/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/path","vs/base/common/errors","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/base/common/types","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/errorMessage","vs/base/common/process","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","os","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","vs/base/parts/ipc/common/ipc","child_process","vs/platform/instantiation/common/descriptors","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","fs","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/map","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Y=function(z){for(var t=[],L=0,P=z.length;L<P;L++)t[L]=J[z[L]];return t};define(J[56],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function L(P,I){if(!P)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}t.ok=L}),define(J[46],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function L(T){return(w,c,g)=>{let p=null,D=null;if(typeof g.value=="function"?(p="value",D=g.value):typeof g.get=="function"&&(p="get",D=g.get),!D)throw new Error("not supported");g[p]=T(D,c)}}t.createDecorator=L;function P(T,w,c){let g=null,p=null;if(typeof c.value=="function"?(g="value",p=c.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(g="get",p=c.get),!p)throw new Error("not supported");const D=`$memoize$${w}`;c[g]=function(...f){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,f)}),this[D]}}t.memoize=P;function I(T,w,c){return L((g,p)=>{const D=`$debounce$${p}`,f=`$debounce$result$${p}`;return function(...E){this[f]||(this[f]=c?c():void 0),clearTimeout(this[D]),w&&(this[f]=w(this[f],...E),E=[this[f]]),this[D]=setTimeout(()=>{g.apply(this,E),this[f]=c?c():void 0},T)}})}t.debounce=I;function C(T,w,c){return L((g,p)=>{const D=`$throttle$timer$${p}`,f=`$throttle$result$${p}`,E=`$throttle$lastRun$${p}`,l=`$throttle$pending$${p}`;return function(...h){if(this[f]||(this[f]=c?c():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),w&&(this[f]=w(this[f],...h)),this[l])return;const v=this[E]+T;v<=Date.now()?(this[E]=Date.now(),g.apply(this,[this[f]]),this[f]=c?c():void 0):(this[l]=!0,this[D]=setTimeout(()=>{this[l]=!1,this[E]=Date.now(),g.apply(this,[this[f]]),this[f]=c?c():void 0},v-Date.now()))}})}t.throttle=C}),define(J[57],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var L;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(L=t.ScanError||(t.ScanError={}));var P;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(P=t.SyntaxKind||(t.SyntaxKind={}));var I;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(I=t.ParseErrorCode||(t.ParseErrorCode={}));var C;(function(e){e.DEFAULT={allowTrailingComma:!0}})(C=t.ParseOptions||(t.ParseOptions={}));function T(e,r=!1){let i=0,n=e.length,o="",d=0,S=16,R=0;function b(re){let fe=0,B=0;for(;fe<re;){const q=e.charCodeAt(i);if(q>=48&&q<=57)B=B*16+q-48;else if(q>=65&&q<=70)B=B*16+q-65+10;else if(q>=97&&q<=102)B=B*16+q-97+10;else break;i++,fe++}return fe<re&&(B=-1),B}function O(re){i=re,o="",d=0,S=16,R=0}function M(){const re=i;if(e.charCodeAt(i)===48)i++;else for(i++;i<e.length&&g(e.charCodeAt(i));)i++;if(i<e.length&&e.charCodeAt(i)===46)if(i++,i<e.length&&g(e.charCodeAt(i)))for(i++;i<e.length&&g(e.charCodeAt(i));)i++;else return R=3,e.substring(re,i);let fe=i;if(i<e.length&&(e.charCodeAt(i)===69||e.charCodeAt(i)===101))if(i++,(i<e.length&&e.charCodeAt(i)===43||e.charCodeAt(i)===45)&&i++,i<e.length&&g(e.charCodeAt(i))){for(i++;i<e.length&&g(e.charCodeAt(i));)i++;fe=i}else R=3;return e.substring(re,fe)}function G(){let re="",fe=i;for(;;){if(i>=n){re+=e.substring(fe,i),R=2;break}const B=e.charCodeAt(i);if(B===34){re+=e.substring(fe,i),i++;break}if(B===92){if(re+=e.substring(fe,i),i++,i>=n){R=2;break}switch(e.charCodeAt(i++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:const ne=b(4);ne>=0?re+=String.fromCharCode(ne):R=4;break;default:R=5}fe=i;continue}if(B>=0&&B<=31)if(c(B)){re+=e.substring(fe,i),R=2;break}else R=6;i++}return re}function ee(){if(o="",R=0,d=i,i>=n)return d=n,S=17;let re=e.charCodeAt(i);if(w(re)){do i++,o+=String.fromCharCode(re),re=e.charCodeAt(i);while(w(re));return S=15}if(c(re))return i++,o+=String.fromCharCode(re),re===13&&e.charCodeAt(i)===10&&(i++,o+=`
`),S=14;switch(re){case 123:return i++,S=1;case 125:return i++,S=2;case 91:return i++,S=3;case 93:return i++,S=4;case 58:return i++,S=6;case 44:return i++,S=5;case 34:return i++,o=G(),S=10;case 47:const fe=i-1;if(e.charCodeAt(i+1)===47){for(i+=2;i<n&&!c(e.charCodeAt(i));)i++;return o=e.substring(fe,i),S=12}if(e.charCodeAt(i+1)===42){i+=2;const B=n-1;let q=!1;for(;i<B;){if(e.charCodeAt(i)===42&&e.charCodeAt(i+1)===47){i+=2,q=!0;break}i++}return q||(i++,R=1),o=e.substring(fe,i),S=13}return o+=String.fromCharCode(re),i++,S=16;case 45:if(o+=String.fromCharCode(re),i++,i===n||!g(e.charCodeAt(i)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=M(),S=11;default:for(;i<n&&ce(re);)i++,re=e.charCodeAt(i);if(d!==i){switch(o=e.substring(d,i),o){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return o+=String.fromCharCode(re),i++,S=16}}function ce(re){if(w(re)||c(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let re;do re=ee();while(re>=12&&re<=15);return re}return{setPosition:O,getPosition:()=>i,scan:r?le:ee,getToken:()=>S,getTokenValue:()=>o,getTokenOffset:()=>d,getTokenLength:()=>i-d,getTokenError:()=>R}}t.createScanner=T;function w(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function g(e){return e>=48&&e<=57}var p;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(p||(p={}));function D(e,r){const i=[],n=new Object;let o;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function R(b,O,M,G){d.value=b,d.offset=O,d.length=M,d.type=G,d.colonOffset=void 0,o=d}try{u(e,{onObjectBegin:(b,O)=>{if(r<=b)throw n;o=void 0,S=r>b,i.push("")},onObjectProperty:(b,O,M)=>{if(r<O||(R(b,O,M,"property"),i[i.length-1]=b,r<=O+M))throw n},onObjectEnd:(b,O)=>{if(r<=b)throw n;o=void 0,i.pop()},onArrayBegin:(b,O)=>{if(r<=b)throw n;o=void 0,i.push(0)},onArrayEnd:(b,O)=>{if(r<=b)throw n;o=void 0,i.pop()},onLiteralValue:(b,O,M)=>{if(r<O||(R(b,O,M,a(b)),r<=O+M))throw n},onSeparator:(b,O,M)=>{if(r<=O)throw n;if(b===":"&&o&&o.type==="property")o.colonOffset=O,S=!1,o=void 0;else if(b===","){const G=i[i.length-1];typeof G=="number"?i[i.length-1]=G+1:(S=!0,i[i.length-1]=""),o=void 0}}})}catch(b){if(b!==n)throw b}return{path:i,previousNode:o,isAtPropertyKey:S,matches:b=>{let O=0;for(let M=0;O<b.length&&M<i.length;M++)if(b[O]===i[M]||b[O]==="*")O++;else if(b[O]!=="**")return!1;return O===b.length}}}t.getLocation=D;function f(e,r=[],i=C.DEFAULT){let n=null,o=[];const d=[];function S(b){Array.isArray(o)?o.push(b):n!==null&&(o[n]=b)}return u(e,{onObjectBegin:()=>{const b={};S(b),d.push(o),o=b,n=null},onObjectProperty:b=>{n=b},onObjectEnd:()=>{o=d.pop()},onArrayBegin:()=>{const b=[];S(b),d.push(o),o=b,n=null},onArrayEnd:()=>{o=d.pop()},onLiteralValue:S,onError:(b,O,M)=>{r.push({error:b,offset:O,length:M})}},i),o[0]}t.parse=f;function E(e,r=[],i=C.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(b){n.type==="property"&&(n.length=b-n.offset,n=n.parent)}function d(b){return n.children.push(b),b}u(e,{onObjectBegin:b=>{n=d({type:"object",offset:b,length:-1,parent:n,children:[]})},onObjectProperty:(b,O,M)=>{n=d({type:"property",offset:O,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:b,offset:O,length:M,parent:n})},onObjectEnd:(b,O)=>{n.length=b+O-n.offset,n=n.parent,o(b+O)},onArrayBegin:(b,O)=>{n=d({type:"array",offset:b,length:-1,parent:n,children:[]})},onArrayEnd:(b,O)=>{n.length=b+O-n.offset,n=n.parent,o(b+O)},onLiteralValue:(b,O,M)=>{d({type:a(b),offset:O,length:M,parent:n,value:b}),o(O+M)},onSeparator:(b,O,M)=>{n.type==="property"&&(b===":"?n.colonOffset=O:b===","&&o(O))},onError:(b,O,M)=>{r.push({error:b,offset:O,length:M})}},i);const R=n.children[0];return R&&delete R.parent,R}t.parseTree=E;function l(e,r){if(!e)return;let i=e;for(let n of r)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const d of i.children)if(Array.isArray(d.children)&&d.children[0].value===n){i=d.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}t.findNodeAtLocation=l;function h(e){if(!e.parent||!e.parent.children)return[];const r=h(e.parent);if(e.parent.type==="property"){const i=e.parent.children[0].value;r.push(i)}else if(e.parent.type==="array"){const i=e.parent.children.indexOf(e);i!==-1&&r.push(i)}return r}t.getNodePath=h;function v(e){switch(e.type){case"array":return e.children.map(v);case"object":const r=Object.create(null);for(let i of e.children){const n=i.children[1];n&&(r[i.children[0].value]=v(n))}return r;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=v;function m(e,r,i=!1){return r>=e.offset&&r<e.offset+e.length||i&&r===e.offset+e.length}t.contains=m;function y(e,r,i=!1){if(m(e,r,i)){const n=e.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const d=y(n[o],r,i);if(d)return d}return e}}t.findNodeAtOffset=y;function u(e,r,i=C.DEFAULT){const n=T(e,!1);function o(X){return X?()=>X(n.getTokenOffset(),n.getTokenLength()):()=>!0}function d(X){return X?Z=>X(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const S=o(r.onObjectBegin),R=d(r.onObjectProperty),b=o(r.onObjectEnd),O=o(r.onArrayBegin),M=o(r.onArrayEnd),G=d(r.onLiteralValue),ee=d(r.onSeparator),ce=o(r.onComment),le=d(r.onError),re=i&&i.disallowComments,fe=i&&i.allowTrailingComma;function B(){for(;;){const X=n.scan();switch(n.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:re||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(X){case 12:case 13:re?q(10):ce();break;case 16:q(1);break;case 15:case 14:break;default:return X}}}function q(X,Z=[],_=[]){if(le(X),Z.length+_.length>0){let N=n.getToken();for(;N!==17;){if(Z.indexOf(N)!==-1){B();break}else if(_.indexOf(N)!==-1)break;N=B()}}}function ne(X){const Z=n.getTokenValue();return X?G(Z):R(Z),B(),!0}function U(){switch(n.getToken()){case 11:let X=0;try{X=JSON.parse(n.getTokenValue()),typeof X!="number"&&(q(2),X=0)}catch(Z){q(2)}G(X);break;case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return B(),!0}function k(){return n.getToken()!==10?(q(3,[],[2,5]),!1):(ne(!1),n.getToken()===6?(ee(":"),B(),te()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function j(){S(),B();let X=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(X||q(4,[],[]),ee(","),B(),n.getToken()===2&&fe)break}else X&&q(6,[],[]);k()||q(4,[],[2,5]),X=!0}return b(),n.getToken()!==2?q(7,[2],[]):B(),!0}function H(){O(),B();let X=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(X||q(4,[],[]),ee(","),B(),n.getToken()===4&&fe)break}else X&&q(6,[],[]);te()||q(4,[],[4,5]),X=!0}return M(),n.getToken()!==4?q(8,[4],[]):B(),!0}function te(){switch(n.getToken()){case 3:return H();case 1:return j();case 10:return ne(!0);default:return U()}}return B(),n.getToken()===17?i.allowEmptyContent?!0:(q(4,[],[]),!1):te()?(n.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}t.visit=u;function s(e,r){let i=T(e),n=[],o,d=0,S;do switch(S=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:d!==S&&n.push(e.substring(d,S)),r!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,r)),d=i.getPosition();break}while(o!==17);return n.join("")}t.stripComments=s;function a(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=a}),function(){function z(I){const C=[];typeof I=="number"&&C.push("code/timeOrigin",I);function T(c){C.push(c,Date.now())}function w(){const c=[];for(let g=0;g<C.length;g+=2)c.push({name:C[g],startTime:C[g+1]});return c}return{mark:T,getMarks:w}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const T of performance.getEntriesByType("mark"))C.push({name:T.name,startTime:Math.round(I+T.startTime)});return C}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function L(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=t()),I.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=L(P))}(),define(J[58],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var L;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(L=t.Source||(t.Source={}));var P;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(P=t.TerminateResponseCode||(t.TerminateResponseCode={}));function I(C,...T){const w=T.reduce((p,D)=>(p[D]=!0,p),{}),c=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(p=>!w[p]).forEach(p=>{for(let D=0;D<c.length;D++)if(p.search(c[D])!==-1){delete C[p];break}})}t.sanitizeProcessEnvironment=I}),function(z,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var L=t();for(var P in L)(typeof exports=="object"?exports:z)[P]=L[P]}}(typeof self!="undefined"?self:this,function(){return function(z){var t={};function L(P){if(t[P])return t[P].exports;var I=t[P]={i:P,l:!1,exports:{}};return z[P].call(I.exports,I,I.exports,L),I.l=!0,I.exports}return L.m=z,L.c=t,L.d=function(P,I,C){L.o(P,I)||Object.defineProperty(P,I,{enumerable:!0,get:C})},L.r=function(P){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},L.t=function(P,I){if(1&I&&(P=L(P)),8&I||4&I&&typeof P=="object"&&P&&P.__esModule)return P;var C=Object.create(null);if(L.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:P}),2&I&&typeof P!="string")for(var T in P)L.d(C,T,function(w){return P[w]}.bind(null,T));return C},L.n=function(P){var I=P&&P.__esModule?function(){return P.default}:function(){return P};return L.d(I,"a",I),I},L.o=function(P,I){return Object.prototype.hasOwnProperty.call(P,I)},L.p="",L(L.s=0)}([function(z,t,L){(function(P){var I;t=z.exports=_,I=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var C=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,w=t.re=[],c=t.src=[],g=0,p=g++;c[p]="0|[1-9]\\d*";var D=g++;c[D]="[0-9]+";var f=g++;c[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=g++;c[E]="("+c[p]+")\\.("+c[p]+")\\.("+c[p]+")";var l=g++;c[l]="("+c[D]+")\\.("+c[D]+")\\.("+c[D]+")";var h=g++;c[h]="(?:"+c[p]+"|"+c[f]+")";var v=g++;c[v]="(?:"+c[D]+"|"+c[f]+")";var m=g++;c[m]="(?:-("+c[h]+"(?:\\."+c[h]+")*))";var y=g++;c[y]="(?:-?("+c[v]+"(?:\\."+c[v]+")*))";var u=g++;c[u]="[0-9A-Za-z-]+";var s=g++;c[s]="(?:\\+("+c[u]+"(?:\\."+c[u]+")*))";var a=g++,e="v?"+c[E]+c[m]+"?"+c[s]+"?";c[a]="^"+e+"$";var r="[v=\\s]*"+c[l]+c[y]+"?"+c[s]+"?",i=g++;c[i]="^"+r+"$";var n=g++;c[n]="((?:<|>)?=?)";var o=g++;c[o]=c[D]+"|x|X|\\*";var d=g++;c[d]=c[p]+"|x|X|\\*";var S=g++;c[S]="[v=\\s]*("+c[d]+")(?:\\.("+c[d]+")(?:\\.("+c[d]+")(?:"+c[m]+")?"+c[s]+"?)?)?";var R=g++;c[R]="[v=\\s]*("+c[o]+")(?:\\.("+c[o]+")(?:\\.("+c[o]+")(?:"+c[y]+")?"+c[s]+"?)?)?";var b=g++;c[b]="^"+c[n]+"\\s*"+c[S]+"$";var O=g++;c[O]="^"+c[n]+"\\s*"+c[R]+"$";var M=g++;c[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var G=g++;c[G]="(?:~>?)";var ee=g++;c[ee]="(\\s*)"+c[G]+"\\s+",w[ee]=new RegExp(c[ee],"g");var ce=g++;c[ce]="^"+c[G]+c[S]+"$";var le=g++;c[le]="^"+c[G]+c[R]+"$";var re=g++;c[re]="(?:\\^)";var fe=g++;c[fe]="(\\s*)"+c[re]+"\\s+",w[fe]=new RegExp(c[fe],"g");var B=g++;c[B]="^"+c[re]+c[S]+"$";var q=g++;c[q]="^"+c[re]+c[R]+"$";var ne=g++;c[ne]="^"+c[n]+"\\s*("+r+")$|^$";var U=g++;c[U]="^"+c[n]+"\\s*("+e+")$|^$";var k=g++;c[k]="(\\s*)"+c[n]+"\\s*("+r+"|"+c[S]+")",w[k]=new RegExp(c[k],"g");var j=g++;c[j]="^\\s*("+c[S]+")\\s+-\\s+("+c[S]+")\\s*$";var H=g++;c[H]="^\\s*("+c[R]+")\\s+-\\s+("+c[R]+")\\s*$";var te=g++;c[te]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)I(X,c[X]),w[X]||(w[X]=new RegExp(c[X]));function Z(F,V){if(F instanceof _)return F;if(typeof F!="string"||F.length>C||!(V?w[i]:w[a]).test(F))return null;try{return new _(F,V)}catch($){return null}}function _(F,V){if(F instanceof _){if(F.loose===V)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof _))return new _(F,V);I("SemVer",F,V),this.loose=V;var $=F.trim().match(V?w[i]:w[a]);if(!$)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(ae){if(/^[0-9]+$/.test(ae)){var he=+ae;if(he>=0&&he<T)return he}return ae}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}t.parse=Z,t.valid=function(F,V){var $=Z(F,V);return $?$.version:null},t.clean=function(F,V){var $=Z(F.trim().replace(/^[=v]+/,""),V);return $?$.version:null},t.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(F){return I("SemVer.compare",this.version,this.loose,F),F instanceof _||(F=new _(F,this.loose)),this.compareMain(F)||this.comparePre(F)},_.prototype.compareMain=function(F){return F instanceof _||(F=new _(F,this.loose)),A(this.major,F.major)||A(this.minor,F.minor)||A(this.patch,F.patch)},_.prototype.comparePre=function(F){if(F instanceof _||(F=new _(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var V=0;do{var $=this.prerelease[V],ae=F.prerelease[V];if(I("prerelease compare",V,$,ae),$===void 0&&ae===void 0)return 0;if(ae===void 0)return 1;if($===void 0)return-1;if($!==ae)return A($,ae)}while(++V)},_.prototype.inc=function(F,V){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",V);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",V);break;case"prepatch":this.prerelease.length=0,this.inc("patch",V),this.inc("pre",V);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",V),this.inc("pre",V);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}V&&(this.prerelease[0]===V?isNaN(this.prerelease[1])&&(this.prerelease=[V,0]):this.prerelease=[V,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},t.inc=function(F,V,$,ae){typeof $=="string"&&(ae=$,$=void 0);try{return new _(F,$).inc(V,ae).version}catch(he){return null}},t.diff=function(F,V){if(Q(F,V))return null;var $=Z(F),ae=Z(V);if($.prerelease.length||ae.prerelease.length){for(var he in $)if((he==="major"||he==="minor"||he==="patch")&&$[he]!==ae[he])return"pre"+he;return"prerelease"}for(var he in $)if((he==="major"||he==="minor"||he==="patch")&&$[he]!==ae[he])return he},t.compareIdentifiers=A;var N=/^[0-9]+$/;function A(F,V){var $=N.test(F),ae=N.test(V);return $&&ae&&(F=+F,V=+V),$&&!ae?-1:ae&&!$?1:F<V?-1:F>V?1:0}function W(F,V,$){return new _(F,$).compare(new _(V,$))}function x(F,V,$){return W(F,V,$)>0}function K(F,V,$){return W(F,V,$)<0}function Q(F,V,$){return W(F,V,$)===0}function se(F,V,$){return W(F,V,$)!==0}function ie(F,V,$){return W(F,V,$)>=0}function me(F,V,$){return W(F,V,$)<=0}function ye(F,V,$,ae){var he;switch(V){case"===":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),he=F===$;break;case"!==":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),he=F!==$;break;case"":case"=":case"==":he=Q(F,$,ae);break;case"!=":he=se(F,$,ae);break;case">":he=x(F,$,ae);break;case">=":he=ie(F,$,ae);break;case"<":he=K(F,$,ae);break;case"<=":he=me(F,$,ae);break;default:throw new TypeError("Invalid operator: "+V)}return he}function ue(F,V){if(F instanceof ue){if(F.loose===V)return F;F=F.value}if(!(this instanceof ue))return new ue(F,V);I("comparator",F,V),this.loose=V,this.parse(F),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}t.rcompareIdentifiers=function(F,V){return A(V,F)},t.major=function(F,V){return new _(F,V).major},t.minor=function(F,V){return new _(F,V).minor},t.patch=function(F,V){return new _(F,V).patch},t.compare=W,t.compareLoose=function(F,V){return W(F,V,!0)},t.rcompare=function(F,V,$){return W(V,F,$)},t.sort=function(F,V){return F.sort(function($,ae){return t.compare($,ae,V)})},t.rsort=function(F,V){return F.sort(function($,ae){return t.rcompare($,ae,V)})},t.gt=x,t.lt=K,t.eq=Q,t.neq=se,t.gte=ie,t.lte=me,t.cmp=ye,t.Comparator=ue;var Ie={};function ve(F,V){if(F instanceof ve)return F.loose===V?F:new ve(F.raw,V);if(F instanceof ue)return new ve(F.value,V);if(!(this instanceof ve))return new ve(F,V);if(this.loose=V,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function Ee(F){return!F||F.toLowerCase()==="x"||F==="*"}function Fe(F,V,$,ae,he,Ce,we,Oe,Pe,Re,Ne,De,Te){return((V=Ee($)?"":Ee(ae)?">="+$+".0.0":Ee(he)?">="+$+"."+ae+".0":">="+V)+" "+(Oe=Ee(Pe)?"":Ee(Re)?"<"+(+Pe+1)+".0.0":Ee(Ne)?"<"+Pe+"."+(+Re+1)+".0":De?"<="+Pe+"."+Re+"."+Ne+"-"+De:"<="+Oe)).trim()}function Me(F,V){for(var $=0;$<F.length;$++)if(!F[$].test(V))return!1;if(V.prerelease.length){for($=0;$<F.length;$++)if(I(F[$].semver),F[$].semver!==Ie&&F[$].semver.prerelease.length>0){var ae=F[$].semver;if(ae.major===V.major&&ae.minor===V.minor&&ae.patch===V.patch)return!0}return!1}return!0}function ze(F,V,$){try{V=new ve(V,$)}catch(ae){return!1}return V.test(F)}function xe(F,V,$,ae){var he,Ce,we,Oe,Pe;switch(F=new _(F,ae),V=new ve(V,ae),$){case">":he=x,Ce=me,we=K,Oe=">",Pe=">=";break;case"<":he=K,Ce=ie,we=x,Oe="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(F,V,ae))return!1;for(var Re=0;Re<V.set.length;++Re){var Ne=V.set[Re],De=null,Te=null;if(Ne.forEach(function(ke){ke.semver===Ie&&(ke=new ue(">=0.0.0")),De=De||ke,Te=Te||ke,he(ke.semver,De.semver,ae)?De=ke:we(ke.semver,Te.semver,ae)&&(Te=ke)}),De.operator===Oe||De.operator===Pe||(!Te.operator||Te.operator===Oe)&&Ce(F,Te.semver)||Te.operator===Pe&&we(F,Te.semver))return!1}return!0}ue.prototype.parse=function(F){var V=this.loose?w[ne]:w[U],$=F.match(V);if(!$)throw new TypeError("Invalid comparator: "+F);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new _($[2],this.loose):this.semver=Ie},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(F){return I("Comparator.test",F,this.loose),this.semver===Ie||(typeof F=="string"&&(F=new _(F,this.loose)),ye(F,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(F,V){if(!(F instanceof ue))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new ve(F.value,V),ze(this.value,$,V);if(F.operator==="")return $=new ve(this.value,V),ze(F.semver,$,V);var ae=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),he=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ce=this.semver.version===F.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),Oe=ye(this.semver,"<",F.semver,V)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Pe=ye(this.semver,">",F.semver,V)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return ae||he||Ce&&we||Oe||Pe},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(F){var V=this.loose;F=F.trim(),I("range",F,V);var $=V?w[H]:w[j];F=F.replace($,Fe),I("hyphen replace",F),F=F.replace(w[k],"$1$2$3"),I("comparator trim",F,w[k]),F=(F=(F=F.replace(w[ee],"$1~")).replace(w[fe],"$1^")).split(/\s+/).join(" ");var ae=V?w[ne]:w[U],he=F.split(" ").map(function(Ce){return function(we,Oe){return I("comp",we),we=function(Pe,Re){return Pe.trim().split(/\s+/).map(function(Ne){return function(De,Te){I("caret",De,Te);var ke=Te?w[q]:w[B];return De.replace(ke,function(Ae,ge,pe,Se,be){var Le;return I("caret",De,Ae,ge,pe,Se,be),Ee(ge)?Le="":Ee(pe)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?Le=ge==="0"?">="+ge+"."+pe+".0 <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+".0 <"+(+ge+1)+".0.0":be?(I("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),Le=ge==="0"?pe==="0"?">="+ge+"."+pe+"."+Se+be+" <"+ge+"."+pe+"."+(+Se+1):">="+ge+"."+pe+"."+Se+be+" <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+"."+Se+be+" <"+(+ge+1)+".0.0"):(I("no pr"),Le=ge==="0"?pe==="0"?">="+ge+"."+pe+"."+Se+" <"+ge+"."+pe+"."+(+Se+1):">="+ge+"."+pe+"."+Se+" <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+"."+Se+" <"+(+ge+1)+".0.0"),I("caret return",Le),Le})}(Ne,Re)}).join(" ")}(we,Oe),I("caret",we),we=function(Pe,Re){return Pe.trim().split(/\s+/).map(function(Ne){return function(De,Te){var ke=Te?w[le]:w[ce];return De.replace(ke,function(Ae,ge,pe,Se,be){var Le;return I("tilde",De,Ae,ge,pe,Se,be),Ee(ge)?Le="":Ee(pe)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?Le=">="+ge+"."+pe+".0 <"+ge+"."+(+pe+1)+".0":be?(I("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),Le=">="+ge+"."+pe+"."+Se+be+" <"+ge+"."+(+pe+1)+".0"):Le=">="+ge+"."+pe+"."+Se+" <"+ge+"."+(+pe+1)+".0",I("tilde return",Le),Le})}(Ne,Re)}).join(" ")}(we,Oe),I("tildes",we),we=function(Pe,Re){return I("replaceXRanges",Pe,Re),Pe.split(/\s+/).map(function(Ne){return function(De,Te){De=De.trim();var ke=Te?w[O]:w[b];return De.replace(ke,function(Ae,ge,pe,Se,be,Le){I("xRange",De,Ae,ge,pe,Se,be,Le);var We=Ee(pe),Ve=We||Ee(Se),je=Ve||Ee(be);return ge==="="&&je&&(ge=""),We?Ae=ge===">"||ge==="<"?"<0.0.0":"*":ge&&je?(Ve&&(Se=0),je&&(be=0),ge===">"?(ge=">=",Ve?(pe=+pe+1,Se=0,be=0):je&&(Se=+Se+1,be=0)):ge==="<="&&(ge="<",Ve?pe=+pe+1:Se=+Se+1),Ae=ge+pe+"."+Se+"."+be):Ve?Ae=">="+pe+".0.0 <"+(+pe+1)+".0.0":je&&(Ae=">="+pe+"."+Se+".0 <"+pe+"."+(+Se+1)+".0"),I("xRange return",Ae),Ae})}(Ne,Re)}).join(" ")}(we,Oe),I("xrange",we),we=function(Pe,Re){return I("replaceStars",Pe,Re),Pe.trim().replace(w[te],"")}(we,Oe),I("stars",we),we}(Ce,V)}).join(" ").split(/\s+/);return this.loose&&(he=he.filter(function(Ce){return!!Ce.match(ae)})),he=he.map(function(Ce){return new ue(Ce,V)})},ve.prototype.intersects=function(F,V){if(!(F instanceof ve))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(ae){return F.set.some(function(he){return he.every(function(Ce){return ae.intersects(Ce,V)})})})})},t.toComparators=function(F,V){return new ve(F,V).set.map(function($){return $.map(function(ae){return ae.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new _(F,this.loose));for(var V=0;V<this.set.length;V++)if(Me(this.set[V],F))return!0;return!1},t.satisfies=ze,t.maxSatisfying=function(F,V,$){var ae=null,he=null;try{var Ce=new ve(V,$)}catch(we){return null}return F.forEach(function(we){Ce.test(we)&&(ae&&he.compare(we)!==-1||(he=new _(ae=we,$)))}),ae},t.minSatisfying=function(F,V,$){var ae=null,he=null;try{var Ce=new ve(V,$)}catch(we){return null}return F.forEach(function(we){Ce.test(we)&&(ae&&he.compare(we)!==1||(he=new _(ae=we,$)))}),ae},t.validRange=function(F,V){try{return new ve(F,V).range||"*"}catch($){return null}},t.ltr=function(F,V,$){return xe(F,V,"<",$)},t.gtr=function(F,V,$){return xe(F,V,">",$)},t.outside=xe,t.prerelease=function(F,V){var $=Z(F,V);return $&&$.prerelease.length?$.prerelease:null},t.intersects=function(F,V,$){return F=new ve(F,$),V=new ve(V,$),F.intersects(V)},t.coerce=function(F){if(F instanceof _)return F;if(typeof F!="string")return null;var V=F.match(w[M]);return V==null?null:Z((V[1]||"0")+"."+(V[2]||"0")+"."+(V[3]||"0"))}}).call(this,L(1))},function(z,t){var L,P,I=z.exports={};function C(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function w(v){if(L===setTimeout)return setTimeout(v,0);if((L===C||!L)&&setTimeout)return L=setTimeout,setTimeout(v,0);try{return L(v,0)}catch(m){try{return L.call(null,v,0)}catch(y){return L.call(this,v,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:C}catch(v){L=C}try{P=typeof clearTimeout=="function"?clearTimeout:T}catch(v){P=T}})();var c,g=[],p=!1,D=-1;function f(){p&&c&&(p=!1,c.length?g=c.concat(g):D=-1,g.length&&E())}function E(){if(!p){var v=w(f);p=!0;for(var m=g.length;m;){for(c=g,g=[];++D<m;)c&&c[D].run();D=-1,m=g.length}c=null,p=!1,function(y){if(P===clearTimeout)return clearTimeout(y);if((P===T||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(y);try{P(y)}catch(u){try{return P.call(null,y)}catch(s){return P.call(this,y)}}}(v)}}function l(v,m){this.fun=v,this.array=m}function h(){}I.nextTick=function(v){var m=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)m[y-1]=arguments[y];g.push(new l(v,m)),g.length!==1||p||w(E)},l.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=h,I.addListener=h,I.once=h,I.off=h,I.removeListener=h,I.removeAllListeners=h,I.emit=h,I.prependListener=h,I.prependOnceListener=h,I.listeners=function(v){return[]},I.binding=function(v){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(v){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(J[59],Y([0,1]),function(z,t){"use strict";var L;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class P{constructor(w,c,g){this.level=w,this.key=c,this.value=g,this.forward=[]}}const I=void 0;class C{constructor(w,c=2**16){this.comparator=w,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(c)|0),this._header=new P(this._maxLevel,I,I)}get size(){return this._size}clear(){this._header=new P(this._maxLevel,I,I)}has(w){return Boolean(C._search(this,w,this.comparator))}get(w){return C._search(this,w,this.comparator)?.value}set(w,c){return C._insert(this,w,c,this.comparator)&&(this._size+=1),this}delete(w){const c=C._delete(this,w,this.comparator);return c&&(this._size-=1),c}forEach(w,c){let g=this._header.forward[0];for(;g;)w.call(c,g.value,g.key,this),g=g.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this._header.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this._header.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this._header.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",c=this._header.forward[0];for(;c;)w+=`node(${c.key}, ${c.value}, lvl:${c.level})`,c=c.forward[0];return w}static _search(w,c,g){let p=w._header;for(let D=w._level-1;D>=0;D--)for(;p.forward[D]&&g(p.forward[D].key,c)<0;)p=p.forward[D];if(p=p.forward[0],p&&g(p.key,c)===0)return p}static _insert(w,c,g,p){let D=[],f=w._header;for(let E=w._level-1;E>=0;E--){for(;f.forward[E]&&p(f.forward[E].key,c)<0;)f=f.forward[E];D[E]=f}if(f=f.forward[0],f&&p(f.key,c)===0)return f.value=g,!1;{let E=C._randomLevel(w);if(E>w._level){for(let l=w._level;l<E;l++)D[l]=w._header;w._level=E}f=new P(E,c,g);for(let l=0;l<E;l++)f.forward[l]=D[l].forward[l],D[l].forward[l]=f;return!0}}static _randomLevel(w,c=.5){let g=1;for(;Math.random()<c&&g<w._maxLevel;)g+=1;return g}static _delete(w,c,g){let p=[],D=w._header;for(let f=w._level-1;f>=0;f--){for(;D.forward[f]&&g(D.forward[f].key,c)<0;)D=D.forward[f];p[f]=D}if(D=D.forward[0],!D||g(D.key,c)!==0)return!1;for(let f=0;f<w._level&&p[f].forward[f]===D;f++)p[f].forward[f]=D.forward[f];for(;w._level>0&&w._header.forward[w._level-1]===I;)w._level-=1;return!0}}t.SkipList=C}),define(J[38],Y([0,1,7,2]),function(z,t,L,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function I(u){const s=u;return s?[s.on,s.pause,s.resume,s.destroy].every(a=>typeof a=="function"):!1}t.isReadableStream=I;function C(u){const s=u;return s?I(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}t.isReadableBufferedStream=C;function T(u,s){return new w(u,s)}t.newWriteableStream=T;class w{constructor(s,a){this.reducer=s,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(a=>a(s))}emitError(s){this.listeners.error.length===0?(0,L.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(a=>a(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,a){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(s,a){if(this.state.destroyed)return;let e;switch(s){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const r=e.indexOf(a);r>=0&&e.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(u,s){const a=[];let e;for(;(e=u.read())!==null;)a.push(e);return s(a)}t.consumeReadable=c;function g(u,s,a){const e=[];let r;for(;(r=u.read())!==null&&e.length<a;)e.push(r);return r===null&&e.length>0?s(e):{read:()=>{if(e.length>0)return e.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return u.read()}}}t.peekReadable=g;function p(u,s){return new Promise((a,e)=>{const r=[];D(u,{onData:i=>{s&&r.push(i)},onError:i=>{s?e(i):a(void 0)},onEnd:()=>{a(s?s(r):void 0)}})})}t.consumeStream=p;function D(u,s){u.on("error",a=>s.onError(a)),u.on("end",()=>s.onEnd()),u.on("data",a=>s.onData(a))}t.listenStream=D;function f(u,s){return new Promise((a,e)=>{const r=new P.DisposableStore,i=[],n=S=>{if(i.push(S),i.length>s)return r.dispose(),u.pause(),a({stream:u,buffer:i,ended:!1})},o=S=>e(S),d=()=>a({stream:u,buffer:i,ended:!0});r.add((0,P.toDisposable)(()=>u.removeListener("error",o))),u.on("error",o),r.add((0,P.toDisposable)(()=>u.removeListener("end",d))),u.on("end",d),r.add((0,P.toDisposable)(()=>u.removeListener("data",n))),u.on("data",n)})}t.peekStream=f;function E(u,s){const a=T(s);return a.end(u),a}t.toStream=E;function l(){const u=T(()=>{throw new Error("not supported")});return u.end(),u}t.emptyStream=l;function h(u){let s=!1;return{read:()=>s?null:(s=!0,u)}}t.toReadable=h;function v(u,s,a){const e=T(a);return D(u,{onData:r=>e.write(s.data(r)),onError:r=>e.error(s.error?s.error(r):r),onEnd:()=>e.end()}),e}t.transform=v;function m(u,s,a){let e=!1;return{read:()=>{const r=s.read();return e?r:(e=!0,r!==null?a([u,r]):u)}}}t.prefixedReadable=m;function y(u,s,a){let e=!1;const r=T(a);return D(s,{onData:i=>e?r.write(i):(e=!0,r.write(a([u,i]))),onError:i=>r.error(i),onEnd:()=>{e||(e=!0,r.write(u)),r.end()}}),r}t.prefixedStream=y}),define(J[17],Y([0,1,38]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const P=typeof Buffer!="undefined";let I,C;class T{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return P?new T(Buffer.allocUnsafe(n)):new T(new Uint8Array(n))}static wrap(n){return P&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new T(n)}static fromString(n,o){return!(o?.dontUseNodeBuffer||!1)&&P?new T(Buffer.from(n)):(I||(I=new TextEncoder),new T(I.encode(n)))}static concat(n,o){if(typeof o=="undefined"){o=0;for(let R=0,b=n.length;R<b;R++)o+=n[R].byteLength}const d=T.alloc(o);let S=0;for(let R=0,b=n.length;R<b;R++){const O=n[R];d.set(O,S),S+=O.byteLength}return d}toString(){return P?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(n,o){return new T(this.buffer.subarray(n,o))}set(n,o){n instanceof T?this.buffer.set(n.buffer,o):this.buffer.set(n,o)}readUInt32BE(n){return g(this.buffer,n)}writeUInt32BE(n,o){p(this.buffer,n,o)}readUInt32LE(n){return D(this.buffer,n)}writeUInt32LE(n,o){f(this.buffer,n,o)}readUInt8(n){return E(this.buffer,n)}writeUInt8(n,o){l(this.buffer,n,o)}}t.VSBuffer=T;function w(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0}t.readUInt16LE=w;function c(i,n,o){i[o+0]=n&255,n=n>>>8,i[o+1]=n&255}t.writeUInt16LE=c;function g(i,n){return i[n]*2**24+i[n+1]*2**16+i[n+2]*2**8+i[n+3]}t.readUInt32BE=g;function p(i,n,o){i[o+3]=n,n=n>>>8,i[o+2]=n,n=n>>>8,i[o+1]=n,n=n>>>8,i[o]=n}t.writeUInt32BE=p;function D(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0|i[n+2]<<16>>>0|i[n+3]<<24>>>0}t.readUInt32LE=D;function f(i,n,o){i[o+0]=n&255,n=n>>>8,i[o+1]=n&255,n=n>>>8,i[o+2]=n&255,n=n>>>8,i[o+3]=n&255}t.writeUInt32LE=f;function E(i,n){return i[n]}t.readUInt8=E;function l(i,n,o){i[o]=n}t.writeUInt8=l;function h(i){return L.consumeReadable(i,n=>T.concat(n))}t.readableToBuffer=h;function v(i){return L.toReadable(i)}t.bufferToReadable=v;function m(i){return L.consumeStream(i,n=>T.concat(n))}t.streamToBuffer=m;async function y(i){return i.ended?T.concat(i.buffer):T.concat([...i.buffer,await m(i.stream)])}t.bufferedStreamToBuffer=y;function u(i){return L.toStream(i,n=>T.concat(n))}t.bufferToStream=u;function s(i){return L.transform(i,{data:n=>typeof n=="string"?T.fromString(n):T.wrap(n)},n=>T.concat(n))}t.streamToBufferReadableStream=s;function a(i){return L.newWriteableStream(n=>T.concat(n),i)}t.newWriteableBufferStream=a;function e(i,n){return L.prefixedReadable(i,n,o=>T.concat(o))}t.prefixedBufferReadable=e;function r(i,n){return L.prefixedStream(i,n,o=>T.concat(o))}t.prefixedBufferStream=r}),define(J[18],Y([0,1,11]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function P(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const v=Array.isArray(h)?[]:{};return Object.keys(h).forEach(m=>{h[m]&&typeof h[m]=="object"?v[m]=P(h[m]):v[m]=h[m]}),v}t.deepClone=P;function I(h){if(!h||typeof h!="object")return h;const v=[h];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const y in m)if(C.call(m,y)){const u=m[y];typeof u=="object"&&!Object.isFrozen(u)&&v.push(u)}}return h}t.deepFreeze=I;const C=Object.prototype.hasOwnProperty;function T(h,v){return w(h,v,new Set)}t.cloneAndChange=T;function w(h,v,m){if((0,L.isUndefinedOrNull)(h))return h;const y=v(h);if(typeof y!="undefined")return y;if((0,L.isArray)(h)){const u=[];for(const s of h)u.push(w(s,v,m));return u}if((0,L.isObject)(h)){if(m.has(h))throw new Error("Cannot clone recursive data-structure");m.add(h);const u={};for(let s in h)C.call(h,s)&&(u[s]=w(h[s],v,m));return m.delete(h),u}return h}function c(h,v,m=!0){return(0,L.isObject)(h)?((0,L.isObject)(v)&&Object.keys(v).forEach(y=>{y in h?m&&((0,L.isObject)(h[y])&&(0,L.isObject)(v[y])?c(h[y],v[y],m):h[y]=v[y]):h[y]=v[y]}),h):v}t.mixin=c;function g(h,v){if(h===v)return!0;if(h==null||v===null||v===void 0||typeof h!=typeof v||typeof h!="object"||Array.isArray(h)!==Array.isArray(v))return!1;let m,y;if(Array.isArray(h)){if(h.length!==v.length)return!1;for(m=0;m<h.length;m++)if(!g(h[m],v[m]))return!1}else{const u=[];for(y in h)u.push(y);u.sort();const s=[];for(y in v)s.push(y);if(s.sort(),!g(u,s))return!1;for(m=0;m<u.length;m++)if(!g(h[u[m]],v[u[m]]))return!1}return!0}t.equals=g;function p(h){const v=new Set;return JSON.stringify(h,(m,y)=>{if((0,L.isObject)(y)||Array.isArray(y)){if(v.has(y))return"[Circular]";v.add(y)}return y})}t.safeStringify=p;function D(h,v,m){const y=v(h);return typeof y=="undefined"?m:y}t.getOrDefault=D;function f(h,v){const m=Object.create(null);return!h||!v||Object.keys(v).forEach(u=>{const s=h[u],a=v[u];g(s,a)||(m[u]=a)}),m}t.distinct=f;function E(h,v){const m=v.toLowerCase(),y=Object.keys(h).find(u=>u.toLowerCase()===m);return y?h[y]:h[v]}t.getCaseInsensitive=E;function l(h,v){const m=Object.create(null);for(const[y,u]of Object.entries(h))v(y,u)&&(m[y]=u);return m}t.filter=l}),define(J[60],Y([0,1,8]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function P(g){const p=g;return p&&typeof p.type=="string"&&typeof p.severity=="string"}t.isRemoteConsoleLog=P;function I(g){const p=[];let D;try{const f=JSON.parse(g.arguments),E=f[f.length-1];E&&E.__$stack&&(f.pop(),D=E.__$stack),p.push(...f)}catch(f){p.push("Unable to log remote console arguments",g.arguments)}return{args:p,stack:D}}t.parse=I;function C(g){if(typeof g!="string")return C(I(g).stack);const p=g;if(p){const D=T(p),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(D||"");if(f&&f.length===4)return{uri:L.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}t.getFirstFrame=C;function T(g){if(!g)return g;const p=g.indexOf(`
`);return p===-1?g:g.substring(0,p)}function w(g,p){const{args:D,stack:f}=I(g),E=typeof D[0]=="string"&&D.length===1;let l=T(f);l&&(l=`(${l.trim()})`);let h=[];if(typeof D[0]=="string"?l&&E?h=[`%c[${p}] %c${D[0]} %c${l}`,c("blue"),c(""),c("grey")]:h=[`%c[${p}] %c${D[0]}`,c("blue"),c(""),...D.slice(1)]:h=[`%c[${p}]%`,c("blue"),...D],l&&!E&&h.push(l),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,h)}t.log=w;function c(g){return`color: ${g}`}}),define(J[61],Y([0,1,17,27,8]),function(z,t,L,P,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function C(p){return JSON.stringify(p,c)}t.stringify=C;function T(p){let D=JSON.parse(p);return D=g(D),D}t.parse=T;var w;(function(p){p[p.Uri=1]="Uri",p[p.Regexp=2]="Regexp",p[p.ScmResource=3]="ScmResource",p[p.ScmResourceGroup=4]="ScmResourceGroup",p[p.ScmProvider=5]="ScmProvider",p[p.CommentController=6]="CommentController",p[p.CommentThread=7]="CommentThread",p[p.CommentThreadReply=8]="CommentThreadReply",p[p.CommentNode=9]="CommentNode",p[p.CommentThreadNode=10]="CommentThreadNode",p[p.TimelineActionContext=11]="TimelineActionContext",p[p.NotebookCellActionContext=12]="NotebookCellActionContext",p[p.TestItemContext=13]="TestItemContext"})(w=t.MarshalledId||(t.MarshalledId={}));function c(p,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,P.regExpFlags)(D)}:D}function g(p,D=0){if(!p||D>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return I.URI.revive(p);case 2:return new RegExp(p.source,p.flags)}if(p instanceof L.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let f=0;f<p.length;++f)p[f]=g(p[f],D+1);else for(const f in p)Object.hasOwnProperty.call(p,f)&&(p[f]=g(p[f],D+1))}return p}t.revive=g}),define(J[62],Y([0,1,47,9,6,12,19,27,8]),function(z,t,L,P,I,C,T,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function g(n,o,d){if(typeof n=="string"&&(n=c.URI.file(n)),d){const R=d.getWorkspaceFolder(n);if(R){const b=d.getWorkspace().folders.length>1;let O;if((0,T.isEqual)(R.uri,n)?O="":O=(0,T.relativePath)(R.uri,n),b){const M=R.name?R.name:(0,T.basename)(R.uri);O=O?M+" \u2022 "+O:M}return O}}if(n.scheme!==P.Schemas.file&&n.scheme!==P.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,L.hasDriveLetter)(n.fsPath))return(0,I.normalize)(D(n.fsPath));let S=(0,I.normalize)(n.fsPath);return!C.isWindows&&o?.userHome&&(S=E(S,o.userHome.fsPath)),S}t.getPathLabel=g;function p(n){if(!n)return;typeof n=="string"&&(n=c.URI.file(n));const o=(0,T.basename)(n)||(n.scheme===P.Schemas.file?n.fsPath:n.path);return C.isWindows&&(0,L.isRootOrDriveLetter)(o)?D(o):o}t.getBaseLabel=p;function D(n,o){return(0,L.hasDriveLetter)(n,o)?n.charAt(0).toUpperCase()+n.slice(1):n}t.normalizeDriveLetter=D;let f=Object.create(null);function E(n,o){if(C.isWindows||!n||!o)return n;let d=f.original===o?f.normalized:void 0;return d||(d=`${(0,w.rtrim)(o,I.posix.sep)}${I.posix.sep}`,f={original:o,normalized:d}),(C.isLinux?n.startsWith(d):(0,w.startsWithIgnoreCase)(n,d))&&(n=`~/${n.substr(d.length)}`),n}t.tildify=E;function l(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}t.untildify=l;const h="\u2026",v="\\\\",m="~";function y(n,o=I.sep){const d=new Array(n.length);let S=!1;for(let R=0;R<n.length;R++){let b=n[R];if(b===""){d[R]=`.${o}`;continue}if(!b){d[R]=b;continue}S=!0;let O="";b.indexOf(v)===0?(O=b.substr(0,b.indexOf(v)+v.length),b=b.substr(b.indexOf(v)+v.length)):b.indexOf(o)===0?(O=b.substr(0,b.indexOf(o)+o.length),b=b.substr(b.indexOf(o)+o.length)):b.indexOf(m)===0&&(O=b.substr(0,b.indexOf(m)+m.length),b=b.substr(b.indexOf(m)+m.length));const M=b.split(o);for(let G=1;S&&G<=M.length;G++)for(let ee=M.length-G;S&&ee>=0;ee--){S=!1;let ce=M.slice(ee,ee+G).join(o);for(let le=0;!S&&le<n.length;le++)if(le!==R&&n[le]&&n[le].indexOf(ce)>-1){const re=ee+G===M.length,fe=ee>0&&n[le].indexOf(o)>-1?o+ce:ce,B=n[le].endsWith(fe);S=!re||B}if(!S){let le="";(M[0].endsWith(":")||O!=="")&&(ee===1&&(ee=0,G++,ce=M[0]+o+ce),ee>0&&(le=M[0]+o),le=O+le),ee>0&&(le=le+h+o),le=le+ce,ee+G<M.length&&(le=le+o+h),d[R]=le}}S&&(d[R]=b)}return d}t.shorten=y;var u;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function s(n,o=Object.create(null)){const d=[];let S=!1,R="";for(const b of n)if(b==="$"||S&&b==="{")R&&d.push({value:R,type:u.TEXT}),R="",S=!0;else if(b==="}"&&S){const O=o[R];if(typeof O=="string")O.length&&d.push({value:O,type:u.VARIABLE});else if(O){const M=d[d.length-1];(!M||M.type!==u.SEPARATOR)&&d.push({value:O.label,type:u.SEPARATOR})}R="",S=!1}else R+=b;return R&&!S&&d.push({value:R,type:u.TEXT}),d.filter((b,O)=>{if(b.type===u.SEPARATOR){const M=d[O-1],G=d[O+1];return[M,G].every(ee=>ee&&(ee.type===u.VARIABLE||ee.type===u.TEXT)&&ee.value.length>0)}return!0}).map(b=>b.value).join("")}t.template=s;function a(n,o){return C.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):n.replace(/&&|&/g,d=>d==="&"?"&&":"&")}t.mnemonicMenuLabel=a;function e(n,o){return C.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):C.isWindows?n.replace(/&&|&/g,d=>d==="&"?"&&":"&"):n.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function r(n){return n.replace(/&/g,"&&")}t.unmnemonicLabel=r;function i(n){const o=n.indexOf("/")!==-1?I.posix:I.win32,d=o.basename(n),S=o.dirname(n);return d.length?{name:d,parentPath:S}:{name:S,parentPath:""}}t.splitName=i}),define(J[63],Y([0,1,131]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class P{constructor(C="utf8"){this.stringDecoder=new L.StringDecoder(C),this.remaining=null}write(C){const T=[],w=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(w.length<1)return T;let c=0,g,p=c;for(;p<w.length;)if(g=w.charCodeAt(p),g===13||g===10){if(T.push(w.substring(c,p)),p++,p<w.length){const D=g;g=w.charCodeAt(p),(D===13&&g===10||D===10&&g===13)&&p++}c=p}else p++;return this.remaining=c<w.length?w.substr(c):null,T}end(){return this.remaining}}t.LineDecoder=P}),define(J[64],Y([0,1,48,6,27,13]),function(z,t,L,P,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function T(p){const D=(0,P.dirname)(p);if(p===D)return p;const f=((0,P.basename)(p)||p).toLowerCase();try{const l=(0,C.readdirSync)(D).filter(h=>h.toLowerCase()===f);if(l.length===1){const h=T(D);if(h)return(0,P.join)(h,l[0])}else if(l.length>1){const h=l.indexOf(f);if(h>=0){const v=T(D);if(v)return(0,P.join)(v,l[h])}}}catch(E){}return null}t.realcaseSync=T;async function w(p){try{return await C.Promises.realpath(p)}catch(D){const f=g(p);return await C.Promises.access(f,L.constants.R_OK),f}}t.realpath=w;function c(p){try{return L.realpathSync(p)}catch(D){const f=g(p);return L.accessSync(f,L.constants.R_OK),f}}t.realpathSync=c;function g(p){return(0,I.rtrim)((0,P.normalize)(p),P.sep)}}),define(J[65],Y([0,1,34,6,13]),function(z,t,L,P,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,T=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var c;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(c||(c={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class D{constructor(a,e,r){this.exePath=a,this.displayName=e,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await I.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:s=!1}={}){return s?g===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:s=!1,findPreview:a=!1}={}){const e=f({useAlternateBitness:s});if(!e)return null;const r=P.join(e,"PowerShell");if(!await I.SymlinkSupport.existsDirectory(r))return null;let i=-1,n=null;for(const S of await I.Promises.readdir(r)){let R=-1;if(a){const O=S.indexOf("-");if(O<0)continue;const M=S.substring(0,O);if(!C.test(M)||S.substring(O+1)!=="preview")continue;R=parseInt(M,10)}else{if(!C.test(S))continue;R=parseInt(S,10)}if(R<=i)continue;const b=P.join(r,S,"pwsh.exe");!await I.SymlinkSupport.existsFile(b)||(n=b,i=R)}if(!n)return null;const o=e.includes("x86")?" (x86)":"",d=a?" Preview":"";return new D(n,`PowerShell${d}${o}`,!0)}async function l({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const a=P.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await I.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:e,pwshMsixName:r}=s?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await I.Promises.readdir(a))if(e.test(i)){const n=P.join(a,i,"pwsh.exe");return new D(n,r)}return null}function h(){const s=P.join(L.homedir(),".dotnet","tools","pwsh.exe");return new D(s,".NET Core PowerShell Global Tool")}function v(){const s=P.join(process.env.windir,g===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new D(s,"Windows PowerShell",!0)}async function*m(){let s=await E();s&&(yield s),s=await E({useAlternateBitness:!0}),s&&(yield s),s=await l(),s&&(yield s),s=h(),s&&(yield s),s=await E({findPreview:!0}),s&&(yield s),s=await l({findPreview:!0}),s&&(yield s),s=await E({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=v(),s&&(yield s)}async function*y(){for await(const s of m())await s.exists()&&(yield s)}t.enumeratePowerShellInstallations=y;async function u(){for await(const s of y())return s;return null}t.getFirstAvailablePowerShellInstallation=u});var de=this&&this.__decorate||function(z,t,L,P){var I=arguments.length,C=I<3?t:P===null?P=Object.getOwnPropertyDescriptor(t,L):P,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(z,t,L,P);else for(var w=z.length-1;w>=0;w--)(T=z[w])&&(C=(I<3?T(C):I>3?T(t,L,C):T(t,L))||C);return I>3&&C&&Object.defineProperty(t,L,C),C};define(J[39],Y([0,1,20,3,17,24,46,7,10,2,61,27,11]),function(z,t,L,P,I,C,T,w,c,g,p,D,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var E;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(E=t.RequestType||(t.RequestType={}));function l(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(h=t.ResponseType||(t.ResponseType={}));function v(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(m||(m={}));class y{constructor(k){this.buffer=k,this.pos=0}read(k){const j=this.buffer.slice(this.pos,this.pos+k);return this.pos+=j.byteLength,j}}class u{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var s;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(s||(s={}));function a(U){const k=I.VSBuffer.alloc(4);return k.writeUInt32BE(U,0),k}function e(U){return U.read(4).readUInt32BE(0)}function r(U){const k=I.VSBuffer.alloc(1);return k.writeUInt8(U,0),k}const i={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object)},n=typeof Buffer!="undefined";function o(U,k){if(typeof k=="undefined")U.write(i.Undefined);else if(typeof k=="string"){const j=I.VSBuffer.fromString(k);U.write(i.String),U.write(a(j.byteLength)),U.write(j)}else if(n&&Buffer.isBuffer(k)){const j=I.VSBuffer.wrap(k);U.write(i.Buffer),U.write(a(j.byteLength)),U.write(j)}else if(k instanceof I.VSBuffer)U.write(i.VSBuffer),U.write(a(k.byteLength)),U.write(k);else if(Array.isArray(k)){U.write(i.Array),U.write(a(k.length));for(const j of k)o(U,j)}else{const j=I.VSBuffer.fromString(JSON.stringify(k));U.write(i.Object),U.write(a(j.byteLength)),U.write(j)}}function d(U){switch(U.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return U.read(e(U)).toString();case s.Buffer:return U.read(e(U)).buffer;case s.VSBuffer:return U.read(e(U));case s.Array:{const j=e(U),H=[];for(let te=0;te<j;te++)H.push(d(U));return H}case s.Object:return JSON.parse(U.read(e(U)).toString())}}class S{constructor(k,j,H=null,te=1e3){this.protocol=k,this.ctx=j,this.logger=H,this.timeoutDelay=te,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(k,j){this.channels.set(k,j),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const j=this.send([k.type]);this.logger&&this.logger.logOutgoing(j,0,1,v(k.type));return}case 201:case 202:case 204:case 203:{const j=this.send([k.type,k.id],k.data);this.logger&&this.logger.logOutgoing(j,k.id,1,v(k.type),k.data);return}}}send(k,j=void 0){const H=new u;return o(H,k),o(H,j),this.sendBuffer(H.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(j){return 0}}onRawMessage(k){const j=new y(k),H=d(j),te=d(j),X=H[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${l(X)}: ${H[2]}.${H[3]}`,te),this.onPromise({type:X,id:H[1],channelName:H[2],name:H[3],arg:te});case 102:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${l(X)}: ${H[2]}.${H[3]}`,te),this.onEventListen({type:X,id:H[1],channelName:H[2],name:H[3],arg:te});case 101:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${l(X)}`),this.disposeActiveRequest({type:X,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${l(X)}`),this.disposeActiveRequest({type:X,id:H[1]})}}onPromise(k){const j=this.channels.get(k.channelName);if(!j){this.collectPendingRequest(k);return}const H=new C.CancellationTokenSource;let te;try{te=j.call(this.ctx,k.name,k.arg,H.token)}catch(_){te=Promise.reject(_)}const X=k.id;te.then(_=>{this.sendResponse({id:X,data:_,type:201}),this.activeRequests.delete(k.id)},_=>{_ instanceof Error?this.sendResponse({id:X,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:X,data:_,type:203}),this.activeRequests.delete(k.id)});const Z=(0,g.toDisposable)(()=>H.cancel());this.activeRequests.set(k.id,Z)}onEventListen(k){const j=this.channels.get(k.channelName);if(!j){this.collectPendingRequest(k);return}const H=k.id,X=j.listen(this.ctx,k.name,k.arg)(Z=>this.sendResponse({id:H,data:Z,type:204}));this.activeRequests.set(k.id,X)}disposeActiveRequest(k){const j=this.activeRequests.get(k.id);j&&(j.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let j=this.pendingRequests.get(k.channelName);j||(j=[],this.pendingRequests.set(k.channelName,j));const H=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:k,timeoutTimer:H})}flushPendingRequests(k){const j=this.pendingRequests.get(k);if(j){for(const H of j)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}t.ChannelServer=S;var R;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(R=t.RequestInitiator||(t.RequestInitiator={}));class b{constructor(k,j=null){this.protocol=k,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=j}getChannel(k){const j=this;return{call(H,te,X){return j.isDisposed?Promise.reject(w.canceled()):j.requestPromise(k,H,te,X)},listen(H,te){return j.isDisposed?Promise.reject(w.canceled()):j.requestEvent(k,H,te)}}}requestPromise(k,j,H,te=C.CancellationToken.None){const X=this.lastRequestId++,_={id:X,type:100,channelName:k,name:j,arg:H};if(te.isCancellationRequested)return Promise.reject(w.canceled());let N;return new Promise((W,x)=>{if(te.isCancellationRequested)return x(w.canceled());const K=()=>{const me=ye=>{switch(ye.type){case 201:this.handlers.delete(X),W(ye.data);break;case 202:this.handlers.delete(X);const ue=new Error(ye.data.message);ue.stack=ye.data.stack,ue.name=ye.data.name,x(ue);break;case 203:this.handlers.delete(X),x(ye.data);break}};this.handlers.set(X,me),this.sendRequest(_)};let Q=null;this.state===m.Idle?K():(Q=(0,P.createCancelablePromise)(me=>this.whenInitialized()),Q.then(()=>{Q=null,K()}));const se=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:X,type:101}),x(w.canceled())},ie=te.onCancellationRequested(se);N=(0,g.combinedDisposable)((0,g.toDisposable)(se),ie),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(k,j,H){const te=this.lastRequestId++,Z={id:te,type:102,channelName:k,name:j,arg:H};let _=null;const N=new c.Emitter({onFirstListenerAdd:()=>{_=(0,P.createCancelablePromise)(W=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(N),this.sendRequest(Z)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(N),this.sendRequest({id:te,type:103}))}}),A=W=>N.fire(W.data);return this.handlers.set(te,A),N.event}sendRequest(k){switch(k.type){case 100:case 102:{const j=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(j,k.id,0,`${l(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const j=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(j,k.id,0,l(k.type));return}}}send(k,j=void 0){const H=new u;return o(H,k),o(H,j),this.sendBuffer(H.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(j){return 0}}onBuffer(k){const j=new y(k),H=d(j),te=d(j),X=H[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,v(X)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],0,v(X),te),this.onResponse({type:H[0],id:H[1],data:te})}}onResponse(k){if(k.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(k.id);j&&j(k)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}de([T.memoize],b.prototype,"onDidInitializePromise",null),t.ChannelClient=b;class O{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:j,onDidClientDisconnect:H})=>{c.Event.once(j.onMessage)(X=>{const Z=new y(X),_=d(Z),N=new S(j,_),A=new b(j);this.channels.forEach((x,K)=>N.registerChannel(K,x));const W={channelServer:N,channelClient:A,ctx:_};this._connections.add(W),this._onDidAddConnection.fire(W),H(()=>{N.dispose(),A.dispose(),this._connections.delete(W),this._onDidRemoveConnection.fire(W)})})})}get connections(){const k=[];return this._connections.forEach(j=>k.push(j)),k}getChannel(k,j){const H=this;return{call(te,X,Z){let _;if((0,f.isFunction)(j)){let A=(0,L.getRandomElement)(H.connections.filter(j));_=A?Promise.resolve(A):c.Event.toPromise(c.Event.filter(H.onDidAddConnection,j))}else _=j.routeCall(H,te,X);const N=_.then(A=>A.channelClient.getChannel(k));return G(N).call(te,X,Z)},listen(te,X){if((0,f.isFunction)(j))return H.getMulticastEvent(k,j,te,X);const Z=j.routeEvent(H,te,X).then(_=>_.channelClient.getChannel(k));return G(Z).listen(te,X)}}}getMulticastEvent(k,j,H,te){const X=this;let Z=new g.DisposableStore;const _=new c.Emitter({onFirstListenerAdd:()=>{Z=new g.DisposableStore;const N=new c.EventMultiplexer,A=new Map,W=K=>{const se=K.channelClient.getChannel(k).listen(H,te),ie=N.add(se);A.set(K,ie)},x=K=>{const Q=A.get(K);!Q||(Q.dispose(),A.delete(K))};X.connections.filter(j).forEach(W),c.Event.filter(X.onDidAddConnection,j)(W,void 0,Z),X.onDidRemoveConnection(x,void 0,Z),N.event(_.fire,_,Z),Z.add(N)},onLastListenerRemove:()=>{Z.dispose()}});return _.event}registerChannel(k,j){this.channels.set(k,j),this._connections.forEach(H=>{H.channelServer.registerChannel(k,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=O;class M{constructor(k,j,H=null){const te=new u;o(te,j),k.send(te.buffer),this.channelClient=new b(k,H),this.channelServer=new S(k,j,H)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,j){this.channelServer.registerChannel(k,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=M;function G(U){return{call(k,j,H){return U.then(te=>te.call(k,j,H))},listen(k,j){const H=new c.Relay;return U.then(te=>H.input=te.listen(k,j)),H.event}}}t.getDelayedChannel=G;function ee(U){let k=!1;return{call(j,H,te){return k?U.call(j,H,te):(0,P.timeout)(0).then(()=>k=!0).then(()=>U.call(j,H,te))},listen(j,H){if(k)return U.listen(j,H);const te=new c.Relay;return(0,P.timeout)(0).then(()=>k=!0).then(()=>te.input=U.listen(j,H)),te.event}}}t.getNextTickChannel=ee;class ce{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const j of k.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await c.Event.toPromise(k.onDidAddConnection),await this.route(k)}}t.StaticRouter=ce;var le;(function(U){function k(X,Z){const _=X,N=Z&&Z.disableMarshalling,A=new Map;for(const W in _)H(W)&&A.set(W,c.Event.buffer(_[W],!0));return new class{listen(W,x,K){const Q=A.get(x);if(Q)return Q;if(te(x)){const se=_[x];if(typeof se=="function")return se.call(_,K)}throw new Error(`Event not found: ${x}`)}call(W,x,K){const Q=_[x];if(typeof Q=="function"){if(!N&&Array.isArray(K))for(let se=0;se<K.length;se++)K[se]=(0,p.revive)(K[se]);return Q.apply(_,K)}throw new Error(`Method not found: ${x}`)}}}U.fromService=k;function j(X,Z){const _=Z&&Z.disableMarshalling;return new Proxy({},{get(N,A){if(typeof A=="string")return Z?.properties?.has(A)?Z.properties.get(A):te(A)?function(W){return X.listen(A,W)}:H(A)?X.listen(A):async function(...W){let x;Z&&!(0,f.isUndefinedOrNull)(Z.context)?x=[Z.context,...W]:x=W;const K=await X.call(A,x);return _?K:(0,p.revive)(K)};throw new Error(`Property not found: ${String(A)}`)}})}U.toService=j;function H(X){return X[0]==="o"&&X[1]==="n"&&D.isUpperAsciiLetter(X.charCodeAt(2))}function te(X){return/^onDynamic/.test(X)&&D.isUpperAsciiLetter(X.charCodeAt(9))}})(le=t.ProxyChannel||(t.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let k=U.toString();if(k!=="[object Object]")return k}return U}function B(U){return Array.isArray(U)?U.map(fe):fe(U)}function q(U,k,j,H,te,X,Z){Z=B(Z);const _=re[te],N=_[H%_.length];let A=[`%c[${U}]%c[${String(k).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(X)?(A=A.concat(Z),A.push(")")):A.push(Z),console.log.apply(console,A)}t.logWithColors=q;class ne{constructor(k,j){this._outgoingPrefix=k,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,j,H,te,X){this._totalOutgoing+=k,q(this._outgoingPrefix,this._totalOutgoing,k,j,H,te,X)}logIncoming(k,j,H,te,X){this._totalIncoming+=k,q(this._incomingPrefix,this._totalIncoming,k,j,H,te,X)}}t.IPCLogger=ne}),define(J[66],Y([0,1,3,10,2,11]),function(z,t,L,P,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var T;(function(D){D[D.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));function w(D){const f=D;return f?.changed instanceof Map||f?.deleted instanceof Set}t.isStorageItemsChangeEvent=w;var c;(function(D){D[D.None=0]="None",D[D.Initialized=1]="Initialized",D[D.Closed=2]="Closed"})(c||(c={}));class g extends I.Disposable{constructor(f,E=Object.create(null)){super();this.database=f,this.options=E,this._onDidChangeStorage=this._register(new P.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((E,l)=>this.accept(l,E)),f.deleted?.forEach(E=>this.accept(E,void 0))}accept(f,E){if(this.state===c.Closed)return;let l=!1;(0,C.isUndefinedOrNull)(E)?l=this.cache.delete(f):this.cache.get(f)!==E&&(this.cache.set(f,E),l=!0),l&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,E){const l=this.cache.get(f);return(0,C.isUndefinedOrNull)(l)?E:l}getBoolean(f,E){const l=this.get(f);return(0,C.isUndefinedOrNull)(l)?E:l==="true"}getNumber(f,E){const l=this.get(f);return(0,C.isUndefinedOrNull)(l)?E:parseInt(l,10)}async set(f,E){if(this.state===c.Closed)return;if((0,C.isUndefinedOrNull)(E))return this.delete(f);const l=String(E);if(this.cache.get(f)!==l)return this.cache.set(f,l),this.pendingInserts.set(f,l),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===c.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch(f){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class p{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((E,l)=>this.items.set(l,E)),f.delete&&f.delete.forEach(E=>this.items.delete(E))}async close(){}}t.InMemoryStorageDatabase=p}),define(J[67],Y([4,5]),function(z,t){return z.create("vs/base/common/date",t)}),define(J[68],Y([0,1,67]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const P=60,I=P*60,C=I*24,T=C*7,w=C*30,c=C*365;function g(D,f){typeof D!="number"&&(D=D.getTime());const E=Math.round((new Date().getTime()-D)/1e3);if(E<-30)return(0,L.localize)(0,null,g(new Date().getTime()+E*1e3,!1));if(E<30)return(0,L.localize)(1,null);let l;return E<P?(l=E,f?l===1?(0,L.localize)(2,null,l):(0,L.localize)(3,null,l):l===1?(0,L.localize)(4,null,l):(0,L.localize)(5,null,l)):E<I?(l=Math.floor(E/P),f?l===1?(0,L.localize)(6,null,l):(0,L.localize)(7,null,l):l===1?(0,L.localize)(8,null,l):(0,L.localize)(9,null,l)):E<C?(l=Math.floor(E/I),f?l===1?(0,L.localize)(10,null,l):(0,L.localize)(11,null,l):l===1?(0,L.localize)(12,null,l):(0,L.localize)(13,null,l)):E<T?(l=Math.floor(E/C),f?l===1?(0,L.localize)(14,null,l):(0,L.localize)(15,null,l):l===1?(0,L.localize)(16,null,l):(0,L.localize)(17,null,l)):E<w?(l=Math.floor(E/T),f?l===1?(0,L.localize)(18,null,l):(0,L.localize)(19,null,l):l===1?(0,L.localize)(20,null,l):(0,L.localize)(21,null,l)):E<c?(l=Math.floor(E/w),f?l===1?(0,L.localize)(22,null,l):(0,L.localize)(23,null,l):l===1?(0,L.localize)(24,null,l):(0,L.localize)(25,null,l)):(l=Math.floor(E/c),f?l===1?(0,L.localize)(26,null,l):(0,L.localize)(27,null,l):l===1?(0,L.localize)(28,null,l):(0,L.localize)(29,null,l))}t.fromNow=g;function p(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=p}),define(J[69],Y([4,5]),function(z,t){return z.create("vs/base/common/errorMessage",t)}),define(J[28],Y([0,1,20,11,69]),function(z,t,L,P,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function C(g,p){return p&&(g.stack||g.stacktrace)?I.localize(0,null,w(g),T(g.stack)||T(g.stacktrace)):w(g)}function T(g){return Array.isArray(g)?g.join(`
`):g}function w(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?I.localize(1,null,g.message):g.message||I.localize(2,null)}function c(g=null,p=!1){if(!g)return I.localize(3,null);if(Array.isArray(g)){const D=L.coalesce(g),f=c(D[0],p);return D.length>1?I.localize(4,null,f,D.length):f}if(P.isString(g))return g;if(g.detail){const D=g.detail;if(D.error)return C(D.error,p);if(D.exception)return C(D.exception,p)}return g.stack?C(g,p):g.message?g.message:I.localize(5,null)}t.toErrorMessage=c}),define(J[70],Y([4,5]),function(z,t){return z.create("vs/base/node/processes",t)}),define(J[49],Y([0,1,40,47,9,18,6,12,29,58,11,63,13,70]),function(z,t,L,P,I,C,T,w,c,g,p,D,f,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.removeDangerousEnvVariables=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return g.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return g.TerminateResponseCode}});function l(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(e,r){if(w.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};r&&(i.cwd=r);const n=L.execFile("taskkill",["/T","/F","/PID",e.pid.toString()],i);return new Promise(o=>{n.once("error",d=>{o({success:!1,error:d})}),n.once("exit",(d,S)=>{o(d===0?{success:!0}:{success:!1,code:d!==null?d:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?l(i.status):1})}else if(w.isLinux||w.isMacintosh)try{const i=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",z).fsPath;return new Promise(n=>{L.execFile(i,[e.pid.toString()],{encoding:"utf8",shell:!0},(o,d,S)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else e.kill("SIGKILL");return Promise.resolve({success:!0})}function v(e){!e||(delete e.DEBUG,w.isMacintosh&&delete e.DYLD_LIBRARY_PATH,w.isLinux&&delete e.LD_PRELOAD)}t.removeDangerousEnvVariables=v;function m(e=c.env){return e.comspec||"cmd.exe"}t.getWindowsShell=m;class y{constructor(r,i,n,o){if(i!==void 0&&n!==void 0&&o!==void 0)this.cmd=r,this.args=i,this.shell=n,this.options=o;else{const d=r;this.cmd=d.command,this.shell=d.isShellCommand,this.args=d.args.slice(0),this.options=d.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const d=Object.create(null);Object.keys(c.env).forEach(S=>{d[S]=c.env[S]}),Object.keys(this.options.env).forEach(S=>{d[S]=this.options.env[S]}),this.options.env=d}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const i=r.lastIndexOf(T.sep);return i!==-1&&(r=r.substring(i+1)),y.WellKnowCommands[r]?r:"other"}start(r){return w.isWindows&&(this.options&&this.options.cwd&&P.isUNC(this.options.cwd)||!this.options&&P.isUNC(c.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(i=>{let n,o;const d=new Promise((S,R)=>{n=S,o=R});if(i){let S=this.cmd;this.args&&(S=S+" "+this.args.join(" ")),this.childProcess=L.exec(S,this.options,(R,b,O)=>{this.childProcess=null;const M=R;M&&M.killed?o({killed:this.terminateRequested,stdout:b.toString(),stderr:O.toString()}):this.handleExec(n,r,R,b,O)})}else{let S=null;const R=b=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(b,n,r,o);const O={terminated:this.terminateRequested};p.isNumber(b)&&(O.cmdCode=b),n(O)};if(this.shell&&w.isWindows){const b=C.deepClone(this.options);b.windowsVerbatimArguments=!0,b.detached=!1;let O=!1,M=!1;const G=[];let ee=this.ensureQuotes(this.cmd);G.push(ee.value),O=ee.quoted,this.args&&this.args.forEach(le=>{ee=this.ensureQuotes(le),G.push(ee.value),M=M&&ee.quoted});const ce=["/s","/c"];O?M?ce.push('"'+G.join(" ")+'"'):G.length>1?ce.push('"'+G[0]+'" '+G.slice(1).join(" ")):ce.push('"'+G[0]+'"'):ce.push(G.join(" ")),S=L.spawn(m(),ce,b)}else this.cmd&&(S=L.spawn(this.cmd,this.args,this.options));S&&(this.childProcess=S,this.childProcessPromise=Promise.resolve(S),this.pidResolve&&(this.pidResolve(p.isNumber(S.pid)?S.pid:-1),this.pidResolve=void 0),S.on("error",b=>{this.childProcess=null,o({terminated:this.terminateRequested,error:b})}),S.pid&&(this.childProcess.on("close",R),this.handleSpawn(S,n,r,o,!0)))}return d})}handleClose(r,i,n,o){}ensureQuotes(r){return y.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,h(r,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!w.isWindows)return r(!1);const i=L.spawn(m(),["/s","/c"]);i.on("error",n=>r(!0)),i.on("exit",n=>r(!1))})}}t.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class u extends y{constructor(r,i,n,o){super(r,i,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,i,n,o,d){[o,d].forEach((S,R)=>{const b=new D.LineDecoder;b.write(S).forEach(G=>{i({line:G,source:R===0?0:1})});const M=b.end();M&&i({line:M,source:R===0?0:1})}),r({terminated:this.terminateRequested,error:n})}handleSpawn(r,i,n,o,d){const S=new D.LineDecoder,R=new D.LineDecoder;r.stdout.on("data",b=>{S.write(b).forEach(M=>n({line:M,source:0}))}),r.stderr.on("data",b=>{R.write(b).forEach(M=>n({line:M,source:1}))}),this.stdoutLineDecoder=S,this.stderrLineDecoder=R}handleClose(r,i,n,o){const d=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;d&&n({line:d,source:0});const S=this.stderrLineDecoder?this.stderrLineDecoder.end():null;S&&n({line:S,source:1})}}t.LineProcess=u;function s(e){let r=[],i=!1;const n=function(o){if(i){r.push(o);return}(!e.send(o,S=>{if(S&&console.error(S),i=!1,r.length>0){const R=r.slice(0);r=[],R.forEach(b=>n(b))}})||w.isWindows)&&(i=!0)};return{send:n}}t.createQueuedSender=s;var a;(function(e){async function r(i,n,o){if(T.isAbsolute(i))return i;if(n===void 0&&(n=c.cwd()),T.dirname(i)!=="."||(o===void 0&&p.isString(c.env.PATH)&&(o=c.env.PATH.split(T.delimiter)),o===void 0||o.length===0))return T.join(n,i);async function S(R){if(await f.Promises.exists(R)){let b;try{b=await f.Promises.stat(R)}catch(O){O.message.startsWith("EACCES")&&(b=await f.Promises.lstat(R))}return b?!b.isDirectory():!1}return!1}for(let R of o){let b;if(T.isAbsolute(R)?b=T.join(R,i):b=T.join(n,R,i),await S(b))return b;let O=b+".com";if(await S(O)||(O=b+".exe",await S(O)))return O}return T.join(n,i)}e.findExecutable=r})(a=t.win32||(t.win32={}))}),define(J[71],Y([0,1,34,12,65,49]),function(z,t,L,P,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function T(E,l){return E===1?P.isWindows?D():C.getWindowsShell(l):g(E,l)}t.getSystemShell=T;function w(E,l){return E===1?P.isWindows?f(l):C.getWindowsShell(l):g(E,l)}t.getSystemShellSync=w;let c=null;function g(E,l){if(P.isLinux&&E===2||P.isMacintosh&&E===3)return"/bin/bash";if(!c){let h;if(P.isWindows)h="/bin/bash";else{if(h=l.SHELL,!h)try{h=(0,L.userInfo)().shell}catch(v){}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}c=h}return c}let p=null;async function D(){return p||(p=(await(0,I.getFirstAvailablePowerShellInstallation)()).exePath),p}function f(E){if(p)return p;const l=P.isWindows&&parseFloat((0,L.release)())>=10,h=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${E.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?v:C.getWindowsShell(E)}}),define(J[50],Y([0,1,40,3,17,24,60,7,10,2,18,49,39]),function(z,t,L,P,I,C,T,w,c,g,p,D,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class E extends f.ChannelServer{constructor(v){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(y){}},onMessage:c.Event.fromNodeEventEmitter(process,"message",m=>I.VSBuffer.wrap(Buffer.from(m,"base64")))},v);process.once("disconnect",()=>this.dispose())}}t.Server=E;class l{constructor(v,m){this.modulePath=v,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new P.Delayer(y),this.child=null,this._client=null}getChannel(v){const m=this;return{call(y,u,s){return m.requestPromise(v,y,u,s)},listen(y,u){return m.requestEvent(v,y,u)}}}requestPromise(v,m,y,u=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(v),a=(0,P.createCancelablePromise)(i=>s.call(m,y,i)),e=u.onCancellationRequested(()=>a.cancel()),r=(0,g.toDisposable)(()=>a.cancel());return this.activeRequests.add(r),a.finally(()=>{e.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(v,m,y){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let u;const s=new c.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(v).listen(m,y)(s.fire,s),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,D.removeDangerousEnvVariables)(m.env),this.child=(0,L.fork)(this.modulePath,v,m);const y=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,T.isRemoteConsoleLog)(n)){(0,T.log)(n,`IPC Library: ${this.options.serverName}`);return}y.fire(I.VSBuffer.wrap(Buffer.from(n,"base64")))});const s=this.options.useQueue?(0,D.createQueuedSender)(this.child):this.child,a=n=>this.child&&this.child.connected&&s.send(n.buffer.toString("base64")),e=y.event,r={send:a,onMessage:e};this._client=new f.ChannelClient(r);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(d=>(0,g.dispose)(d)),this.activeRequests.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:o})})}return this._client}getCachedChannel(v){let m=this.channels.get(v);return m||(m=this.client.getChannel(v),this.channels.set(v,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=l}),define(J[72],Y([4,5]),function(z,t){return z.create("vs/base/node/zip",t)}),define(J[73],Y([4,5]),function(z,t){return z.create("vs/platform/configuration/common/configurationRegistry",t)}),define(J[74],Y([4,5]),function(z,t){return z.create("vs/platform/environment/node/shellEnv",t)}),define(J[75],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(J[76],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(J[77],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(J[78],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(J[79],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(J[80],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(J[81],Y([4,5]),function(z,t){return z.create("vs/platform/extensions/common/extensionValidator",t)}),define(J[82],Y([4,5]),function(z,t){return z.create("vs/platform/files/common/fileService",t)}),define(J[83],Y([4,5]),function(z,t){return z.create("vs/platform/files/common/io",t)}),define(J[84],Y([4,5]),function(z,t){return z.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(J[85],Y([4,5]),function(z,t){return z.create("vs/platform/request/common/request",t)}),define(J[86],Y([4,5]),function(z,t){return z.create("vs/platform/telemetry/common/telemetryService",t)}),define(J[87],Y([0,1,68,46,9,6,29,19,8]),function(z,t,L,P,I,C,T,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class g{constructor(h,v,m){this._args=h,this.paths=v,this.productService=m}get appRoot(){return(0,C.dirname)(I.FileAccess.asFileUri("",z).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(c.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=T.env.VSCODE_PORTABLE;return h?c.URI.file((0,C.join)(h,"argv.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,w.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,C.resolve)(h):(0,C.normalize)((0,C.join)(I.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,C.resolve)(h):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,C.resolve)(h);const v=T.env.VSCODE_EXTENSIONS;if(v)return v;const m=T.env.VSCODE_PORTABLE;return m?(0,C.join)(m,"extensions"):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(v=>/^[^:/?#]+?:\/\//.test(v)?c.URI.parse(v):c.URI.file((0,C.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?c.URI.parse(h):c.URI.file((0,C.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,w.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([P.memoize],g.prototype,"appRoot",null),de([P.memoize],g.prototype,"userHome",null),de([P.memoize],g.prototype,"userDataPath",null),de([P.memoize],g.prototype,"appSettingsHome",null),de([P.memoize],g.prototype,"tmpDir",null),de([P.memoize],g.prototype,"userRoamingDataHome",null),de([P.memoize],g.prototype,"settingsResource",null),de([P.memoize],g.prototype,"userDataSyncHome",null),de([P.memoize],g.prototype,"userDataSyncLogResource",null),de([P.memoize],g.prototype,"sync",null),de([P.memoize],g.prototype,"machineSettingsResource",null),de([P.memoize],g.prototype,"globalStorageHome",null),de([P.memoize],g.prototype,"workspaceStorageHome",null),de([P.memoize],g.prototype,"keybindingsResource",null),de([P.memoize],g.prototype,"keyboardLayoutResource",null),de([P.memoize],g.prototype,"argvResource",null),de([P.memoize],g.prototype,"snippetsHome",null),de([P.memoize],g.prototype,"isExtensionDevelopment",null),de([P.memoize],g.prototype,"untitledWorkspacesHome",null),de([P.memoize],g.prototype,"installSourcePath",null),de([P.memoize],g.prototype,"builtinExtensionsPath",null),de([P.memoize],g.prototype,"extensionsPath",null),de([P.memoize],g.prototype,"extensionDevelopmentLocationURI",null),de([P.memoize],g.prototype,"extensionDevelopmentKind",null),de([P.memoize],g.prototype,"extensionTestsLocationURI",null),de([P.memoize],g.prototype,"debugExtensionHost",null),de([P.memoize],g.prototype,"serviceMachineIdResource",null),de([P.memoize],g.prototype,"telemetryLogResource",null),de([P.memoize],g.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=g;function p(l,h){return E(l["inspect-extensions"],l["inspect-brk-extensions"],5870,h,l.debugId,l.extensionEnvironment)}t.parseExtensionHostPort=p;function D(l,h){return E(l["inspect-search"],l["inspect-brk-search"],5876,h,l.extensionEnvironment)}t.parseSearchPort=D;function f(l,h){return E(l["inspect-ptyhost"],l["inspect-brk-ptyhost"],5877,h,l.extensionEnvironment)}t.parsePtyHostPort=f;function E(l,h,v,m,y,u){const a=Number(h||l)||(m?null:v),e=a?Boolean(!!h):!1;let r;if(u)try{r=JSON.parse(u)}catch{}return{port:a,break:e,debugId:y,env:r}}}),function(){"use strict";function z(t,L,P,I){function C(w){const c=T(w),g=[c];return t.isAbsolute(c)||g.unshift(I),t.resolve(...g)}function T(w){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return t.join(g,P);const p=w["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const D=process.env.USERPROFILE;if(typeof D!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=t.join(D,"AppData","Roaming")}break;case"darwin":g=t.join(L.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||t.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(g,P)}return{getUserDataPath:C}}if(typeof define=="function")define(J[88],Y([0,132,34,9,19,29]),function(t,L,P,I,C,T){const w=C.dirname(I.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(C.joinPath(w,"package.json").fsPath);return z(L,P,c.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),L=require("path"),P=require("os");module.exports=z(L,P,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[89],Y([0,1,34,87,88]),function(z,t,L,P,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class C extends P.AbstractNativeEnvironmentService{constructor(w,c){super(w,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,I.getUserDataPath)(w)},c)}}t.NativeEnvironmentService=C}),define(J[90],Y([0,1,18]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const P=/^%([\w\d.-]+)%$/i;function I(C,T){const w=c=>{if(typeof c!="string")return;const g=P.exec(c);if(!g)return;const p=T[g[1]]??c;return typeof p=="string"?p:typeof p.message=="string"?p.message:c};return(0,L.cloneAndChange)(C,w)}t.localizeManifest=I}),define(J[51],Y([0,1,81]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function C(f){return f=f.trim(),f==="*"||P.test(f)}t.isValidVersionStr=C;function T(f){if(!C(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=f.match(P);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}t.parseVersion=T;function w(f){if(!f)return null;let E=f.majorBase,l=f.majorMustEqual,h=f.minorBase,v=f.minorMustEqual,m=f.patchBase,y=f.patchMustEqual;f.hasCaret&&(E===0||(v=!1),y=!1);let u=0;if(f.preRelease){const s=I.exec(f.preRelease);if(s){const[,a,e,r]=s;u=Date.UTC(Number(a),Number(e)-1,Number(r))}}return{majorBase:E,majorMustEqual:l,minorBase:h,minorMustEqual:v,patchBase:m,patchMustEqual:y,isMinimum:f.hasGreaterEquals,notBefore:u}}t.normalizeVersion=w;function c(f,E,l){let h;typeof f=="string"?h=w(T(f)):h=f;let v;E instanceof Date?v=E.getTime():typeof E=="string"&&(v=new Date(E).getTime());let m;if(typeof l=="string"?m=w(T(l)):m=l,!h||!m)return!1;let y=h.majorBase,u=h.minorBase,s=h.patchBase,a=m.majorBase,e=m.minorBase,r=m.patchBase,i=m.notBefore,n=m.majorMustEqual,o=m.minorMustEqual,d=m.patchMustEqual;return m.isMinimum?y>a?!0:y<a?!1:u>e?!0:u<e||v&&v<i?!1:s>=r:(y===1&&a===0&&(!n||!o||!d)&&(a=1,e=0,r=0,n=!0,o=!1,d=!1),y<a?!1:y>a?!n:u<e?!1:u>e?!o:s<r?!1:s>r?!d:!(v&&v<i))}t.isValidVersion=c;function g(f,E,l,h){return l.isBuiltin||typeof l.main=="undefined"?!0:D(f,E,l.engines.vscode,h)}t.isValidExtensionVersion=g;function p(f,E,l){return f==="*"||D(E,l,f)}t.isEngineValid=p;function D(f,E,l,h=[]){let v=w(T(l));if(!v)return h.push(L.localize(0,null,l)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return h.push(L.localize(1,null,l)),!1}else if(!v.majorMustEqual)return h.push(L.localize(2,null,l)),!1;return c(f,E,v)?!0:(h.push(L.localize(3,null,f,l)),!1)}}),define(J[41],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class L{constructor(I,C=[],T=!1){this.ctor=I,this.staticArguments=C,this.supportsDelayedInstantiation=T}}t.SyncDescriptor=L}),define(J[91],Y([0,1,41]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const P=[];function I(T,w,c){w instanceof L.SyncDescriptor||(w=new L.SyncDescriptor(w,[],c)),P.push([T,w])}t.registerSingleton=I;function C(){return P}t.getSingletonServiceDescriptors=C}),define(J[92],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class L{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}t.Node=L;class P{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let T of this._nodes.values())T.outgoing.size===0&&C.push(T);return C}insertEdge(C,T){const w=this.lookupOrInsertNode(C),c=this.lookupOrInsertNode(T);w.outgoing.set(this._hashFn(T),c),c.incoming.set(this._hashFn(C),w)}removeNode(C){const T=this._hashFn(C);this._nodes.delete(T);for(let w of this._nodes.values())w.outgoing.delete(T),w.incoming.delete(T)}lookupOrInsertNode(C){const T=this._hashFn(C);let w=this._nodes.get(T);return w||(w=new L(C),this._nodes.set(T,w)),w}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[T,w]of this._nodes)C.push(`${T}, (incoming)[${[...w.incoming.keys()].join(", ")}], (outgoing)[${[...w.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,T]of this._nodes){const w=new Set([C]),c=this._findCycle(T,w);if(c)return c}}_findCycle(C,T){for(let[w,c]of C.outgoing){if(T.has(w))return[...T,w].join(" -> ");T.add(w);const g=this._findCycle(c,T);if(g)return g;T.delete(w)}}}t.Graph=P}),define(J[52],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,L.createDecorator)("downloadService")}),define(J[21],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,L.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,L.refineServiceDecorator)(t.IEnvironmentService)}),define(J[22],Y([0,1,9,76,14]),function(z,t,L,P,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var C;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(C=t.TargetPlatform||(t.TargetPlatform={}));function T(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=T;function w(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=w;function c(u,s){switch(u){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=c;function g(u,s){return s==="web"&&!u.includes("web")}t.isNotWebExtensionInWebTargetPlatform=g;function p(u,s,a){return g(s,a)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===a?!0:D(a).includes(u)}t.isTargetPlatformCompatible=p;function D(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=D;function f(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}t.isIExtensionIdentifier=f;var E;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(E=t.SortBy||(t.SortBy={}));var l;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(l=t.SortOrder||(t.SortOrder={}));var h;(function(u){u.Install="install",u.Uninstall="uninstall"})(h=t.StatisticType||(t.StatisticType={}));var v;(function(u){u[u.None=0]="None",u[u.Install=1]="Install",u[u.Update=2]="Update"})(v=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var m;(function(u){u.Unsupported="Unsupported",u.Malicious="Malicious",u.Incompatible="Incompatible",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal"})(m=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class y extends Error{constructor(s,a){super(s);this.code=a,this.name=a}}t.ExtensionManagementError=y,t.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",z).toString(!0),t.ExtensionsLabel=(0,P.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,P.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(J[93],Y([0,1,40,6,74,24,28,7,12,31,71,133,3]),function(z,t,L,P,I,C,T,w,c,g,p,D,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;const E=1e4;let l;async function h(m,y,u){return y["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):c.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,D.isLaunchedFromCli)(u)&&!y["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,D.isLaunchedFromCli)(u)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),l||(l=f.Promises.withAsyncBody(async(s,a)=>{const e=new C.CancellationTokenSource,r=setTimeout(()=>{e.dispose(!0),a(new Error((0,I.localize)(0,null)))},E);try{s(await v(m,e.token))}catch(i){!(0,w.isPromiseCanceledError)(i)&&!e.token.isCancellationRequested?a(new Error((0,I.localize)(1,null,(0,T.toErrorMessage)(i)))):s({})}finally{clearTimeout(r),e.dispose()}})),l)}t.resolveShellEnv=h;async function v(m,y){const u=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",u);const s=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",s);const a=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(a+"(.*)"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",r);const i=await(0,p.getSystemShell)(c.OS,r);return m.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(y.isCancellationRequested)return o((0,w.canceled)());const d=(0,P.basename)(i);let S,R;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(d)?(S=`& '${process.execPath}' ${b} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,R=["-Login","-Command"]):(S=`'${process.execPath}' ${b} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,d==="tcsh"?R=["-ic"]:R=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),S);const O=(0,L.spawn)(i,[...R,S],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});y.onCancellationRequested(()=>(O.kill(),o((0,w.canceled)()))),O.on("error",ee=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(ee)),o(ee)});const M=[];O.stdout.on("data",ee=>M.push(ee));const G=[];O.stderr.on("data",ee=>G.push(ee)),O.on("close",(ee,ce)=>{const le=Buffer.concat(M).toString("utf8");m.trace("getUnixShellEnvironment#raw",le);const re=Buffer.concat(G).toString("utf8");if(re.trim()&&m.trace("getUnixShellEnvironment#stderr",re),ee||ce)return o(new Error((0,I.localize)(2,null,ee,ce)));const fe=e.exec(le),B=fe?fe[1]:"{}";try{const q=JSON.parse(B);u?q.ELECTRON_RUN_AS_NODE=u:delete q.ELECTRON_RUN_AS_NODE,s?q.ELECTRON_NO_ATTACH_CONSOLE=s:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",q),n(q)}catch(q){m.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(q)),o(q)}})})}}),define(J[53],Y([0,1,17,7,83,16]),function(z,t,L,P,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(p,D,f,E,l,h){let v;try{await w(p,D,f,E,l,h)}catch(m){v=m}finally{v&&l.errorTransformer&&(v=l.errorTransformer(v)),typeof v!="undefined"&&f.error(v),f.end()}}t.readFileIntoStream=T;async function w(p,D,f,E,l,h){c(h);const v=await p.open(D,{create:!1});try{c(h);let m=0,y=0,u=l&&typeof l.length=="number"?l.length:void 0,s=L.VSBuffer.alloc(Math.min(l.bufferSize,typeof u=="number"?u:l.bufferSize)),a=l&&typeof l.position=="number"?l.position:0,e=0;do y=await p.read(v,a,s.buffer,e,s.byteLength-e),a+=y,e+=y,m+=y,typeof u=="number"&&(u-=y),e===s.byteLength&&(await f.write(E(s)),s=L.VSBuffer.alloc(Math.min(l.bufferSize,typeof u=="number"?u:l.bufferSize)),e=0);while(y>0&&(typeof u!="number"||u>0)&&c(h)&&g(m,l));if(e>0){let r=e;typeof u=="number"&&(r=Math.min(e,u)),f.write(E(s.slice(0,r)))}}catch(m){throw(0,C.ensureFileSystemProviderError)(m)}finally{await p.close(v)}}function c(p){if(p.isCancellationRequested)throw(0,P.canceled)();return!0}function g(p,D){if(D?.limits){if(typeof D.limits.memory=="number"&&p>D.limits.memory)throw(0,C.createFileSystemProviderError)((0,I.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof D.limits.size=="number"&&p>D.limits.size)throw(0,C.createFileSystemProviderError)((0,I.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[35],Y([0,1,2,12,8,16]),function(z,t,L,P,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=t.WatcherService=t.AbstractWatcherService=void 0;class T extends L.Disposable{constructor(f,E,l){super();this.onFileChanges=f,this.onLogMessage=E,this.verboseLogging=l,this.serviceDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const f=new L.DisposableStore;this.serviceDisposables.value=f,this.service=this.createService(f),this.service.setVerboseLogging(this.verboseLogging),f.add(this.service.onDidChangeFile(E=>this.onFileChanges(E))),f.add(this.service.onDidLogMessage(E=>this.onLogMessage(E))),f.add(this.service.onDidError(E=>this.onError(E)))}onError(f){this.restartCounter<T.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${f}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${f}`)}restart(f){this.restartCounter++,this.init(),this.watch(f)}async watch(f){this.requests=f,await this.service?.watch(f)}async setVerboseLogging(f){this.verboseLogging=f,await this.service?.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${f}`})}dispose(){return this.service=void 0,super.dispose()}}t.AbstractWatcherService=T,T.MAX_RESTARTS=5;class w extends L.Disposable{}t.WatcherService=w;function c(D){return D.map(f=>({type:f.type,resource:I.URI.file(f.path)}))}t.toFileChanges=c;function g(D){const f=new p;for(const E of D)f.processEvent(E);return f.normalize()}t.normalizeFileChanges=g;class p{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(f){return P.isLinux?f.path:f.path.toLowerCase()}processEvent(f){const E=this.mapPathToChange.get(this.toKey(f));let l=!1;if(E){const h=E.type,v=f.type;E.path!==f.path&&f.type===2?l=!0:h===1&&v===2?(this.mapPathToChange.delete(this.toKey(f)),this.normalized.delete(E)):h===2&&v===1?E.type=0:h===1&&v===0||(E.type=v)}else l=!0;l&&(this.normalized.add(f),this.mapPathToChange.set(this.toKey(f),f))}normalize(){const f=[],E=[];return Array.from(this.normalized).filter(l=>l.type!==2?(f.push(l),!1):!0).sort((l,h)=>l.path.length-h.path.length).filter(l=>E.some(h=>(0,C.isParent)(l.path,h,!P.isLinux))?!1:(E.push(l.path),!0)).concat(f)}}}),define(J[94],Y([0,1,3,2,6,64,13,134,35]),function(z,t,L,P,I,C,T,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class g extends P.Disposable{constructor(D,f,E,l){super();this.path=D,this.onDidFilesChange=f,this.onLogMessage=E,this.verboseLogging=l,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(w.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(D){this.verboseLogging=D}async startWatching(){try{const{stat:D,symbolicLink:f}=await T.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(f)try{E=await(0,C.realpath)(E)}catch(l){if(this.onError(l),f.dangling)return}D.isDirectory()?this._register((0,w.watchFolder)(E,(l,h)=>{this.onFileChange({type:l==="changed"?0:l==="added"?1:2,path:(0,I.join)(this.path,(0,I.basename)(h))})},l=>this.onError(l))):this._register((0,w.watchFile)(E,l=>{this.onFileChange({type:l==="changed"?0:2,path:this.path})},l=>this.onError(l)))}catch(D){D.code!=="ENOENT"&&this.onError(D)}}onFileChange(D){this.fileChangesBuffer.push(D),this.verboseLogging&&this.onVerbose(`${D.type===1?"[ADDED]":D.type===2?"[DELETED]":"[CHANGED]"} ${D.path}`),this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,c.normalizeFileChanges)(f);if(this.verboseLogging)for(const l of E)this.onVerbose(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);E.length>0&&this.onDidFilesChange(E)})}onError(D){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${D}`})}onVerbose(D){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${D}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=g}),define(J[95],Y([0,1,9,39,50,35]),function(z,t,L,P,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends C.WatcherService{constructor(c,g,p){super();this.onDidFilesChange=c,this.onLogMessage=g,this.verboseLogging=p,this.isDisposed=!1,this.startWatching()}startWatching(){const c=this._register(new I.Client(L.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=P.ProxyChannel.toService((0,P.getNextTickChannel)(c.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g)))}async setVerboseLogging(c){this.verboseLogging=c,this.isDisposed||await this.service?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${c}`})}async watch(c){this.isDisposed||await this.service?.watch(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T}),define(J[96],Y([0,1,9,39,50,35]),function(z,t,L,P,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends C.AbstractWatcherService{constructor(c,g,p){super(c,g,p);this.init()}createService(c){const g=c.add(new I.Client(L.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return c.add(g.onDidProcessExit(({code:p,signal:D})=>this.onError(`terminated by itself with code ${p}, signal: ${D}`))),P.ProxyChannel.toService((0,P.getNextTickChannel)(g.getChannel("watcher")))}}t.FileWatcher=T}),define(J[54],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class L{constructor(...I){this._entries=new Map;for(let[C,T]of I)this.set(C,T)}set(I,C){const T=this._entries.get(I);return this._entries.set(I,C),T}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}t.ServiceCollection=L}),define(J[97],Y([0,1,3,7,41,92,14,54]),function(z,t,L,P,I,C,T,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class g extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class p{constructor(l=new w.ServiceCollection,h=!1,v){this._activeInstantiations=new Set,this._services=l,this._strict=h,this._parent=v,this._services.set(T.IInstantiationService,this)}createChild(l){return new p(l,this._strict,this)}invokeFunction(l,...h){let v=f.traceInvocation(l),m=!1;try{return l({get:u=>{if(m)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(u,v);if(!s)throw new Error(`[invokeFunction] unknown service '${u}'`);return s}},...h)}finally{m=!0,v.stop()}}createInstance(l,...h){let v,m;return l instanceof I.SyncDescriptor?(v=f.traceCreation(l.ctor),m=this._createInstance(l.ctor,l.staticArguments.concat(h),v)):(v=f.traceCreation(l),m=this._createInstance(l,h,v)),v.stop(),m}_createInstance(l,h=[],v){let m=T._util.getServiceDependencies(l).sort((s,a)=>s.index-a.index),y=[];for(const s of m){let a=this._getOrCreateServiceInstance(s.id,v);if(!a&&this._strict&&!s.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${s.id}.`);y.push(a)}let u=m.length>0?m[0].index:h.length;if(h.length!==u){console.warn(`[createInstance] First service dependency of ${l.name} at position ${u+1} conflicts with ${h.length} static arguments`);let s=u-h.length;s>0?h=h.concat(new Array(s)):h=h.slice(0,u)}return new l(...[...h,...y])}_setServiceInstance(l,h){if(this._services.get(l)instanceof I.SyncDescriptor)this._services.set(l,h);else if(this._parent)this._parent._setServiceInstance(l,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let h=this._services.get(l);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):h}_getOrCreateServiceInstance(l,h){let v=this._getServiceInstanceOrDescriptor(l);return v instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,v,h.branch(l,!0)):(h.branch(l,!1),v)}_safeCreateAndCacheServiceInstance(l,h,v){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,h,v)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,h,v){const m=new C.Graph(s=>s.id.toString());let y=0;const u=[{id:l,desc:h,_trace:v}];for(;u.length;){const s=u.pop();if(m.lookupOrInsertNode(s),y++>1e3)throw new g(m);for(let a of T._util.getServiceDependencies(s.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(a.id);if(!e&&!a.optional&&console.warn(`[createInstance] ${l} depends on ${a.id} which is NOT registered.`),e instanceof I.SyncDescriptor){const r={id:a.id,desc:e,_trace:s._trace.branch(a.id,!0)};m.insertEdge(s,r),u.push(r)}}}for(;;){const s=m.roots();if(s.length===0){if(!m.isEmpty())throw new g(m);break}for(const{data:a}of s){if(this._getServiceInstanceOrDescriptor(a.id)instanceof I.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}m.removeNode(a)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,h,v=[],m,y){if(this._services.get(l)instanceof I.SyncDescriptor)return this._createServiceInstance(h,v,m,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,h,v,m,y);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(l,h=[],v,m){if(v){const y=new L.IdleValue(()=>this._createInstance(l,h,m));return new Proxy(Object.create(null),{get(u,s){if(s in u)return u[s];let a=y.value,e=a[s];return typeof e!="function"||(e=e.bind(a),u[s]=e),e},set(u,s,a){return y.value[s]=a,!0}})}else return this._createInstance(l,h,m)}}t.InstantiationService=p;var D;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(D||(D={}));class f{constructor(l,h){this.type=l,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return c?new f(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(l){return c?new f(0,l.name):f._None}branch(l,h){let v=new f(2,l.toString());return this._dep.push([l,h,v]),v}stop(){let l=Date.now()-this._start;f._totals+=l;let h=!1;function v(y,u){let s=[],a=new Array(y+1).join("	");for(const[e,r,i]of u._dep)if(r&&i){h=!0,s.push(`${a}CREATES -> ${e}`);let n=v(y+1,i);n&&s.push(n)}else s.push(`${a}uses -> ${e}`);return s.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(l>2||h)&&console.log(m.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(J[55],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,L.createDecorator)("localizationsService");function P(I){if(typeof I.languageId!="string"||!Array.isArray(I.translations)||I.translations.length===0)return!1;for(const C of I.translations)if(typeof C.id!="string"||typeof C.path!="string")return!1;return!(I.languageName&&typeof I.languageName!="string"||I.localizedLanguageName&&typeof I.localizedLanguageName!="string")}t.isValidLocalization=P}),define(J[15],Y([0,1,28,10,2,12,14]),function(z,t,L,P,I,C,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.format=t.log=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,T.createDecorator)("logService"),t.ILoggerService=(0,T.createDecorator)("loggerService");function w(){return new Date().toISOString()}var c;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;function g(r,i,n){switch(i){case c.Trace:r.trace(n);break;case c.Debug:r.debug(n);break;case c.Info:r.info(n);break;case c.Warning:r.warn(n);break;case c.Error:r.error(n);break;case c.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}t.log=g;function p(r){let i="";for(let n=0;n<r.length;n++){let o=r[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(d){}i+=(n>0?" ":"")+o}return i}t.format=p;class D extends I.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=D;class f extends D{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(c.Trace)&&this.log(c.Trace,p([i,...n]))}debug(i,...n){this.checkLogLevel(c.Debug)&&this.log(c.Debug,p([i,...n]))}info(i,...n){this.checkLogLevel(c.Info)&&this.log(c.Info,p([i,...n]))}warn(i,...n){this.checkLogLevel(c.Warning)&&this.log(c.Warning,p([i,...n]))}error(i,...n){if(this.checkLogLevel(c.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(c.Error,p(o))}else this.log(c.Error,p([i,...n]))}critical(i,...n){this.checkLogLevel(c.Critical)&&this.log(c.Critical,p([i,...n]))}flush(){}}t.AbstractMessageLogger=f;class E extends D{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!C.isWindows}trace(i,...n){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${w()}][0m`,i,...n):console.log(`[main ${w()}]`,i,...n))}debug(i,...n){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${w()}][0m`,i,...n):console.log(`[main ${w()}]`,i,...n))}info(i,...n){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${w()}][0m`,i,...n):console.log(`[main ${w()}]`,i,...n))}warn(i,...n){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${w()}][0m`,i,...n):console.warn(`[main ${w()}]`,i,...n))}error(i,...n){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${w()}][0m`,i,...n):console.error(`[main ${w()}]`,i,...n))}critical(i,...n){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${w()}][0m`,i,...n):console.error(`[main ${w()}]`,i,...n))}dispose(){}flush(){}}t.ConsoleMainLogger=E;class l extends D{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...n){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}t.ConsoleLogger=l;class h extends D{constructor(i,n=t.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,L.toErrorMessage)(i,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=h;class v extends D{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const o of this.logServices)o.trace(i,...n)}debug(i,...n){for(const o of this.logServices)o.debug(i,...n)}info(i,...n){for(const o of this.logServices)o.info(i,...n)}warn(i,...n){for(const o of this.logServices)o.warn(i,...n)}error(i,...n){for(const o of this.logServices)o.error(i,...n)}critical(i,...n){for(const o of this.logServices)o.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}t.MultiplexLogService=v;class m extends I.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}t.LogService=m;class y extends I.Disposable{constructor(i,n){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,n?.always?c.Trace:this.logLevel,n),this.loggers.set(i.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=y;class u{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(i){}getLevel(){return c.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}t.NullLogService=u;function s(r){if(r.verbose)return c.Trace;if(typeof r.logLevel=="string"){const i=a(r.logLevel.toLowerCase());if(i!==void 0)return i}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=s;function a(r){switch(r){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=a;function e(r){switch(r){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=e});var oe=this&&this.__param||function(z,t){return function(L,P){t(L,P,z)}};define(J[98],Y([0,1,40,3,28,10,2,9,6,13,21,15]),function(z,t,L,P,I,C,T,w,c,g,p,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let f=class extends T.Disposable{constructor(l,h){super();this.environmentService=l,this.logService=h,this.processesLimiter=new P.Limiter(5)}async postUninstall(l){const h=this.parseScript(l,"uninstall");return h&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${v}`)))),g.Promises.rm(this.getExtensionStoragePath(l)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(l,h){const v=`vscode:${h}`;if(l.location.scheme===w.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[v]=="string"){const m=l.manifest.scripts[v].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${v} should be a node script`),null):{script:(0,c.join)(l.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(l,h,v,m,y){return new Promise((u,s)=>{const a=this.start(l,h,v,y);let e;const r=i=>{e&&(clearTimeout(e),e=null),i?s(i):u(void 0)};a.on("error",i=>{r((0,I.toErrorMessage)(i)||"Unknown")}),a.on("exit",(i,n)=>{r(i?`post-${h} process exited with code ${i}`:void 0)}),m&&(e=setTimeout(()=>{e=null,a.kill(),s("timed out")},5e3))})}start(l,h,v,m){const y={silent:!0,execArgv:void 0},u=(0,L.fork)(l,[`--type=extension-post-${h}`,...v],y);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const s=C.Event.fromNodeEventEmitter(u.stdout,"data"),a=C.Event.fromNodeEventEmitter(u.stderr,"data");s(i=>this.logService.info(m.identifier.id,m.manifest.version,`post-${h}`,i)),a(i=>this.logService.error(m.identifier.id,m.manifest.version,`post-${h}`,i));const e=C.Event.any(C.Event.map(s,i=>({data:`%c${i}`,format:[""]})),C.Event.map(a,i=>({data:`%c${i}`,format:["color: red"]})));return C.Event.debounce(e,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(m.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),u}getExtensionStoragePath(l){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};f=de([oe(0,p.IEnvironmentService),oe(1,D.ILogService)],f),t.ExtensionsLifecycle=f}),define(J[99],Y([0,1,20,3,7,10,2,6,35,15]),function(z,t,L,P,I,C,T,w,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class p extends T.Disposable{constructor(f){super();this.logService=f,this._onDidErrorOccur=this._register(new C.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new P.ThrottledDelayer(0))}watch(f,E){return E.recursive?this.watchRecursive(f,E):this.watchNonRecursive(f)}watchRecursive(f,E){const l={path:this.toFilePath(f),excludes:E.excludes},h=(0,L.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,T.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(f=>(0,I.onUnexpectedError)(f))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(f=>this._onDidChangeFile.fire((0,c.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(f,E){return f.watch(E)}watchNonRecursive(f){const E=this.createNonRecursiveWatcher(this.toFilePath(f),h=>this._onDidChangeFile.fire((0,c.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===g.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{E.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)});return(0,T.combinedDisposable)(E,l)}onWatcherLogMessage(f){f.type==="error"&&this._onDidErrorOccur.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,w.normalize)(f.fsPath)}}t.AbstractDiskFileSystemProvider=p}),define(J[100],Y([0,1,20,3,17,24,10,135,2,101,9,102,19,38,82,16,53,15]),function(z,t,L,P,I,C,T,w,c,g,p,D,f,E,l,h,v,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let y=class Ue extends c.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new T.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new h.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new h.FileChangesEvent(a,!0)))),this.watchedResources=g.TernarySearchTree.forUris(a=>{const e=this.getProvider(a.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new P.ResourceQueue)}registerProvider(s,a){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,D.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:a});const e=new c.DisposableStore;return e.add(a.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(a)))),e.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:s}))),typeof a.onDidErrorOccur=="function"&&e.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:a}),this.provider.delete(s),(0,c.dispose)(e)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(e){a.push(e)}}),!this.provider.has(s)&&await P.Promises.settled(a)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,a){const e=this.provider.get(s.scheme);return!!(e&&e.capabilities&a)}listCapabilities(){return w.Iterable.map(this.provider,([s,a])=>({scheme:s,capabilities:a.capabilities}))}async withProvider(s){if(!(0,f.isAbsolutePath)(s))throw new h.FileOperationError((0,l.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const a=this.provider.get(s.scheme);if(!a){const e=new Error;throw e.name="ENOPRO",e.message=(0,l.localize)(1,null,s.toString()),e}return a}async withReadProvider(s){const a=await this.withProvider(s);if((0,h.hasOpenReadWriteCloseCapability)(a)||(0,h.hasReadWriteCapability)(a)||(0,h.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const a=await this.withProvider(s);if((0,h.hasOpenReadWriteCloseCapability)(a)||(0,h.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,a){try{return await this.doResolveFile(s,a)}catch(e){throw(0,h.toFileSystemProviderErrorCode)(e)===h.FileSystemProviderErrorCode.FileNotFound?new h.FileOperationError((0,l.localize)(2,null,this.resourceForError(s)),1):(0,h.ensureFileSystemProviderError)(e)}}async doResolveFile(s,a){const e=await this.withProvider(s),r=this.isPathCaseSensitive(e),i=a?.resolveTo,n=a?.resolveSingleChildDescendants,o=a?.resolveMetadata,d=await e.stat(s);let S;return this.toFileStat(e,s,d,void 0,!!o,(R,b)=>(S||(S=g.TernarySearchTree.forUris(()=>!r),S.set(s,!0),i&&S.fill(!0,i)),S.get(R.resource)||S.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&n?b===1:!1))}async toFileStat(s,a,e,r,i,n){const{providerExtUri:o}=this.getExtUri(s),d={resource:a,name:o.basename(a),isFile:(e.type&h.FileType.File)!=0,isDirectory:(e.type&h.FileType.Directory)!=0,isSymbolicLink:(e.type&h.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&h.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,h.etag)({mtime:e.mtime,size:e.size})};if(d.isDirectory&&n(d,r)){try{const S=await s.readdir(a),R=await P.Promises.settled(S.map(async([b,O])=>{try{const M=o.joinPath(a,b),G=i?await s.stat(M):{type:O};return await this.toFileStat(s,M,G,S.length,i,n)}catch(M){return this.logService.trace(M),null}}));d.children=(0,L.coalesce)(R)}catch(S){this.logService.trace(S),d.children=[]}return d}return d}async resolveAll(s){return P.Promises.settled(s.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(s){const a=await this.withProvider(s);try{return!!await a.stat(s)}catch(e){return!1}}async canCreateFile(s,a){try{await this.doValidateCreateFile(s,a)}catch(e){return e}return!0}async doValidateCreateFile(s,a){if(!a?.overwrite&&await this.exists(s))throw new h.FileOperationError((0,l.localize)(3,null,this.resourceForError(s)),3,a)}async createFile(s,a=I.VSBuffer.fromString(""),e){await this.doValidateCreateFile(s,e);const r=await this.writeFile(s,a);return this._onDidRunOperation.fire(new h.FileOperationEvent(s,0,r)),r}async writeFile(s,a,e){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,s,e)||await this.mkdirp(r,i.dirname(s));let o;if((0,h.hasReadWriteCapability)(r)&&!(a instanceof I.VSBuffer))if((0,E.isReadableStream)(a)){const d=await(0,E.peekStream)(a,3);d.ended?o=I.VSBuffer.concat(d.buffer):o=d}else o=(0,E.peekReadable)(a,d=>I.VSBuffer.concat(d),3);else o=a;!(0,h.hasOpenReadWriteCloseCapability)(r)||(0,h.hasReadWriteCapability)(r)&&o instanceof I.VSBuffer?await this.doWriteUnbuffered(r,s,e,o):await this.doWriteBuffered(r,s,e,o instanceof I.VSBuffer?(0,I.bufferToReadable)(o):o)}catch(n){throw new h.FileOperationError((0,l.localize)(4,null,this.resourceForError(s),(0,h.ensureFileSystemProviderError)(n).toString()),(0,h.toFileOperationResult)(n),e)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,a,e){if(!!e?.unlock&&!(s.capabilities&8192))throw new Error((0,l.localize)(5,null,this.resourceForError(a)));let i;try{i=await s.stat(a)}catch(n){return}if((i.type&h.FileType.Directory)!=0)throw new h.FileOperationError((0,l.localize)(6,null,this.resourceForError(a)),0,e);if(this.throwIfFileIsReadonly(a,i),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==h.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&e.mtime<i.mtime&&e.etag!==(0,h.etag)({mtime:e.mtime,size:i.size}))throw new h.FileOperationError((0,l.localize)(7,null),3,e);return i}async readFile(s,a){const e=await this.withReadProvider(s);return a?.atomic?this.doReadFileAtomic(e,s,a):this.doReadFile(e,s,a)}async doReadFileAtomic(s,a,e){return new Promise((r,i)=>{this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{try{const n=await this.doReadFile(s,a,e);r(n)}catch(n){i(n)}})})}async doReadFile(s,a,e){const r=await this.doReadFileStream(s,a,{...e,preferUnbuffered:!0});return{...r,value:await(0,I.streamToBuffer)(r.value)}}async readFileStream(s,a){const e=await this.withReadProvider(s);return this.doReadFileStream(e,s,a)}async doReadFileStream(s,a,e){const r=new C.CancellationTokenSource,i=this.validateReadFile(a,e).then(o=>o,o=>{throw r.cancel(),o});let n;try{return typeof e?.etag=="string"&&e.etag!==h.ETAG_DISABLED&&await i,!((0,h.hasOpenReadWriteCloseCapability)(s)||(0,h.hasFileReadStreamCapability)(s))||(0,h.hasReadWriteCapability)(s)&&e?.preferUnbuffered?n=this.readFileUnbuffered(s,a,e):(0,h.hasFileReadStreamCapability)(s)?n=this.readFileStreamed(s,a,r.token,e):n=this.readFileBuffered(s,a,r.token,e),{...await i,value:n}}catch(o){n&&await(0,E.consumeStream)(n);const d=(0,l.localize)(8,null,this.resourceForError(a),(0,h.ensureFileSystemProviderError)(o).toString());throw o instanceof h.NotModifiedSinceFileOperationError?new h.NotModifiedSinceFileOperationError(d,o.stat,e):new h.FileOperationError(d,(0,h.toFileOperationResult)(o),e)}}readFileStreamed(s,a,e,r=Object.create(null)){const i=s.readFileStream(a,r,e);return(0,E.transform)(i,{data:n=>n instanceof I.VSBuffer?n:I.VSBuffer.wrap(n),error:n=>new h.FileOperationError((0,l.localize)(9,null,this.resourceForError(a),(0,h.ensureFileSystemProviderError)(n).toString()),(0,h.toFileOperationResult)(n),r)},n=>I.VSBuffer.concat(n))}readFileBuffered(s,a,e,r=Object.create(null)){const i=(0,I.newWriteableBufferStream)();return(0,v.readFileIntoStream)(s,a,i,n=>n,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:n=>new h.FileOperationError((0,l.localize)(10,null,this.resourceForError(a),(0,h.ensureFileSystemProviderError)(n).toString()),(0,h.toFileOperationResult)(n),r)},e),i}readFileUnbuffered(s,a,e){const r=(0,E.newWriteableStream)(i=>I.VSBuffer.concat(i));return(async()=>{try{let i=await s.readFile(a);typeof e?.position=="number"&&(i=i.slice(e.position)),typeof e?.length=="number"&&(i=i.slice(0,e.length)),this.validateReadFileLimits(a,i.byteLength,e),r.end(I.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(s,a){const e=await this.resolve(s,{resolveMetadata:!0});if(e.isDirectory)throw new h.FileOperationError((0,l.localize)(11,null,this.resourceForError(s)),0,a);if(typeof a?.etag=="string"&&a.etag!==h.ETAG_DISABLED&&a.etag===e.etag)throw new h.NotModifiedSinceFileOperationError((0,l.localize)(12,null),e,a);return this.validateReadFileLimits(s,e.size,a),e}validateReadFileLimits(s,a,e){if(e?.limits){let r;if(typeof e.limits.memory=="number"&&a>e.limits.memory&&(r=9),typeof e.limits.size=="number"&&a>e.limits.size&&(r=7),typeof r=="number")throw new h.FileOperationError((0,l.localize)(13,null,this.resourceForError(s)),r)}}async canMove(s,a,e){return this.doCanMoveCopy(s,a,"move",e)}async canCopy(s,a,e){return this.doCanMoveCopy(s,a,"copy",e)}async doCanMoveCopy(s,a,e,r){if(s.toString()!==a.toString())try{const i=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(i,s,n,a,e,r)}catch(i){return i}return!0}async move(s,a,e){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=await this.doMoveCopy(r,s,i,a,"move",!!e),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(s,n==="move"?2:3,o)),o}async copy(s,a,e){const r=await this.withReadProvider(s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=await this.doMoveCopy(r,s,i,a,"copy",!!e),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(s,n==="copy"?3:2,o)),o}async doMoveCopy(s,a,e,r,i,n){if(a.toString()===r.toString())return i;const{exists:o,isSameResourceWithDifferentPathCase:d}=await this.doValidateMoveCopy(s,a,e,r,i,n);if(o&&!d&&n&&await this.del(r,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(r)),i==="copy"){if(s===e&&(0,h.hasFileFolderCopyCapability)(s))await s.copy(a,r,{overwrite:n});else{const S=await this.resolve(a);S.isDirectory?await this.doCopyFolder(s,S,e,r):await this.doCopyFile(s,a,e,r)}return i}else return s===e?(await s.rename(a,r,{overwrite:n}),i):(await this.doMoveCopy(s,a,e,r,"copy",n),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(s,a,e,r){if((0,h.hasOpenReadWriteCloseCapability)(s)&&(0,h.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(s,a,e,r);if((0,h.hasOpenReadWriteCloseCapability)(s)&&(0,h.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(s,a,e,r);if((0,h.hasReadWriteCapability)(s)&&(0,h.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(s,a,e,r);if((0,h.hasReadWriteCapability)(s)&&(0,h.hasReadWriteCapability)(e))return this.doPipeUnbuffered(s,a,e,r)}async doCopyFolder(s,a,e,r){await e.mkdir(r),Array.isArray(a.children)&&await P.Promises.settled(a.children.map(async i=>{const n=this.getExtUri(e).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(s,await this.resolve(i.resource),e,n):this.doCopyFile(s,i.resource,e,n)}))}async doValidateMoveCopy(s,a,e,r,i,n){let o=!1;if(s===e){const{providerExtUri:S,isPathCaseSensitive:R}=this.getExtUri(s);if(R||(o=S.isEqual(a,r)),o&&i==="copy")throw new Error((0,l.localize)(14,null,this.resourceForError(a),this.resourceForError(r)));if(!o&&S.isEqualOrParent(r,a))throw new Error((0,l.localize)(15,null,this.resourceForError(a),this.resourceForError(r)))}const d=await this.exists(r);if(d&&!o){if(!n)throw new h.FileOperationError((0,l.localize)(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(s===e){const{providerExtUri:S}=this.getExtUri(s);if(S.isEqualOrParent(a,r))throw new Error((0,l.localize)(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:d,isSameResourceWithDifferentPathCase:o}}getExtUri(s){const a=this.isPathCaseSensitive(s);return{providerExtUri:a?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(a,s);const e=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(s,0,e)),e}async mkdirp(s,a){const e=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(a,r.dirname(a));)try{if(((await s.stat(a)).type&h.FileType.Directory)==0)throw new Error((0,l.localize)(18,null,this.resourceForError(a)));break}catch(i){if((0,h.toFileSystemProviderErrorCode)(i)!==h.FileSystemProviderErrorCode.FileNotFound)throw i;e.push(r.basename(a)),a=r.dirname(a)}for(let i=e.length-1;i>=0;i--){a=r.joinPath(a,e[i]);try{await s.mkdir(a)}catch(n){if((0,h.toFileSystemProviderErrorCode)(n)!==h.FileSystemProviderErrorCode.FileExists)throw n}}}async canDelete(s,a){try{await this.doValidateDelete(s,a)}catch(e){return e}return!0}async doValidateDelete(s,a){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!a?.useTrash&&!(e.capabilities&4096))throw new Error((0,l.localize)(19,null,this.resourceForError(s)));let i;try{i=await e.stat(s)}catch(o){}if(i)this.throwIfFileIsReadonly(s,i);else throw new h.FileOperationError((0,l.localize)(20,null,this.resourceForError(s)),1);if(!!!a?.recursive){const o=await this.resolve(s);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,l.localize)(21,null,this.resourceForError(s)))}return e}async del(s,a){const e=await this.doValidateDelete(s,a),r=!!a?.useTrash,i=!!a?.recursive;await e.delete(s,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new h.FileOperationEvent(s,1))}onDidChangeFile(s,a){this._onDidChangeFilesRaw.fire({changes:s});let e,r;{for(const i of s)this.watchedResources.has(i.resource)?(e||(e=[]),e.push(i)):(r||(r=[]),r.push(i));e&&this._onDidFilesChange.fire(new h.FileChangesEvent(e,!a))}if(r){const i=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&Ue.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,a={recursive:!1,excludes:[]}){const e=new c.DisposableStore;let r=!1,i=()=>{r=!0};return e.add((0,c.toDisposable)(()=>i())),this.doWatch(s,a).then(n=>{r?(0,c.dispose)(n):i=()=>(0,c.dispose)(n)},n=>this.logService.error(n)),a.recursive||(this.watchedResources.set(s,(this.watchedResources.get(s)??0)+1),e.add((0,c.toDisposable)(()=>{const n=this.watchedResources.get(s);typeof n=="number"&&(n<=1?this.watchedResources.delete(s):this.watchedResources.set(s,n-1))}))),e}async doWatch(s,a){const e=await this.withProvider(s),r=this.toWatchKey(e,s,a);let i=this.activeWatchers.get(r);return i||(i={count:0,disposable:e.watch(s,a)},this.activeWatchers.set(r,i)),i.count+=1,(0,c.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,c.dispose)(i.disposable),this.activeWatchers.delete(r)))})}toWatchKey(s,a,e){const{providerExtUri:r}=this.getExtUri(s);return[r.getComparisonKey(a),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,c.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,a,e,r){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{const i=await s.open(a,{create:!0,unlock:e?.unlock??!1});try{(0,E.isReadableStream)(r)||(0,E.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(s,i,r):await this.doWriteReadableBufferedQueued(s,i,r)}catch(n){throw(0,h.ensureFileSystemProviderError)(n)}finally{await s.close(i)}})}async doWriteStreamBufferedQueued(s,a,e){let r=0,i;if((0,E.isReadableBufferedStream)(e)){if(e.buffer.length>0){const n=I.VSBuffer.concat(e.buffer);await this.doWriteBuffer(s,a,n,n.byteLength,r,0),r+=n.byteLength}if(e.ended)return;i=e.stream}else i=e;return new Promise((n,o)=>{(0,E.listenStream)(i,{onData:async d=>{i.pause();try{await this.doWriteBuffer(s,a,d,d.byteLength,r,0)}catch(S){return o(S)}r+=d.byteLength,setTimeout(()=>i.resume())},onError:d=>o(d),onEnd:()=>n()})})}async doWriteReadableBufferedQueued(s,a,e){let r=0,i;for(;(i=e.read())!==null;)await this.doWriteBuffer(s,a,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(s,a,e,r,i,n){let o=0;for(;o<r;)o+=await s.write(a,i+o,e.buffer,n+o,r-o)}async doWriteUnbuffered(s,a,e,r){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,a,e,r))}async doWriteUnbufferedQueued(s,a,e,r){let i;r instanceof I.VSBuffer?i=r:(0,E.isReadableStream)(r)?i=await(0,I.streamToBuffer)(r):(0,E.isReadableBufferedStream)(r)?i=await(0,I.bufferedStreamToBuffer)(r):i=(0,I.readableToBuffer)(r),await s.writeFile(a,i.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(s,a,e,r){return this.writeQueue.queueFor(r,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,a,e,r))}async doPipeBufferedQueued(s,a,e,r){let i,n;try{i=await s.open(a,{create:!1}),n=await e.open(r,{create:!0,unlock:!1});const o=I.VSBuffer.alloc(this.BUFFER_SIZE);let d=0,S=0,R=0;do R=await s.read(i,d,o.buffer,S,o.byteLength-S),await this.doWriteBuffer(e,n,o,R,d,S),d+=R,S+=R,S===o.byteLength&&(S=0);while(R>0)}catch(o){throw(0,h.ensureFileSystemProviderError)(o)}finally{await P.Promises.settled([typeof i=="number"?s.close(i):Promise.resolve(),typeof n=="number"?e.close(n):Promise.resolve()])}}async doPipeUnbuffered(s,a,e,r){return this.writeQueue.queueFor(r,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,a,e,r))}async doPipeUnbufferedQueued(s,a,e,r){return e.writeFile(r,await s.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,a,e,r){return this.writeQueue.queueFor(r,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,a,e,r))}async doPipeUnbufferedToBufferedQueued(s,a,e,r){const i=await e.open(r,{create:!0,unlock:!1});try{const n=await s.readFile(a);await this.doWriteBuffer(e,i,I.VSBuffer.wrap(n),n.byteLength,0,0)}catch(n){throw(0,h.ensureFileSystemProviderError)(n)}finally{await e.close(i)}}async doPipeBufferedToUnbuffered(s,a,e,r){const i=await(0,I.streamToBuffer)(this.readFileBuffered(s,a,C.CancellationToken.None));await this.doWriteUnbuffered(e,r,void 0,i)}throwIfFileSystemIsReadonly(s,a){if(s.capabilities&2048)throw new h.FileOperationError((0,l.localize)(22,null,this.resourceForError(a)),6);return s}throwIfFileIsReadonly(s,a){if((a.permissions??0)&h.FilePermission.Readonly)throw new h.FileOperationError((0,l.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===p.Schemas.file?s.fsPath:s.toString(!0)}};y.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},y=de([oe(0,m.ILogService)],y),t.FileService=y}),define(J[103],Y([0,1,48,136,3,17,10,47,6,12,19,38,13,84,16,53,94,95,96,99,28]),function(z,t,L,P,I,C,T,w,c,g,p,D,f,E,l,h,v,m,y,u,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,P.gracefulify)(L)}catch(e){console.error(`Error enabling graceful-fs: ${(0,s.toErrorMessage)(e)}`)}})();class a extends u.AbstractDiskFileSystemProvider{constructor(r,i){super(r);this.options=i,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,g.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:i,symbolicLink:n}=await f.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(r){try{const i=await f.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async o=>{try{let d;o.isSymbolicLink()?d=(await this.stat((0,p.joinPath)(r,o.name))).type:d=this.toType(o),n.push([o.name,d])}catch(d){this.logService.trace(d)}})),n}catch(i){throw this.toFileSystemProviderError(i)}}toType(r,i){let n;return i?.dangling?n=l.FileType.Unknown:r.isFile()?n=l.FileType.File:r.isDirectory()?n=l.FileType.Directory:n=l.FileType.Unknown,i&&(n|=l.FileType.SymbolicLink),n}async readFile(r){try{const i=this.toFilePath(r);return await f.Promises.readFile(i)}catch(i){throw this.toFileSystemProviderError(i)}}readFileStream(r,i,n){const o=(0,D.newWriteableStream)(d=>C.VSBuffer.concat(d.map(S=>C.VSBuffer.wrap(S))).buffer);return(0,h.readFileIntoStream)(this,r,o,d=>d.buffer,{...i,bufferSize:256*1024},n),o}async writeFile(r,i,n){let o;try{const d=this.toFilePath(r);if(!n.create||!n.overwrite){if(await f.Promises.exists(d)){if(!n.overwrite)throw(0,l.createFileSystemProviderError)((0,E.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,l.createFileSystemProviderError)((0,E.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(r,{create:!0,unlock:n.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(r,d)}finally{typeof o=="number"&&await this.close(o)}}async open(r,i){try{const n=this.toFilePath(r);if((0,l.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:S}=await f.SymlinkSupport.stat(n);S.mode&128||await f.Promises.chmod(n,S.mode|128)}catch(S){this.logService.trace(S)}let o;if((0,l.isFileOpenForWriteOptions)(i)){if(g.isWindows)try{await f.Promises.truncate(n,0),o="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}o||(o="w")}else o="r";const d=await f.Promises.open(n,o);return this.mapHandleToPos.set(d,0),(0,l.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(d,r),d}catch(n){throw(0,l.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(r,n):this.toFileSystemProviderError(n)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await f.Promises.fdatasync(r)}catch(i){this.canFlush=!1,this.logService.error(i)}return await f.Promises.close(r)}catch(i){throw this.toFileSystemProviderError(i)}}async read(r,i,n,o,d){const S=this.normalizePos(r,i);let R=null;try{const b=await f.Promises.read(r,n,o,d,S);return typeof b=="number"?R=b:R=b.bytesRead,R}catch(b){throw this.toFileSystemProviderError(b)}finally{this.updatePos(r,S,R)}}normalizePos(r,i){return i===this.mapHandleToPos.get(r)?null:i}updatePos(r,i,n){const o=this.mapHandleToPos.get(r);typeof o=="number"&&(typeof i=="number"||(typeof n=="number"?this.mapHandleToPos.set(r,o+n):this.mapHandleToPos.delete(r)))}async write(r,i,n,o,d){return(0,I.retry)(()=>this.doWrite(r,i,n,o,d),100,3)}async doWrite(r,i,n,o,d){const S=this.normalizePos(r,i);let R=null;try{const b=await f.Promises.write(r,n,o,d,S);return typeof b=="number"?R=b:R=b.bytesWritten,R}catch(b){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),b)}finally{this.updatePos(r,S,R)}}async mkdir(r){try{await f.Promises.mkdir(this.toFilePath(r))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(r,i){try{const n=this.toFilePath(r);await this.doDelete(n,i)}catch(n){throw this.toFileSystemProviderError(n)}}async doDelete(r,i){i.recursive?await f.Promises.rm(r,f.RimRafMode.MOVE):await f.Promises.unlink(r)}async rename(r,i,n){const o=this.toFilePath(r),d=this.toFilePath(i);if(o!==d)try{await this.validateTargetDeleted(r,i,"move",n.overwrite),await f.Promises.move(o,d)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,E.localize)(2,null,(0,c.basename)(o),(0,c.basename)((0,c.dirname)(d)),S.toString()))),this.toFileSystemProviderError(S)}}async copy(r,i,n){const o=this.toFilePath(r),d=this.toFilePath(i);if(o!==d)try{await this.validateTargetDeleted(r,i,"copy",n.overwrite),await f.Promises.copy(o,d,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,E.localize)(3,null,(0,c.basename)(o),(0,c.basename)((0,c.dirname)(d)),S.toString()))),this.toFileSystemProviderError(S)}}async validateTargetDeleted(r,i,n,o){const d=this.toFilePath(r),S=this.toFilePath(i);let R=!1;if(!!(this.capabilities&1024)||(R=(0,w.isEqual)(d,S,!0)),R&&n==="copy")throw(0,l.createFileSystemProviderError)((0,E.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!R&&await f.Promises.exists(S)){if(!o)throw(0,l.createFileSystemProviderError)((0,E.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(r,i,n){let o,d=!1;return this.options?.watcher?.usePolling?d=!1:d=this.options?.legacyWatcher==="on",d?o=m.FileWatcher:o=y.FileWatcher,new o(S=>r(S),S=>i(S),n,this.options?.watcher)}doWatch(r,i){const n=this.options?.watcher?.usePolling;if(n===!0)for(const o of i)o.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(n))for(const o of i)n.includes(o.path)&&(o.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(r,i)}createNonRecursiveWatcher(r,i,n,o){return new v.FileWatcher(r,d=>i(d),d=>n(d),o)}toFileSystemProviderError(r){if(r instanceof l.FileSystemProviderError)return r;let i;switch(r.code){case"ENOENT":i=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=l.FileSystemProviderErrorCode.NoPermissions;break;default:i=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(r,i)}async toFileSystemProviderWriteError(r,i){let n=this.toFileSystemProviderError(i);if(r&&n.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await f.SymlinkSupport.stat(this.toFilePath(r));o.mode&128||(n=(0,l.createFileSystemProviderError)(i,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return n}}t.DiskFileSystemProvider=a}),define(J[104],Y([0,1,16,15]),function(z,t,L,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function I(c,g,p,D,f){try{const E=await new Promise((h,v)=>{z(["spdlog"],h,v)});E.setFlushOn(P.LogLevel.Trace);const l=await E.createAsyncRotatingLogger(c,g,p,D);return f&&l.clearFormatters(),l}catch(E){console.error(E)}return null}function C(c,g,p,D){const f=z.__$__nodeRequire("spdlog");return f.setFlushOn(P.LogLevel.Trace),f.createRotatingLogger(c,g,p,D)}t.createRotatingLogger=C;function T(c,g,p){switch(g){case P.LogLevel.Trace:c.trace(p);break;case P.LogLevel.Debug:c.debug(p);break;case P.LogLevel.Info:c.info(p);break;case P.LogLevel.Warning:c.warn(p);break;case P.LogLevel.Error:c.error(p);break;case P.LogLevel.Critical:c.critical(p);break;default:throw new Error("Invalid log level")}}class w extends P.AbstractMessageLogger{constructor(g,p,D,f,E){super();this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(g,p,D,f),this._register(this.onDidChangeLogLevel(l=>{this._logger&&this._logger.setLevel(l)}))}async _createSpdLogLogger(g,p,D,f){const E=D?6:1,l=30/E*L.ByteSize.MB,h=await I(g,p,l,E,f);if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:v,message:m}of this.buffer)T(this._logger,v,m);this.buffer=[]}}log(g,p){this._logger?T(this._logger,g,p):this.getLevel()<=g&&this.buffer.push({level:g,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=w}),define(J[32],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,L.createDecorator)("productService")}),define(J[25],Y([0,1,56,11]),function(z,t,L,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class I{constructor(){this.data=new Map}add(T,w){L.ok(P.isString(T)),L.ok(P.isObject(w)),L.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,w)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new I}),define(J[105],Y([0,1,10,25]),function(z,t,L,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function I(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class C{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,g){this.schemasById[I(c)]=g,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new C;P.Registry.add(t.Extensions.JSONContribution,T)}),define(J[33],Y([0,1,20,10,11,73,105,25]),function(z,t,L,P,I,C,T,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var c;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(c=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var g;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const p=w.Registry.as(T.Extensions.JSONContribution);class D{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new P.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new P.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(u,s=!0){this.registerConfigurations([u],s)}registerConfigurations(u,s=!0){const a=this.doRegisterConfigurations(u,s);p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(u){const s=this.doDeregisterConfigurations(u);p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}updateConfigurations({add:u,remove:s}){const a=[];a.push(...this.doDeregisterConfigurations(s)),a.push(...this.doRegisterConfigurations(u,!1)),p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,L.distinct)(a))}registerDefaultConfigurations(u){const s=[],a=[];for(const e of u)for(const r in e)if(s.push(r),t.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]={...this.defaultValues[r]||{},...e[r]};const i={type:"object",default:this.defaultValues[r],description:C.localize(1,null,r),$ref:t.resourceLanguageSettingsSchemaId};a.push(E(r)),this.configurationProperties[r]=i,this.defaultLanguageConfigurationOverridesNode.properties[r]=i}else{this.defaultValues[r]=e[r];const i=this.configurationProperties[r];i&&(this.updatePropertyDefaultValue(r,i),this.updateSchema(r,i))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterDefaultConfigurations(u){const s=[];for(const a of u)for(const e in a)if(s.push(e),delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const r=this.configurationProperties[e];r&&(this.updatePropertyDefaultValue(e,r),this.updateSchema(e,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const s of u)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,s){const a=[];return u.forEach(e=>{a.push(...this.validateAndRegisterProperties(e,s,e.extensionInfo)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),a}doDeregisterConfigurations(u){const s=[],a=e=>{if(e.properties)for(const r in e.properties)s.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,e.properties[r]);e.allOf&&e.allOf.forEach(r=>a(r))};for(const e of u){a(e);const r=this.configurationContributors.indexOf(e);r!==-1&&this.configurationContributors.splice(r,1)}return s}validateAndRegisterProperties(u,s=!0,a,e=3){e=I.isUndefinedOrNull(u.scope)?e:u.scope;let r=[],i=u.properties;if(i)for(let o in i){if(s&&v(o)){delete i[o];continue}const d=i[o];if(this.updatePropertyDefaultValue(o,d),t.OVERRIDE_PROPERTY_PATTERN.test(o)?d.scope=void 0:(d.scope=I.isUndefinedOrNull(d.scope)?e:d.scope,d.restricted=I.isUndefinedOrNull(d.restricted)?!!a?.restrictedConfigurations?.includes(o):d.restricted),i[o].hasOwnProperty("included")&&!i[o].included){this.excludedConfigurationProperties[o]=i[o],delete i[o];continue}else this.configurationProperties[o]=i[o];!i[o].deprecationMessage&&i[o].markdownDeprecationMessage&&(i[o].deprecationMessage=i[o].markdownDeprecationMessage),r.push(o)}let n=u.allOf;if(n)for(let o of n)r.push(...this.validateAndRegisterProperties(o,s,a,e));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(u){const s=a=>{let e=a.properties;if(e)for(const i in e)this.updateSchema(i,e[i]);let r=a.allOf;r&&r.forEach(s)};s(u)}updateSchema(u,s){switch(t.allSettings.properties[u]=s,s.scope){case 1:t.applicationSettings.properties[u]=s;break;case 2:t.machineSettings.properties[u]=s;break;case 6:t.machineOverridableSettings.properties[u]=s;break;case 3:t.windowSettings.properties[u]=s;break;case 4:t.resourceSettings.properties[u]=s;break;case 5:t.resourceSettings.properties[u]=s,this.resourceLanguageSettingsSchema.properties[u]=s;break}}removeFromSchema(u,s){switch(delete t.allSettings.properties[u],s.scope){case 1:delete t.applicationSettings.properties[u];break;case 2:delete t.machineSettings.properties[u];break;case 6:delete t.machineOverridableSettings.properties[u];break;case 3:delete t.windowSettings.properties[u];break;case 4:case 5:delete t.resourceSettings.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const s=`[${u}]`,a={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,a),t.allSettings.properties[s]=a,t.applicationSettings.properties[s]=a,t.machineSettings.properties[s]=a,t.machineOverridableSettings.properties[s]=a,t.windowSettings.properties[s]=a,t.resourceSettings.properties[s]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,s){let a=this.defaultValues[u];I.isUndefined(a)&&(a=s.default),I.isUndefined(a)&&(a=l(s.type)),s.default=a}}const f="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(f);function E(y){return y.substring(1,y.length-1)}t.overrideIdentifierFromKey=E;function l(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=l;const h=new D;w.Registry.add(t.Extensions.Configuration,h);function v(y){return y.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(y)?C.localize(5,null,y):h.getConfigurationProperties()[y]!==void 0?C.localize(6,null,y):null:C.localize(4,null)}t.validateProperty=v;function m(){const y=[],u=h.getConfigurationProperties();for(const s of Object.keys(u))y.push([s,u[s].scope]);return y.push(["launch",4]),y.push(["task",4]),y}t.getScopes=m}),define(J[26],Y([0,1,18,11,8,33,14,25]),function(z,t,L,P,I,C,T,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,T.createDecorator)("configurationService");function c(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof I.URI)}t.isConfigurationOverrides=c;var g;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(g=t.ConfigurationTarget||(t.ConfigurationTarget={}));function p(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=p;function D(r,i){const n=i?r?i.keys.filter(M=>r.keys.indexOf(M)===-1):[...i.keys]:[],o=r?i?r.keys.filter(M=>i.keys.indexOf(M)===-1):[...r.keys]:[],d=[];if(i&&r){for(const M of r.keys)if(i.keys.indexOf(M)!==-1){const G=m(r.contents,M),ee=m(i.contents,M);L.equals(G,ee)||d.push(M)}}const S=[],R=M=>{const G={};for(const ee of M)for(const ce of ee.identifiers)G[a(ce)]=ee;return G},b=i?R(i.overrides):{},O=r?R(r.overrides):{};if(Object.keys(b).length)for(const M of n){const G=b[M];G&&S.push([(0,C.overrideIdentifierFromKey)(M),G.keys])}if(Object.keys(O).length)for(const M of o){const G=O[M];G&&S.push([(0,C.overrideIdentifierFromKey)(M),G.keys])}if(Object.keys(b).length&&Object.keys(O).length)for(const M of d){const G=O[M],ee=b[M];if(G&&ee){const ce=D({contents:G.contents,keys:G.keys,overrides:[]},{contents:ee.contents,keys:ee.keys,overrides:[]});S.push([(0,C.overrideIdentifierFromKey)(M),[...ce.added,...ce.removed,...ce.updated]])}}return{added:n,removed:o,updated:d,overrides:S}}t.compare=D;function f(r,i){const n=[];for(const o of Object.keys(r))if(C.OVERRIDE_PROPERTY_PATTERN.test(o)){const d={};for(const S in r[o])d[S]=r[o][S];n.push({identifiers:[(0,C.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(d),contents:E(d,i)})}return n}t.toOverrides=f;function E(r,i){const n=Object.create(null);for(let o in r)l(n,o,r[o],i);return n}t.toValuesTree=E;function l(r,i,n,o){const d=i.split("."),S=d.pop();let R=r;for(let b=0;b<d.length;b++){let O=d[b],M=R[O];switch(typeof M){case"undefined":M=R[O]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${d.slice(0,b+1).join(".")} is ${JSON.stringify(M)}`);return}R=M}if(typeof R=="object"&&R!==null)try{R[S]=n}catch(b){o(`Ignoring ${i} as ${d.join(".")} is ${JSON.stringify(R)}`)}else o(`Ignoring ${i} as ${d.join(".")} is ${JSON.stringify(R)}`)}t.addToValueTree=l;function h(r,i){const n=i.split(".");v(r,n)}t.removeFromValueTree=h;function v(r,i){const n=i.shift();if(i.length===0){delete r[n];return}if(Object.keys(r).indexOf(n)!==-1){const o=r[n];typeof o=="object"&&!Array.isArray(o)&&(v(o,i),Object.keys(o).length===0&&delete r[n])}}function m(r,i,n){function o(R,b){let O=R;for(const M of b){if(typeof O!="object"||O===null)return;O=O[M]}return O}const d=i.split("."),S=o(r,d);return typeof S=="undefined"?n:S}t.getConfigurationValue=m;function y(r,i,n){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in r?P.isObject(r[o])&&P.isObject(i[o])?y(r[o],i[o],n):n&&(r[o]=i[o]):r[o]=i[o])})}t.merge=y;function u(){const r=w.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}t.getConfigurationKeys=u;function s(){const r=Object.create(null),i=w.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let n in i){let o=i[n].default;l(r,n,o,d=>console.error(`Conflict in default settings: ${d}`))}return r}t.getDefaultValues=s;function a(r){return`[${r}]`}t.keyFromOverrideIdentifier=a;function e(r,i,n){const o=r.inspect(i),d=r.inspect(n);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:o.defaultValue}t.getMigratedSettingValue=e}),define(J[106],Y([0,1,20,10,57,2,101,18,11,8,26,33,25]),function(z,t,L,P,I,C,T,w,c,g,p,D,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class E{constructor(e={},r=[],i=[]){this._contents=e,this._keys=r,this._overrides=i,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,p.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,r){const i=this.getContentsForOverrideIdentifer(r);return i?e?(0,p.getConfigurationValue)(i,e):i:void 0}getKeysForOverrideIdentifier(e){for(const r of this.overrides)if(r.identifiers.indexOf(e)!==-1)return r.keys;return[]}override(e){let r=this.overrideConfigurations.get(e);return r||(r=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,r)),r}merge(...e){const r=w.deepClone(this.contents),i=w.deepClone(this.overrides),n=[...this.keys];for(const o of e){this.mergeContents(r,o.contents);for(const d of o.overrides){const[S]=i.filter(R=>L.equals(R.identifiers,d.identifiers));S?this.mergeContents(S.contents,d.contents):i.push(w.deepClone(d))}for(const d of o.keys)n.indexOf(d)===-1&&n.push(d)}return new E(r,n,i)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const r=this.getContentsForOverrideIdentifer(e);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const n of L.distinct([...Object.keys(this.contents),...Object.keys(r)])){let o=this.contents[n],d=r[n];d&&(typeof o=="object"&&typeof d=="object"?(o=w.deepClone(o),this.mergeContents(o,d)):o=d),i[n]=o}return new E(i,this.keys,this.overrides)}mergeContents(e,r){for(const i of Object.keys(r)){if(i in e&&c.isObject(e[i])&&c.isObject(r[i])){this.mergeContents(e[i],r[i]);continue}e[i]=w.deepClone(r[i])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?w.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const r of this.overrides)if(r.identifiers.indexOf(e)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,r){this.addKey(e),(0,p.addToValueTree)(this.contents,e,r,i=>{throw new Error(i)})}removeValue(e){this.removeKey(e)&&(0,p.removeFromValueTree)(this.contents,e)}addKey(e){let r=this.keys.length;for(let i=0;i<r;i++)e.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,e)}removeKey(e){let r=this.keys.indexOf(e);return r!==-1?(this.keys.splice(r,1),!0):!1}}t.ConfigurationModel=E;class l extends E{constructor(){const e=(0,p.getDefaultValues)(),r=(0,p.getConfigurationKeys)(),i=[];for(const n of Object.keys(e))D.OVERRIDE_PROPERTY_PATTERN.test(n)&&i.push({identifiers:[(0,D.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(e[n]),contents:(0,p.toValuesTree)(e[n],o=>console.error(`Conflict in default settings file: ${o}`))});super(e,r,i)}}t.DefaultConfigurationModel=l;class h{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,r){if(!c.isUndefinedOrNull(e)){const i=this.doParseContent(e);this.parseRaw(i,r)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,r){this._raw=e;const{contents:i,keys:n,overrides:o,restricted:d}=this.doParseRaw(e,r);this._configurationModel=new E(i,n,o),this._restrictedConfigurations=d||[]}doParseContent(e){let r={},i=null,n=[],o=[],d=[];function S(b){Array.isArray(n)?n.push(b):i!==null&&(n[i]=b)}let R={onObjectBegin:()=>{let b={};S(b),o.push(n),n=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{let b=[];S(b),o.push(n),n=b,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:S,onError:(b,O,M)=>{d.push({error:b,offset:O,length:M})}};if(e)try{I.visit(e,R),r=n[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return r}doParseRaw(e,r){const i=f.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),n=this.filter(e,i,!0,r);e=n.raw;const o=(0,p.toValuesTree)(e,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),d=Object.keys(e),S=(0,p.toOverrides)(e,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:o,keys:d,overrides:S,restricted:n.restricted}}filter(e,r,i,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:e,restricted:[]};const o={},d=[];for(let S in e)if(D.OVERRIDE_PROPERTY_PATTERN.test(S)&&i){const R=this.filter(e[S],r,!1,n);o[S]=R.raw,d.push(...R.restricted)}else{const R=r[S],b=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&d.push(S),(b===void 0||n.scopes===void 0||n.scopes.includes(b))&&(n.skipRestricted&&R?.restricted||(o[S]=e[S]))}return{raw:o,restricted:d}}}t.ConfigurationModelParser=h;class v extends C.Disposable{constructor(e,r,i,n){super();this.userSettingsResource=e,this.scopes=r,this.fileService=n,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(P.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=v;class m{constructor(e,r,i=new E,n=new E,o=new T.ResourceMap,d=new E,S=new T.ResourceMap,R=!0){this._defaultConfiguration=e,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=n,this._folderConfigurations=o,this._memoryConfiguration=d,this._memoryConfigurationByResource=S,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(e,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(e)}updateValue(e,r,i={}){let n;i.resource?(n=this._memoryConfigurationByResource.get(i.resource),n||(n=new E,this._memoryConfigurationByResource.set(i.resource,n))):n=this._memoryConfiguration,r===void 0?n.removeValue(e):n.setValue(e,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,r,i){const n=this.getConsolidateConfigurationModel(r,i),o=this.getFolderConfigurationModelForResource(r.resource,i),d=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,S=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),R=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),b=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),O=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),M=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,G=o?r.overrideIdentifier?o.freeze().override(r.overrideIdentifier).getValue(e):o.freeze().getValue(e):void 0,ee=r.overrideIdentifier?d.override(r.overrideIdentifier).getValue(e):d.getValue(e),ce=n.getValue(e),le=L.distinct(L.flatten(n.overrides.map(re=>re.identifiers))).filter(re=>n.getOverrideValue(e,re)!==void 0);return{defaultValue:S,userValue:R,userLocalValue:b,userRemoteValue:O,workspaceValue:M,workspaceFolderValue:G,memoryValue:ee,value:ce,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,userLocal:b!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,workspace:M!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,workspaceFolder:G!==void 0?{value:o?.freeze().getValue(e),override:r.overrideIdentifier?o?.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,memory:ee!==void 0?{value:d.getValue(e),override:r.overrideIdentifier?d.getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:le.length?le:void 0}}keys(e){const r=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,r){this._folderConfigurations.set(e,r),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,r){const i=r.filter(n=>D.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const o=(0,D.overrideIdentifierFromKey)(n),d=this._defaultConfiguration.getKeysForOverrideIdentifier(o),S=e.getKeysForOverrideIdentifier(o),R=[...S.filter(b=>d.indexOf(b)===-1),...d.filter(b=>S.indexOf(b)===-1),...d.filter(b=>!w.equals(this._defaultConfiguration.override(o).getValue(b),e.override(o).getValue(b)))];return[o,R]});return this.updateDefaultConfiguration(e),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(e){const{added:r,updated:i,removed:n,overrides:o}=(0,p.compare)(this.localUserConfiguration,e),d=[...r,...i,...n];return d.length&&this.updateLocalUserConfiguration(e),{keys:d,overrides:o}}compareAndUpdateRemoteUserConfiguration(e){const{added:r,updated:i,removed:n,overrides:o}=(0,p.compare)(this.remoteUserConfiguration,e);let d=[...r,...i,...n];return d.length&&this.updateRemoteUserConfiguration(e),{keys:d,overrides:o}}compareAndUpdateWorkspaceConfiguration(e){const{added:r,updated:i,removed:n,overrides:o}=(0,p.compare)(this.workspaceConfiguration,e);let d=[...r,...i,...n];return d.length&&this.updateWorkspaceConfiguration(e),{keys:d,overrides:o}}compareAndUpdateFolderConfiguration(e,r){const i=this.folderConfigurations.get(e),{added:n,updated:o,removed:d,overrides:S}=(0,p.compare)(i,r);let R=[...n,...o,...d];return(R.length||!i)&&this.updateFolderConfiguration(e,r),{keys:R,overrides:S}}compareAndDeleteFolderConfiguration(e){const r=this.folderConfigurations.get(e);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:i,updated:n,removed:o,overrides:d}=(0,p.compare)(r,void 0);return{keys:[...i,...n,...o],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,r){let i=this.getConsolidatedConfigurationModelForResource(e,r);return e.overrideIdentifier?i.override(e.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:e},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&e){const n=r.getFolder(e);n&&(i=this.getFolderConsolidatedConfiguration(n.uri)||i);const o=this._memoryConfigurationByResource.get(e);o&&(i=i.merge(o))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let r=this._foldersConsolidatedConfigurations.get(e);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(e);n?(r=i.merge(n),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(e,r)):r=i}return r}getFolderConfigurationModelForResource(e,r){if(r&&e){const i=r.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,r)=>{const{contents:i,overrides:n,keys:o}=this._folderConfigurations.get(r);return e.push([r,{contents:i,overrides:n,keys:o}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>e.add(r)),this.userConfiguration.freeze().keys.forEach(r=>e.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>e.add(i))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(e).forEach(n=>r.add(n))),[...r.values()]}static parse(e){const r=this.parseConfigurationModel(e.defaults),i=this.parseConfigurationModel(e.user),n=this.parseConfigurationModel(e.workspace),o=e.folders.reduce((d,S)=>(d.set(g.URI.revive(S[0]),this.parseConfigurationModel(S[1])),d),new T.ResourceMap);return new m(r,i,new E,n,o,new E,new T.ResourceMap,!1)}static parseConfigurationModel(e){return new E(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=m;function y(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const e=new Set,r=new Map;for(const n of a)n.keys.forEach(o=>e.add(o)),n.overrides.forEach(([o,d])=>{const S=(0,T.getOrSet)(r,o,new Set);d.forEach(R=>S.add(R))});const i=[];return r.forEach((n,o)=>i.push([o,[...n.values()]])),{keys:[...e.values()],overrides:i}}t.mergeChanges=y;class u{constructor(e,r,i,n){this.change=e,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;e.keys.forEach(S=>o.add(S)),e.overrides.forEach(([,S])=>S.forEach(R=>o.add(R))),this.affectedKeys=[...o.values()];const d=new E;this.affectedKeys.forEach(S=>d.setValue(S,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(e,r,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(e,r,this.currentWorkspace);return!w.equals(i,n)}return!0}return!1}doesAffectedKeysTreeContains(e,r){let i=(0,p.toValuesTree)({[r]:!0},()=>{}),n;for(;typeof i=="object"&&(n=Object.keys(i)[0]);){if(e=e[n],!e)return!1;i=i[n]}return!0}}t.ConfigurationChangeEvent=u;class s extends u{constructor(e,r,i,n){super({keys:e.allKeys(),overrides:[]},void 0,e,r);this.source=i,this.sourceConfig=n}}t.AllKeysConfigurationChangeEvent=s}),define(J[107],Y([0,1,3,10,2,19,26,106,33,25]),function(z,t,L,P,I,C,T,w,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class p extends I.Disposable{constructor(f,E){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new w.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,E)),this.configuration=new w.Configuration(new w.DefaultConfigurationModel,new w.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(l=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new w.Configuration(new w.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,E){const l=typeof f=="string"?f:void 0,h=(0,T.isConfigurationOverrides)(f)?f:(0,T.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(l,h,void 0)}updateValue(f,E,l,h){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const E=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(l,E,1)}onDidDefaultConfigurationChange(f){const E=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new w.DefaultConfigurationModel,f);this.trigger(l,E,6)}trigger(f,E,l){const h=new w.ConfigurationChangeEvent(f,{data:E},this.configuration);h.source=l,h.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=p}),define(J[108],Y([0,1,9]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVirtualWorkspace=t.getVirtualWorkspaceScheme=t.getVirtualWorkspaceLocation=t.isVirtualResource=t.getRemoteName=t.getRemoteAuthority=void 0;function P(g){return g.scheme===L.Schemas.vscodeRemote?g.authority:void 0}t.getRemoteAuthority=P;function I(g){if(!g)return;const p=g.indexOf("+");return p<0?g:g.substr(0,p)}t.getRemoteName=I;function C(g){return g.scheme!==L.Schemas.file&&g.scheme!==L.Schemas.vscodeRemote}t.isVirtualResource=C;function T(g){if(g.folders.length)return g.folders.every(p=>C(p.uri))?g.folders[0].uri:void 0;if(g.configuration&&C(g.configuration))return g.configuration}t.getVirtualWorkspaceLocation=T;function w(g){return T(g)?.scheme}t.getVirtualWorkspaceScheme=w;function c(g){return T(g)!==void 0}t.isVirtualWorkspace=c}),define(J[42],Y([0,1,27,14,108]),function(z,t,L,P,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.checkProposedApiEnabled=t.isProposedApiEnabled=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}t.getWorkspaceSupportTypeMessage=C;function T(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}t.isIExtensionIdentifier=T,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(w=t.ExtensionType||(t.ExtensionType={}));class c{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,v){if(typeof h=="undefined"||h===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof h=="string"||typeof v=="string"){let m=typeof h=="string"?h:h.value,y=typeof v=="string"?v:v.value;return L.equalsIgnoreCase(m,y)}return h._lower===v._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}t.ExtensionIdentifier=c;function g(l){return Boolean(l.enableProposedApi)}t.isProposedApiEnabled=g;function p(l){if(!g(l))throw new Error(`[${l.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`)}t.checkProposedApiEnabled=p;function D(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}t.isLanguagePackExtension=D;function f(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=f;function E(l,h){if(h&&g(l)){const v=`onResolveRemoteAuthority:${(0,I.getRemoteName)(h)}`;return l.activationEvents?.indexOf(v)!==-1}return!1}t.isResolverExtension=E,t.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[23],Y([0,1,27,42]),function(z,t,L,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function I(l,h){return l.uuid&&h.uuid?l.uuid===h.uuid:l.id===h.id?!0:(0,L.compareIgnoreCase)(l.id,h.id)===0}t.areSameExtensions=I;class C{constructor(h,v){this.version=v,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof C?I(this,h)&&this.version===h.version:!1}}t.ExtensionIdentifierWithVersion=C;function T(l,h){return`${l}.${h}`}t.getExtensionId=T;function w(l){return l.toLocaleLowerCase()}t.adoptToGalleryExtensionId=w;function c(l,h){return w(T(l,h))}t.getGalleryExtensionId=c;function g(l,h){const v=[],m=y=>{for(const u of v)if(u.some(s=>I(h(s),h(y))))return u;return null};for(const y of l){const u=m(y);u?u.push(y):v.push([y])}return v}t.groupByExtension=g;function p(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=p;function D(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}t.getGalleryExtensionTelemetryData=D,t.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function f(l){const h=new Set;for(const v of l)v.malicious&&h.add(v.id.id);return h}t.getMaliciousExtensionsSet=f;function E(l,h){const v=[],m=h.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const y=m.shift();if(y&&v.every(u=>!I(u.identifier,{id:y}))){const u=l.filter(s=>I(s.identifier,{id:y}));u.length===1&&(v.push(u[0]),m.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}t.getExtensionDependencies=E}),define(J[109],Y([0,1,24,7,62,9,43,8,77,22,23,42]),function(z,t,L,P,I,C,T,w,c,g,p,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const f=y=>(0,c.localize)(0,null,y),E=(0,c.localize)(1,null,"ms-dotnettools.csharp");function l(y,u){return u?`${y.publisher}.${y.name}@${y.version}`:`${y.publisher}.${y.name}`}const h=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function v(y){const u=h.exec(y);return u&&u[1]?[(0,p.adoptToGalleryExtensionId)(u[1]),u[2]]:[(0,p.adoptToGalleryExtensionId)(y),void 0]}t.getIdAndVersion=v;let m=class{constructor(u,s){this.extensionManagementService=u,this.extensionGalleryService=s}get location(){}async listExtensions(u,s,a=console){let e=await this.extensionManagementService.getInstalled(1);const r=D.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(s&&s!==""){if(r.indexOf(s.toLowerCase())<0){a.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(n=>n.manifest.categories?n.manifest.categories.map(d=>d.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){a.log("Possible Categories: "),r.forEach(n=>{a.log(n)});return}this.location&&a.log((0,c.localize)(2,null,this.location)),e=e.sort((n,o)=>n.identifier.id.localeCompare(o.identifier.id));let i;for(let n of e)i!==n.identifier.id&&(i=n.identifier.id,a.log(l(n.manifest,u)))}async installExtensions(u,s,a,e,r=console){const i=[],n=[];u.length&&r.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const o=await this.extensionManagementService.getInstalled(1),d=(b,O)=>{const M=o.find(G=>(0,p.areSameExtensions)(G.identifier,{id:b}));if(M){if(!O&&!e)return r.log((0,c.localize)(5,null,b,M.manifest.version,b)),!1;if(O&&M.manifest.version===O)return r.log((0,c.localize)(6,null,`${b}@${O}`)),!1}return!0},S=[],R=[];for(const b of u)if(b instanceof w.URI)S.push(b);else{const[O,M]=v(b);d(O,M)&&R.push({id:O,version:M,installOptions:{isBuiltin:!1,isMachineScoped:a}})}for(const b of s){const[O,M]=v(b);d(O,M)&&R.push({id:O,version:M,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(S.length&&await Promise.all(S.map(async b=>{try{const O=await this.installVSIX(b,{isBuiltin:!1,isMachineScoped:a},e,r);O&&n.push(O)}catch(O){r.error(O.message||O.stack||O),i.push(b.toString())}})),R.length){const b=await this.getGalleryExtensions(R);await Promise.all(R.map(async O=>{const M=b.get(O.id.toLowerCase());if(M)try{const G=await this.installFromGallery(O,M,o,e,r);G&&n.push(G)}catch(G){r.error(G.message||G.stack||G),i.push(O.id)}else r.error(`${f(O.version?`${O.id}@${O.version}`:O.id)}
${E}`),i.push(O.id)}))}if(i.length)throw new Error((0,c.localize)(7,null,i.join(", ")))}async installVSIX(u,s,a,e){const r=await this.extensionManagementService.getManifest(u);if(!r)throw new Error("Invalid vsix");if(await this.validateVSIX(r,a,e))try{return await this.extensionManagementService.install(u,s),e.log((0,c.localize)(8,null,(0,I.getBaseLabel)(u))),r}catch(n){if((0,P.isPromiseCanceledError)(n))return e.log((0,c.localize)(9,null,(0,I.getBaseLabel)(u))),null;throw n}return null}async getGalleryExtensions(u){const s=new Map,a=await this.extensionGalleryService.getExtensions(u,L.CancellationToken.None);for(const e of a)s.set(e.identifier.id.toLowerCase(),e);return s}async installFromGallery({id:u,version:s,installOptions:a},e,r,i,n){const o=await this.extensionGalleryService.getManifest(e,L.CancellationToken.None);if(o&&!this.validateExtensionKind(o,n))return null;const d=r.find(S=>(0,p.areSameExtensions)(S.identifier,e.identifier));if(d){if(e.version===d.manifest.version)return n.log((0,c.localize)(10,null,s?`${u}@${s}`:u)),null;n.log((0,c.localize)(11,null,u,e.version))}try{return a.isBuiltin?n.log(s?(0,c.localize)(12,null,u,s):(0,c.localize)(13,null,u)):n.log(s?(0,c.localize)(14,null,u,s):(0,c.localize)(15,null,u)),await this.extensionManagementService.installFromGallery(e,{...a,installGivenVersion:!!s}),n.log((0,c.localize)(16,null,u,e.version)),o}catch(S){if((0,P.isPromiseCanceledError)(S))return n.log((0,c.localize)(17,null,u)),null;throw S}}validateExtensionKind(u,s){return!0}async validateVSIX(u,s,a){const e={id:(0,p.getGalleryExtensionId)(u.publisher,u.name)},i=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,p.areSameExtensions)(e,n.identifier)&&(0,T.gt)(n.manifest.version,u.version));return i&&!s?(a.log((0,c.localize)(18,null,i.identifier.id,i.manifest.version,u.version)),!1):this.validateExtensionKind(u,a)}async uninstallExtensions(u,s,a=console){const e=async i=>{if(i instanceof w.URI){const n=await this.extensionManagementService.getManifest(i);return l(n)}return i},r=[];for(const i of u){const n=await e(i),d=(await this.extensionManagementService.getInstalled()).filter(S=>(0,p.areSameExtensions)(S.identifier,{id:n}));if(!d.length)throw new Error(`${this.notInstalled(n)}
${E}`);if(d.some(S=>S.type===0)){a.log((0,c.localize)(19,null,n));return}if(!s&&d.some(S=>S.isBuiltin)){a.log((0,c.localize)(20,null,n));return}a.log((0,c.localize)(21,null,n));for(const S of d)await this.extensionManagementService.uninstall(S),r.push(S);this.location?a.log((0,c.localize)(22,null,n,this.location)):a.log((0,c.localize)(23,null,n))}}async locateExtension(u,s=console){const a=await this.extensionManagementService.getInstalled();u.forEach(e=>{a.forEach(r=>{if(r.identifier.id===e&&r.location.scheme===C.Schemas.file){s.log(r.location.fsPath);return}})})}notInstalled(u){return this.location?(0,c.localize)(24,null,u,this.location):(0,c.localize)(25,null,u)}};m=de([oe(0,g.IExtensionManagementService),oe(1,g.IExtensionGalleryService)],m),t.ExtensionManagementCLIService=m}),define(J[110],Y([0,1,3,7,2,12,19,43,8,31,13,21,22,23,16,15]),function(z,t,L,P,I,C,T,w,c,g,p,D,f,E,l,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends I.Disposable{constructor(u,s,a,e){super();this.fileService=s,this.extensionGalleryService=a,this.logService=e,this.extensionsDownloadDir=c.URI.file(u.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(u,s){await this.cleanUpPromise;const a=this.getName(u),e=(0,T.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(e)){const r=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,g.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(u,r,s);try{await this.rename(r,e,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(n){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",u.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,r.path),i}}return e}async delete(u){await this.cleanUpPromise,await this.fileService.del(u)}async rename(u,s,a){try{await p.Promises.rename(u.fsPath,s.fsPath)}catch(e){if(C.isWindows&&e&&e.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${u} to ${s} with 'EPERM' error. Trying again...`),this.rename(u,s,a);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const u=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(u.children){const s=[],a=[];for(const i of u.children){const n=this.parse(i.name);n&&a.push([n,i])}const e=(0,E.groupByExtension)(a,([i])=>i),r=[];for(const i of e)i.sort((n,o)=>w.rcompare(n[0].version,o[0].version)),s.push(...i.slice(1).map(n=>n[1].resource)),r.push(i[0][1]);r.sort((i,n)=>i.mtime-n.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await L.Promises.settled(s.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(u){this.logService.error(u)}}getName(u){return this.cache?`${new E.ExtensionIdentifierWithVersion(u.identifier,u.version).key().toLowerCase()}${u.properties.targetPlatform!=="undefined"?`-${u.properties.targetPlatform}`:""}`:(0,g.generateUuid)()}parse(u){const s=v.exec(u);return s&&s[1]&&s[2]?new E.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};m=de([oe(0,D.INativeEnvironmentService),oe(1,l.IFileService),oe(2,f.IExtensionGalleryService),oe(3,h.ILogService)],m),t.ExtensionsDownloader=m}),define(J[111],Y([0,1,2,6,13,42]),function(z,t,L,P,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends L.Disposable{constructor(c,g){super();this.environmentService=c,this.extensionsManifestCache=(0,P.join)(this.environmentService.userDataPath,C.MANIFEST_CACHE_FOLDER,C.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(g.onDidUninstallExtension(p=>this.onDidUnInstallExtension(p)))}onDidInstallExtensions(c){c.some(g=>!!g.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){I.Promises.rm(this.extensionsManifestCache,I.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(J[112],Y([0,1,137,20,3,2,9,6,13,21,22,23,55,15]),function(z,t,L,P,I,C,T,w,c,g,p,D,f,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let l=class extends C.Disposable{constructor(m,y,u){super();this.extensionManagementService=m,this.logService=u,this.cache=this._register(new h(y,u)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),y=["en",...Object.keys(m)];return(0,P.distinct)(y)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const y=await this.cache.getLanguagePacks();Object.keys(y).some(u=>y[u]&&y[u].extensions.some(s=>(0,D.areSameExtensions)(s.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),u=await this.cache.update(y);return!(0,P.equals)(Object.keys(m),Object.keys(u))}};l=de([oe(0,p.IExtensionManagementService),oe(1,g.INativeEnvironmentService),oe(2,E.ILogService)],l),t.LocalizationsService=l;let h=class extends C.Disposable{constructor(m,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,w.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new I.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(y=>{Object.keys(y).forEach(u=>delete y[u]),this.createLanguagePacksFromExtensions(y,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...y){for(const u of y)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,u);Object.keys(m).forEach(u=>this.updateHash(m[u]))}createLanguagePacksFromExtension(m,y){const u=y.identifier,s=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const a of s)if(y.location.scheme===T.Schemas.file&&(0,f.isValidLocalization)(a)){let e=m[a.languageId];e||(e={hash:"",extensions:[],translations:{}},m[a.languageId]=e);let r=e.extensions.filter(i=>(0,D.areSameExtensions)(i.extensionIdentifier,u))[0];r?r.version=y.manifest.version:e.extensions.push({extensionIdentifier:u,version:y.manifest.version});for(const i of a.translations)e.translations[i.id]=(0,w.join)(y.location.fsPath,i.path)}}updateHash(m){if(m){const y=(0,L.createHash)("md5");for(const u of m.extensions)y.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);m.hash=y.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch(s){return{}}}).then(u=>(y=m(u),u)).then(u=>{for(const a of Object.keys(u))u[a]||delete u[a];this.languagePacks=u,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),c.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>y,u=>this.logService.error(u))})}};h=de([oe(0,g.INativeEnvironmentService),oe(1,E.ILogService)],h)}),define(J[44],Y([0,1,17,85,33,14,25]),function(z,t,L,P,I,C,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,C.createDecorator)("requestService");function w(l){return l.res.statusCode&&l.res.statusCode>=200&&l.res.statusCode<300||l.res.statusCode===1223}t.isSuccess=w;function c(l){return l.res.statusCode===204}async function g(l){if(!w(l))throw new Error("Server returned "+l.res.statusCode);return c(l)?null:(await(0,L.streamToBuffer)(l.stream)).toString()}t.asText=g;async function p(l){if(!w(l))throw new Error("Server returned "+l.res.statusCode);if(c(l))return null;const v=(await(0,L.streamToBuffer)(l.stream)).toString();try{return JSON.parse(v)}catch(m){throw m.message+=`:
`+v,m}}t.asJson=p;function D(l){E(l)}t.updateProxyConfigurationsScope=D;let f;function E(l){const h=T.Registry.as(I.Extensions.Configuration),v=f;f={id:"http",order:15,title:(0,P.localize)(0,null),type:"object",scope:l,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(4,null),(0,P.localize)(5,null),(0,P.localize)(6,null),(0,P.localize)(7,null)],default:"override",description:(0,P.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[f],remove:v?[v]:[]})}E(2)}),define(J[113],Y([0,1,24,9,16,44]),function(z,t,L,P,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let T=class{constructor(c,g){this.requestService=c,this.fileService=g}async download(c,g,p=L.CancellationToken.None){if(c.scheme===P.Schemas.file||c.scheme===P.Schemas.vscodeRemote){await this.fileService.copy(c,g);return}const D={type:"GET",url:c.toString()},f=await this.requestService.request(D,p);if(f.res.statusCode===200)await this.fileService.writeFile(g,f.stream);else{const E=await(0,C.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${E}`)}}};T=de([oe(0,C.IRequestService),oe(1,I.IFileService)],T),t.DownloadService=T}),define(J[114],Y([0,1,115,11]),function(z,t,L,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function I(T,w){return T.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:T.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function C(T,w,c={}){const g=(0,L.parse)(T),p=c.proxyUrl||I(g,w);if(!p)return null;const D=(0,L.parse)(p);if(!/^https?:$/.test(D.protocol||""))return null;const f={host:D.hostname||"",port:D.port||(D.protocol==="https"?"443":"80"),auth:D.auth,rejectUnauthorized:(0,P.isBoolean)(c.strictSSL)?c.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((E,l)=>{z(["http-proxy-agent"],E,l)}))(f):new(await new Promise((E,l)=>{z(["https-proxy-agent"],E,l)}))(f)}t.getProxyAgent=C}),define(J[116],Y([0,1,17,31]),function(z,t,L,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function I(C,T,w){let c=w&&w.get("storage.serviceMachineId",0)||null;if(c)return c;try{const p=(await T.readFile(C.serviceMachineIdResource)).value.toString();c=(0,P.isUUID)(p)?p:null}catch(g){c=null}if(!c){c=(0,P.generateUuid)();try{await T.writeFile(C.serviceMachineIdResource,L.VSBuffer.fromString(c))}catch(g){}}return w&&w.store("storage.serviceMachineId",c,0,1),c}t.getServiceMachineId=I}),define(J[117],Y([0,1,3,10,2,102,11,66,14]),function(z,t,L,P,I,C,T,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const g="__$__targetStorageMarker";t.IStorageService=(0,c.createDecorator)("storageService");var p;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(p=t.WillSaveStateReason||(t.WillSaveStateReason={}));var D;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(D=t.StorageScope||(t.StorageScope={}));var f;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(f=t.StorageTarget||(t.StorageTarget={}));class E extends I.Disposable{constructor(m={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new P.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new P.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new P.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new I.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,I.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,y){y===g?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:y,target:this.getKeyTargets(m)[y]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,y,u){return this.getStorage(y)?.get(m,u)}getBoolean(m,y,u){return this.getStorage(y)?.getBoolean(m,u)}getNumber(m,y,u){return this.getStorage(y)?.getNumber(m,u)}store(m,y,u,s){if((0,T.isUndefinedOrNull)(y)){this.remove(m,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,u,s),this.getStorage(u)?.set(m,y)})}remove(m,y){this.withPausedEmitters(()=>{this.updateKeyTarget(m,y,void 0),this.getStorage(y)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,y){const u=[],s=this.getKeyTargets(m);for(const a of Object.keys(s))s[a]===y&&u.push(a);return u}updateKeyTarget(m,y,u){const s=this.getKeyTargets(y);typeof u=="number"?s[m]!==u&&(s[m]=u,this.getStorage(y)?.set(g,JSON.stringify(s))):typeof s[m]=="number"&&(delete s[m],this.getStorage(y)?.set(g,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const y=this.get(g,m);if(y)try{return JSON.parse(y)}catch(u){}return Object.create(null)}isNew(m){return this.getBoolean(t.IS_NEW_KEY,m)===!0}async flush(m=p.NONE){this._onWillSaveState.fire({reason:m});const y=this.getStorage(0),u=this.getStorage(1);switch(m){case p.NONE:await L.Promises.settled([y?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await L.Promises.settled([y?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return h(m,y,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class l extends E{constructor(){super();this.globalStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}t.InMemoryStorageService=l;async function h(v,m,y,u){const s=d=>{try{return JSON.parse(d)}catch(S){return d}},a=new Map,e=new Map;v.forEach((d,S)=>{a.set(S,d),e.set(S,s(d))});const r=new Map,i=new Map;m.forEach((d,S)=>{r.set(S,d),i.set(S,s(d))}),console.group(`Storage: Global (path: ${y})`);let n=[];a.forEach((d,S)=>{n.push({key:S,value:d})}),console.table(n),console.groupEnd(),console.log(e),console.group(`Storage: Workspace (path: ${u})`);let o=[];r.forEach((d,S)=>{o.push({key:S,value:d})}),console.table(o),console.groupEnd(),console.log(i)}t.logStorage=h}),define(J[118],Y([0,1,12,29,8,31]),function(z,t,L,P,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function T(g){if(L.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function w(g,p,D,f,E,l,h,v,m,y){const u=Object.create(null);u["common.machineId"]=h,u.sessionID=(0,C.generateUuid)()+Date.now(),u.commitHash=E,u.version=l,u["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,L.PlatformToString)(L.platform),u["common.nodePlatform"]=P.platform,u["common.nodeArch"]=f,u["common.product"]=y||"desktop";const s=c(v||[]);s&&(u["common.msftInternal"]=s);let a=0;const e=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),L.isLinuxSnap&&(u["common.snap"]="true");const r=T(D);r&&(u["common.platformDetail"]=r);try{const i=await g.readFile(I.URI.file(m));u["common.source"]=i.value.toString().slice(0,30)}catch(i){}return u}t.resolveCommonProperties=w;function c(g){const p=P.env.USERDNSDOMAIN;if(!p)return!1;const D=p.toLowerCase();return g.some(f=>D===f)}t.verifyMicrosoftInternalDomain=c}),define(J[30],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,L.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var P;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(P=t.TelemetryLevel||(t.TelemetryLevel={}));var I;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(I=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(J[119],Y([0,1,20,3,24,7,10,2,12,8,75,22,23,15,32,30]),function(z,t,L,P,I,C,T,w,c,g,p,D,f,E,l,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let v=class extends w.Disposable{constructor(e,r,i,n){super();this.galleryService=e,this.telemetryService=r,this.logService=i,this.productService=n,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,w.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(e){const r=await this.getTargetPlatform();return e.allTargetPlatforms.some(i=>(0,D.isTargetPlatformCompatible)(i,e.allTargetPlatforms,r))}async installFromGallery(e,r={}){try{return await this.doInstallFromGallery(e,r)}catch(i){throw this.logService.error("Failed to install extension.",e.identifier.id),this.logService.error(i),y(i)}}async uninstall(e,r={}){return this.logService.trace("ExtensionManagementService#uninstall",e.identifier.id),this.unininstallExtension(e,r)}async reinstallFromGallery(e){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",e.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(0,null));const r=await this.findGalleryExtension(e);if(!r)throw new Error(p.localize(1,null));await this.createUninstallExtensionTask(e,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(r)}getExtensionsReport(){const e=new Date().getTime();return(!this.reportedExtensions||e-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=e),this.reportedExtensions}registerParticipant(e){this.participants.push(e)}async doInstallFromGallery(e,r={}){if(!this.galleryService.isEnabled())throw new D.ExtensionManagementError(p.localize(2,null),D.ExtensionManagementErrorCode.Internal);if(!await this.canInstall(e)){const n=await this.getTargetPlatform(),o=new D.ExtensionManagementError(p.localize(3,null,e.identifier.id,this.productService.nameLong,(0,D.TargetPlatformToString)(n)),D.ExtensionManagementErrorCode.Incompatible);throw u(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(e),void 0,o),o}try{e=await this.checkAndGetCompatibleVersion(e,!r.installGivenVersion)}catch(n){throw u(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(e),void 0,n),n}const i=await this.galleryService.getManifest(e,I.CancellationToken.None);if(i===null){const n=new D.ExtensionManagementError(`Missing manifest for extension ${e.identifier.id}`,D.ExtensionManagementErrorCode.Invalid);throw u(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(e),void 0,n),n}if(i.version!==e.version){const n=new D.ExtensionManagementError(`Cannot install '${e.identifier.id}' extension because of version mismatch in Marketplace`,D.ExtensionManagementErrorCode.Invalid);throw u(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(e),void 0,n),n}return this.installExtension(i,e,r)}async installExtension(e,r,i){if(!g.URI.isUri(r)){let R=this.installingExtensions.get(new f.ExtensionIdentifierWithVersion(r.identifier,r.version).key());if(R)return this.logService.info("Extensions is already requested to install",r.identifier.id),R.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],o=[],d=this.createInstallExtensionTask(e,r,i);g.URI.isUri(r)||this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(d.identifier,e.version).key(),d),this._onInstallExtension.fire({identifier:d.identifier,source:r}),this.logService.info("Installing extension:",d.identifier.id),n.push({task:d,manifest:e});let S=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",d.identifier.id);else try{const b=await this.getAllDepsAndPackExtensionsToInstall(d.identifier,e,!!i.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:O,manifest:M}of b)if(S=S||!!M.extensionDependencies?.some(G=>(0,f.areSameExtensions)({id:G},d.identifier)),this.installingExtensions.has(new f.ExtensionIdentifierWithVersion(O.identifier,O.version).key()))this.logService.info("Extension is already requested to install",O.identifier.id);else{const G=this.createInstallExtensionTask(M,O,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(G.identifier,M.version).key(),G),this._onInstallExtension.fire({identifier:G.identifier,source:O}),this.logService.info("Installing extension:",G.identifier.id),n.push({task:G,manifest:M})}}catch(b){if(g.URI.isUri(d.source))(0,L.isNonEmptyArray)(e.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",d.identifier.id,b.message),(0,L.isNonEmptyArray)(e.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",d.identifier.id,b.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",d.identifier.id),b}const R=n.reduce((b,{task:O,manifest:M})=>(b.set(O.identifier.id.toLowerCase(),{task:O,manifest:M}),b),new Map);for(;R.size;){let b;const O=[...R.values()].filter(({manifest:M})=>!M.extensionDependencies?.some(G=>R.has(G.toLowerCase())));O.length?b=R.size===1?O:O.filter(({task:M})=>!(M===d&&!S)):(this.logService.info("Found extensions with circular dependencies",O.map(({task:M})=>M.identifier.id)),b=[...R.values()]),await this.joinAllSettled(b.map(async({task:M})=>{const G=new Date().getTime();try{const ee=await M.run();if(await this.joinAllSettled(this.participants.map(ce=>ce.postInstall(ee,M.source,i,I.CancellationToken.None))),!g.URI.isUri(M.source)&&(u(this.telemetryService,M.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(M.source),new Date().getTime()-G,void 0),c.isWeb&&M.operation===1))try{await this.galleryService.reportStatistic(ee.manifest.publisher,ee.manifest.name,ee.manifest.version,"install")}catch(ce){}o.push({local:ee,identifier:M.identifier,operation:M.operation,source:M.source})}catch(ee){throw g.URI.isUri(M.source)||u(this.telemetryService,M.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(M.source),new Date().getTime()-G,ee),this.logService.error("Error while installing the extension:",M.identifier.id),ee}finally{R.delete(M.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:b})=>this.logService.info("Extension installed successfully:",b.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:b})=>(0,f.areSameExtensions)(b,d.identifier))[0].local}catch(R){if(n.forEach(({task:b})=>b.cancel()),o.length)try{const b=await Promise.allSettled(o.map(({local:O})=>this.createUninstallExtensionTask(O,{versionOnly:!0}).run()));for(let O=0;O<b.length;O++){const M=b[O],{identifier:G}=o[O];M.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",G.id):this.logService.warn("Rollback: Error while uninstalling extension",G.id,(0,C.getErrorMessage)(M.reason))}}catch(b){this.logService.warn("Error while rolling back extensions",(0,C.getErrorMessage)(b),o.map(({identifier:O})=>O.id))}throw this._onDidInstallExtensions.fire(n.map(({task:b})=>({identifier:b.identifier,operation:1,source:b.source}))),R}finally{for(const{task:R,manifest:b}of n)if(!g.URI.isUri(R.source)){const O=new f.ExtensionIdentifierWithVersion(R.identifier,b.version).key();this.installingExtensions.delete(O)||this.logService.warn("Installation task is not found in the cache",O)}}}async joinAllSettled(e){const r=[],i=[],n=await Promise.allSettled(e);for(const o of n)o.status==="fulfilled"?r.push(o.value):i.push(o.reason);if(i.length)throw m(i);return r}async getAllDepsAndPackExtensionsToInstall(e,r,i){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const o=[e,...n.map(R=>R.identifier)],d=[],S=async(R,b)=>{const O=b.extensionDependencies||[],M=[...O];if(b.extensionPack){const G=i?n.find(ee=>(0,f.areSameExtensions)(ee.identifier,R)):void 0;for(const ee of b.extensionPack)G&&G.manifest.extensionPack&&G.manifest.extensionPack.some(ce=>(0,f.areSameExtensions)({id:ce},{id:ee}))||M.every(ce=>!(0,f.areSameExtensions)({id:ce},{id:ee}))&&M.push(ee)}if(M.length){const G=[...o,...d.map(ce=>ce.gallery.identifier)],ee=M.filter(ce=>G.every(le=>!(0,f.areSameExtensions)(le,{id:ce})));if(ee.length){const ce=await this.galleryService.query({names:ee,pageSize:M.length},I.CancellationToken.None);for(const le of ce.firstPage){if(G.find(q=>(0,f.areSameExtensions)(q,le.identifier)))continue;if(!O.some(q=>(0,f.areSameExtensions)({id:q},le.identifier))&&!await this.canInstall(le)){this.logService.info("Skipping the packed extension as it cannot be installed",le.identifier.id);continue}const fe=await this.checkAndGetCompatibleVersion(le,!0),B=await this.galleryService.getManifest(fe,I.CancellationToken.None);if(B===null)throw new D.ExtensionManagementError(`Missing manifest for extension ${fe.identifier.id}`,D.ExtensionManagementErrorCode.Invalid);d.push({gallery:fe,manifest:B}),await S(fe.identifier,B)}}}};return await S(e,r),n=await this.getInstalled(),d.filter(R=>!n.some(b=>(0,f.areSameExtensions)(b.identifier,R.gallery.identifier)))}async checkAndGetCompatibleVersion(e,r){if(await this.isMalicious(e))throw new D.ExtensionManagementError(p.localize(4,null,e.identifier.id),D.ExtensionManagementErrorCode.Malicious);const i=await this.getCompatibleVersion(e,r);if(!i)throw new D.ExtensionManagementError(p.localize(5,null,e.identifier.id,this.productService.nameLong,this.productService.version),D.ExtensionManagementErrorCode.Incompatible);return i}async getCompatibleVersion(e,r){const i=await this.getTargetPlatform();let n=null;return await this.galleryService.isExtensionCompatible(e,i)&&(n=e),!n&&r&&(n=await this.galleryService.getCompatibleExtension(e,i)),n}async isMalicious(e){const r=await this.getExtensionsReport();return(0,f.getMaliciousExtensionsSet)(r).has(e.identifier.id)}async unininstallExtension(e,r){const i=this.uninstallingExtensions.get(e.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",e.identifier.id),i.waitUntilTaskIsFinished();const n=(R,b)=>{const O=this.createUninstallExtensionTask(R,b);return this.uninstallingExtensions.set(O.extension.identifier.id.toLowerCase(),O),this.logService.info("Uninstalling extension:",R.identifier.id),this._onUninstallExtension.fire(R.identifier),O},o=(R,b)=>{b?this.logService.error("Failed to uninstall extension:",R.identifier.id,b.message):this.logService.info("Successfully uninstalled extension:",R.identifier.id),u(this.telemetryService,"extensionGallery:uninstall",(0,f.getLocalExtensionTelemetryData)(R),void 0,b),this._onDidUninstallExtension.fire({identifier:R.identifier,error:b?.code})},d=[],S=[];try{d.push(n(e,{}));const R=await this.getInstalled(1);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",e.identifier.id);else{const b=this.getAllPackExtensionsToUninstall(e,R);for(const O of b)this.uninstallingExtensions.has(O.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):d.push(n(O,{}))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",e.identifier.id):this.checkForDependents(d.map(b=>b.extension),R,e),await this.joinAllSettled(d.map(async b=>{try{if(await b.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(b.extension,r,I.CancellationToken.None))),b.extension.identifier.uuid)try{await this.galleryService.reportStatistic(b.extension.manifest.publisher,b.extension.manifest.name,b.extension.manifest.version,"uninstall")}catch(O){}o(b.extension)}catch(O){const M=O instanceof D.ExtensionManagementError?O:new D.ExtensionManagementError((0,C.getErrorMessage)(O),D.ExtensionManagementErrorCode.Internal);throw o(b.extension,M),M}finally{S.push(b)}}))}catch(R){const b=R instanceof D.ExtensionManagementError?R:new D.ExtensionManagementError((0,C.getErrorMessage)(R),D.ExtensionManagementErrorCode.Internal);for(const O of d){try{O.cancel()}catch(M){}S.includes(O)||o(O.extension,b)}throw b}finally{for(const R of d)this.uninstallingExtensions.delete(R.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",R.extension.identifier.id)}}checkForDependents(e,r,i){for(const n of e){const o=this.getDependents(n,r);if(o.length){const d=o.filter(S=>!e.some(R=>(0,f.areSameExtensions)(R.identifier,S.identifier)));if(d.length)throw new Error(this.getDependentsErrorMessage(n,d,i))}}}getDependentsErrorMessage(e,r,i){return i===e?r.length===1?p.localize(6,null,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?p.localize(7,null,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):p.localize(8,null,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?p.localize(9,null,i.manifest.displayName||i.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?p.localize(10,null,i.manifest.displayName||i.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):p.localize(11,null,i.manifest.displayName||i.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(e,r,i=[]){if(i.indexOf(e)!==-1)return[];i.push(e);const n=e.manifest.extensionPack?e.manifest.extensionPack:[];if(n.length){const o=r.filter(S=>!S.isBuiltin&&n.some(R=>(0,f.areSameExtensions)({id:R},S.identifier))),d=[];for(const S of o)d.push(...this.getAllPackExtensionsToUninstall(S,r,i));return[...o,...d]}return[]}getDependents(e,r){return r.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(n=>(0,f.areSameExtensions)({id:n},e.identifier)))}async findGalleryExtension(e){if(e.identifier.uuid){const r=await this.findGalleryExtensionById(e.identifier.uuid);return r||this.findGalleryExtensionByName(e.identifier.id)}return this.findGalleryExtensionByName(e.identifier.id)}async findGalleryExtensionById(e){return(await this.galleryService.query({ids:[e],pageSize:1},I.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(e){return(await this.galleryService.query({names:[e],pageSize:1},I.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const e=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${e.length} reported extensions from service`),e}catch(e){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};v=de([oe(0,D.IExtensionGalleryService),oe(1,h.ITelemetryService),oe(2,E.ILogService),oe(3,l.IProductService)],v),t.AbstractExtensionManagementService=v;function m(a){const e=Array.isArray(a)?a:[a];return e.length===1?e[0]instanceof Error?e[0]:new Error(e[0]):e.reduce((r,i)=>new Error(`${r.message}${r.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=m;function y(a){if(a instanceof D.ExtensionManagementError)return a;const e=new D.ExtensionManagementError(a.message,D.ExtensionManagementErrorCode.Internal);return e.stack=a.stack,e}function u(a,e,r,i,n){const o=n?n instanceof D.ExtensionManagementError?n.code:D.ExtensionManagementErrorCode.Internal:void 0;a.publicLogError(e,{...r,success:!n,duration:i,errorcode:o})}t.reportTelemetry=u;class s{constructor(){this.barrier=new P.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(e=>this.doRun(e))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(e=>new Promise((r,i)=>{const n=e.onCancellationRequested(()=>{n.dispose(),i((0,C.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=s}),define(J[36],Y([0,1,18,11,26,30]),function(z,t,L,P,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,y){return Promise.resolve(void 0)}publicLog2(m,y){return this.publicLog(m,y)}publicLogError(m,y){return Promise.resolve(void 0)}publicLogError2(m,y){return this.publicLogError(m,y)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=T,t.NullTelemetryService=new T;class w{async publicLog(m,y,u){}async publicLogError(m,y,u){}}t.NullEndpointTelemetryService=w,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(v,m){return m.onDidChangeConfiguration(y=>{y.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,I.ConfigurationTargetToString)(y.source),configurationKeys:l(y.sourceConfig)})})}t.configurationTelemetry=c;function g(v,m){return!(m.disableTelemetry||!v.enableTelemetry)}t.supportsTelemetry=g;function p(v){const m=v.getValue(C.TELEMETRY_SETTING_ID),y=v.getValue("telemetry.enableCrashReporter");if(v.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||y===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=p;function D(v){const m=Object.create(null),y=Object.create(null),u=Object.create(null);E(v,u);for(let s in u){s=s.length>150?s.substr(s.length-149):s;const a=u[s];typeof a=="number"?y[s]=a:typeof a=="boolean"?y[s]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${a.length}`),m[s]=a.substring(0,8191)):typeof a!="undefined"&&a!==null&&(m[s]=a)}return{properties:m,measurements:y}}t.validateTelemetryData=D;function f(v){if(!v)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(u=>{v.indexOf(`${u}+`)===0&&(m=u)}),m}t.cleanRemoteAuthority=f;function E(v,m,y=0,u){if(!!v)for(let s of Object.getOwnPropertyNames(v)){const a=v[s],e=u?u+s:s;Array.isArray(a)?m[e]=(0,L.safeStringify)(a):a instanceof Date?m[e]=a.toISOString():(0,P.isObject)(a)?y<2?E(a,m,y+1,e+"."):m[e]=(0,L.safeStringify)(a):m[e]=a}}function l(v){if(!v)return[];const m=[];return h(m,"",v),m}function h(v,m,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(u=>h(v,m?`${m}.${u}`:u,y[u])):v.push(m)}}),define(J[120],Y([0,1,20,24,7,18,12,29,8,26,21,22,23,51,16,15,32,44,116,117,30,36]),function(z,t,L,P,I,C,T,w,c,g,p,D,f,E,l,h,v,m,y,u,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const e=T.isWeb?"web":(0,D.getTargetPlatform)(T.platform,w.arch);var r;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished"})(r||(r={}));function i(...N){return String(N.reduce((A,W)=>A|W,0))}var n;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},d={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},R={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class b{constructor(A=R){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,W=this.state.pageSize){return new b({...this.state,pageNumber:A,pageSize:W})}withFilter(A,...W){const x=[...this.state.criteria,...W.length?W.map(K=>({filterType:A,value:K})):[{filterType:A}]];return new b({...this.state,criteria:x})}withSortBy(A){return new b({...this.state,sortBy:A})}withSortOrder(A){return new b({...this.state,sortOrder:A})}withFlags(...A){return new b({...this.state,flags:A.reduce((W,x)=>W|x,0)})}withAssetTypes(...A){return new b({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:W,pageSize:x,sortBy:K,sortOrder:Q,flags:se,assetTypes:ie}=this.state;return{filters:[{criteria:A,pageNumber:W,pageSize:x,sortBy:K,sortOrder:Q}],assetTypes:ie,flags:se}}get searchText(){const A=this.state.criteria.filter(W=>W.filterType===n.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(N,A){const W=(N||[]).filter(x=>x.statisticName===A)[0];return W?W.value:0}function M(N){const A="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(x=>x.assetType.indexOf(A)===0).reduce((x,K)=>{const Q=le(N,K.assetType);return Q&&x.push([K.assetType.substring(A.length),Q]),x},[])}function G(N){if(N.properties){const A=N.properties.filter(K=>K.key===o.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),x=A.filter(K=>W.test(K.value))[0];return x?{uri:x.value,fallbackUri:x.value}:null}return le(N,o.Repository)}function ee(N){return{uri:`${N.fallbackAssetUri}/${o.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${o.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function ce(N){const A=le(N,o.Icon);if(A)return A;const W=D.DefaultIconPath;return{uri:W,fallbackUri:W}}function le(N,A){return N.files.filter(x=>x.assetType===A)[0]?{uri:`${N.assetUri}/${A}`,fallbackUri:`${N.fallbackAssetUri}/${A}`}:null}function re(N,A){const W=N.properties?N.properties.filter(K=>K.key===A):[],x=W.length>0&&W[0].value;return x?x.split(",").map(K=>(0,f.adoptToGalleryExtensionId)(K)):[]}function fe(N){const A=N.properties?N.properties.filter(W=>W.key===d.Engine):[];return A.length>0&&A[0].value||""}function B(N){const A=N.properties?N.properties.filter(x=>x.key===d.LocalizedLanguages):[],W=A.length>0&&A[0].value||"";return W?W.split(","):[]}function q(N){return N.indexOf("preview")!==-1}function ne(N){return N.targetPlatform?(0,D.toTargetPlatform)(N.targetPlatform):"undefined"}function U(N){const A=(0,L.distinct)(N.versions.map(ne)),W=!!N.tags?.includes(D.WEB_EXTENSION_TAG),x=A.indexOf("web");return W?x===-1&&A.push("web"):x!==-1&&A.splice(x,1),A}function k(N,A){const W=(0,D.getFallbackTargetPlarforms)(A);for(let x=0;x<N.length;x++){const K=N[x];if(K.version===N[x-1]?.version){let Q=x;const se=ne(K);if(se===A)for(;Q>0&&N[Q-1].version===K.version;)Q--;else if(W.includes(se))for(;Q>0&&N[Q-1].version===K.version&&ne(N[Q-1])!==A;)Q--;Q!==x&&(N.splice(x,1),N.splice(Q,0,K))}}return N}t.sortExtensionVersions=k;function j(N,A,W,x,K){const Q=U(N);let se=N.versions[0];return se=N.versions.find(ie=>ie.version===se.version&&(0,D.isTargetPlatformCompatible)(ne(ie),Q,K))||se,H(N,se,Q,A,W,x)}function H(N,A,W,x,K,Q){const se={manifest:le(A,o.Manifest),readme:le(A,o.Details),changelog:le(A,o.Changelog),license:le(A,o.License),repository:G(A),download:ee(A),icon:ce(A),coreTranslations:M(A)};return{identifier:{id:(0,f.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:A.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,description:N.shortDescription||"",installCount:O(N.statistics,"install"),rating:O(N.statistics,"averagerating"),ratingCount:O(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:W,assets:se,properties:{dependencies:re(A,d.Dependency),extensionPack:re(A,d.ExtensionPack),engine:fe(A),localizedLanguages:B(A),targetPlatform:ne(A)},preview:q(N.flags),telemetryData:{index:(K.pageNumber-1)*K.pageSize+x,querySource:Q}}}let te=class{constructor(A,W,x,K,Q,se,ie,me){this.requestService=W,this.logService=x,this.environmentService=K,this.telemetryService=Q,this.fileService=se,this.productService=ie,this.configurationService=me;const ye=ie.extensionsGallery;this.extensionsGalleryUrl=ye&&ye.serviceUrl,this.extensionsControlUrl=ye&&ye.controlUrl,this.commonHeadersPromise=_(ie.version,ie,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,W){const x=[];let K=new b().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,A.length).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExtensionName,...A.map(({id:se})=>se.toLowerCase()));A.every(se=>!se.version)&&(K=K.withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties,r.IncludeLatestVersionOnly));const{galleryExtensions:Q}=await this.queryGallery(K,e,P.CancellationToken.None);for(let se=0;se<Q.length;se++){const ie=Q[se];if(!ie.versions.length)continue;const me=(0,f.getGalleryExtensionId)(ie.publisher.publisherName,ie.extensionName),ye=A.find(ue=>(0,f.areSameExtensions)(ue,{id:me}))?.version;if(ye){const ue=ie.versions.find(Ie=>Ie.version===ye);ue&&x.push(H(ie,ue,U(ie),se,K))}else x.push(j(ie,se,K,void 0,e))}return x}async getCompatibleExtension(A,W){const x=(0,D.isIExtensionIdentifier)(A)?null:A;if(x){if((0,D.isNotWebExtensionInWebTargetPlatform)(x.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(x,W))return x}const{id:K,uuid:Q}=x?x.identifier:A;let se=new b().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");Q?se=se.withFilter(n.ExtensionId,Q):se=se.withFilter(n.ExtensionName,K);const{galleryExtensions:ie}=await this.queryGallery(se,W,P.CancellationToken.None),[me]=ie;if(!me||!me.versions.length)return null;const ye=U(me);if((0,D.isNotWebExtensionInWebTargetPlatform)(ye,W))return null;for(let ue of me.versions){if(!fe(ue)){const Ie=await this.getEngine(ue);ue={...ue,properties:[...ue.properties||[],{key:d.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(ue,ye,W))return H(me,ue,ye,0,se)}return null}async isExtensionCompatible(A,W){if(!(0,D.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,W))return!1;let x=A.properties.engine;if(!x){const K=await this.getManifest(A,P.CancellationToken.None);if(!K)throw new Error("Manifest was not found");x=K.engines.vscode}return(0,E.isEngineValid)(x,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,W,x){if(!(0,D.isTargetPlatformCompatible)(ne(A),W,x))return!1;const K=await this.getEngine(A);return(0,E.isEngineValid)(K,this.productService.version,this.productService.date)}async query(A,W){const x=P.CancellationToken.isCancellationToken(A)?{}:A,K=P.CancellationToken.isCancellationToken(A)?A:W;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Q=x.text||"";const se=(0,C.getOrDefault)(x,ve=>ve.pageSize,50);let ie=new b().withFlags(r.IncludeLatestVersionOnly,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,se).withFilter(n.Target,"Microsoft.VisualStudio.Code");Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,Ee,Fe)=>(ie=ie.withFilter(n.Category,Fe||Ee),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,Ee,Fe)=>(ie=ie.withFilter(n.Tag,Fe||Ee),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(n.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),ie=ie.withFilter(n.SearchText,Q)),ie=ie.withSortBy(0)):x.ids?ie=ie.withFilter(n.ExtensionId,...x.ids):x.names?ie=ie.withFilter(n.ExtensionName,...x.names):ie=ie.withSortBy(4),typeof x.sortBy=="number"&&(ie=ie.withSortBy(x.sortBy)),typeof x.sortOrder=="number"&&(ie=ie.withSortOrder(x.sortOrder));const{galleryExtensions:me,total:ye}=await this.queryGallery(ie,e,K),ue=me.map((ve,Ee)=>j(ve,Ee,ie,x.source,e)),Ie=async(ve,Ee)=>{if(Ee.isCancellationRequested)throw(0,I.canceled)();const Fe=ie.withPage(ve+1),{galleryExtensions:Me}=await this.queryGallery(Fe,e,Ee);return Me.map((ze,xe)=>j(ze,xe,Fe,x.source,e))};return{firstPage:ue,total:ye,pageSize:ie.pageSize,getPage:Ie}}async queryGallery(A,W,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,r.ExcludeNonValidated).withFilter(n.ExcludeWithFlags,i(r.Unpublished));const K=await this.commonHeadersPromise,Q=JSON.stringify(A.raw),se={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},ie=new Date().getTime();let me,ye,ue=0;try{if(me=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Q,headers:se},x),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:ue};const Ie=await(0,m.asJson)(me);if(Ie){const ve=Ie.results[0],Ee=ve.extensions;Ee.forEach(Me=>k(Me.versions,W));const Fe=ve.resultMetadata&&ve.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return ue=Fe&&Fe.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:ue}}return{galleryExtensions:[],total:ue}}catch(Ie){throw ye=Ie,Ie}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-ie,success:!!me&&(0,m.isSuccess)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ye?(0,I.isPromiseCanceledError)(ye)?"canceled":(0,I.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(A,W,x,K){if(!this.isEnabled())return;const Q=T.isWeb?this.api(`/itemName/${A}.${W}/version/${x}/statType/${K==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${W}/${x}/stats?statType=${K}`),se=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:Q,headers:me},P.CancellationToken.None)}catch(ye){}}async download(A,W,x){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const K=(0,f.getGalleryExtensionTelemetryData)(A),Q=new Date().getTime(),se=ue=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...K,duration:ue}),ie=x===1?"install":x===2?"update":"",me=ie?{uri:`${A.assets.download.uri}${c.URI.parse(A.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${A.assets.download.fallbackUri}${c.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:A.assets.download,ye=await this.getAsset(me);await this.fileService.writeFile(W,ye.stream),se(new Date().getTime()-Q)}async getReadme(A,W){if(A.assets.readme){const x=await this.getAsset(A.assets.readme,{},W);return await(0,m.asText)(x)||""}return""}async getManifest(A,W){if(A.assets.manifest){const x=await this.getAsset(A.assets.manifest,{},W),K=await(0,m.asText)(x);return K?JSON.parse(K):null}return null}async getManifestFromRawExtensionVersion(A,W){const x=le(A,o.Manifest);if(!x)throw new Error("Manifest was not found");const K={"Accept-Encoding":"gzip"},Q=await this.getAsset(x,{headers:K});return await(0,m.asJson)(Q)}async getCoreTranslation(A,W){const x=A.assets.coreTranslations.filter(K=>K[0]===W.toUpperCase())[0];if(x){const K=await this.getAsset(x[1]),Q=await(0,m.asText)(K);return Q?JSON.parse(Q):null}return null}async getChangelog(A,W){if(A.assets.changelog){const x=await this.getAsset(A.assets.changelog,{},W);return await(0,m.asText)(x)||""}return""}async getAllCompatibleVersions(A,W){let x=new b().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?x=x.withFilter(n.ExtensionId,A.identifier.uuid):x=x.withFilter(n.ExtensionName,A.identifier.id);const{galleryExtensions:K}=await this.queryGallery(x,W,P.CancellationToken.None);if(!K.length)return[];const Q=U(K[0]);if((0,D.isNotWebExtensionInWebTargetPlatform)(Q,W))return[];const se=[];for(const ie of K[0].versions)try{se[se.length-1]?.version!==ie.version&&await this.isRawExtensionVersionCompatible(ie,Q,W)&&se.push({version:ie.version,date:ie.lastUpdated})}catch(me){}return se}async getAsset(A,W={},x=P.CancellationToken.None){const K=await this.commonHeadersPromise,Q={type:"GET"},se={...K,...W.headers||{}};W={...W,...Q,headers:se};const ie=A.uri,me=A.fallbackUri,ye={...W,url:ie};try{const ue=await this.requestService.request(ye,x);if(ue.res.statusCode===200)return ue;const Ie=await(0,m.asText)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${Ie}`)}catch(ue){if((0,I.isPromiseCanceledError)(ue))throw ue;const Ie=(0,I.getErrorMessage)(ue);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:Ie});const ve={...W,url:me};return this.requestService.request(ve,x)}}async getEngine(A){let W=fe(A);if(!W){const x=await this.getManifestFromRawExtensionVersion(A,P.CancellationToken.None);if(!x)throw new Error("Manifest was not found");W=x.engines.vscode}return W}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},P.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,m.asJson)(A),x=new Map;if(W)for(const K of W.malicious){const Q=x.get(K)||{id:{id:K},malicious:!0,slow:!1};Q.malicious=!0,x.set(K,Q)}return[...x.values()]}};te=de([oe(1,m.IRequestService),oe(2,h.ILogService),oe(3,p.IEnvironmentService),oe(4,s.ITelemetryService),oe(5,l.IFileService),oe(6,v.IProductService),oe(7,g.IConfigurationService)],te);let X=class extends te{constructor(A,W,x,K,Q,se,ie,me){super(A,W,x,K,Q,se,ie,me)}};X=de([oe(0,u.IStorageService),oe(1,m.IRequestService),oe(2,h.ILogService),oe(3,p.IEnvironmentService),oe(4,s.ITelemetryService),oe(5,l.IFileService),oe(6,v.IProductService),oe(7,g.IConfigurationService)],X),t.ExtensionGalleryService=X;let Z=class extends te{constructor(A,W,x,K,Q,se,ie){super(void 0,A,W,x,K,Q,se,ie)}};Z=de([oe(0,m.IRequestService),oe(1,h.ILogService),oe(2,p.IEnvironmentService),oe(3,s.ITelemetryService),oe(4,l.IFileService),oe(5,v.IProductService),oe(6,g.IConfigurationService)],Z),t.ExtensionGalleryServiceWithNoStorageService=Z;async function _(N,A,W,x,K,Q){const se={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N}`},ie=await(0,y.getServiceMachineId)(W,K,Q);return(0,a.supportsTelemetry)(A,W)&&(0,a.getTelemetryLevel)(x)===3&&(se["X-Market-User-Id"]=ie),se}t.resolveMarketplaceHeaders=_}),define(J[121],Y([0,1,2,18,12,27,86,26,33,122,25,30,36]),function(z,t,L,P,I,C,T,w,c,g,p,D,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let E=class{constructor(v,m){this._configurationService=m,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(y),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(y=>{const u=/^[a-f0-9]+$/i.test(y["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!u})})}setExperimentProperty(v,m){this._experimentProperties[v]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let m=v.sessionID,y=v["common.instanceId"],u=v["common.machineId"],s=v["common.firstSessionDate"],a=v["common.msftInternal"];return{sessionId:m,instanceId:y,machineId:u,firstSessionDate:s,msftInternal:a}}dispose(){this._disposables.dispose()}_log(v,m,y,u){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(s=>{y=(0,P.mixin)(y,s),y=(0,P.mixin)(y,this._experimentProperties),y=(0,P.cloneAndChange)(y,a=>{if(typeof a=="string")return this._cleanupInfo(a,u)}),this._appenders.forEach(a=>a.log(v,y))},s=>{console.error(s)})}publicLog(v,m,y){return this._log(v,3,m,y)}publicLog2(v,m,y){return this.publicLog(v,m,y)}publicLogError(v,m){return this.sendErrorTelemetry?this._log(v,2,m,!0):Promise.resolve(void 0)}publicLogError2(v,m){return this.publicLogError(v,m)}_anonymizeFilePaths(v){let m=v;const y=[];for(let e of this._cleanupPatterns)for(;;){const r=e.exec(v);if(!r)break;y.push([r.index,e.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(m="";;){const e=s.exec(v);if(!e)break;!u.test(e[0])&&y.every(([r,i])=>e.index<r||e.index>=i)&&(m+=v.substring(a,e.index)+"<REDACTED: user-file-path>",a=s.lastIndex)}return a<v.length&&(m+=v.substr(a)),m}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const m=v.toLowerCase(),y=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(m)?"<REDACTED: secret>":y.test(m)?"<REDACTED: email>":v}_cleanupInfo(v,m){let y=v;m&&(y=this._anonymizeFilePaths(y));for(let u of this._cleanupPatterns)y=y.replace(u,"");return y=this._removePropertiesWithPossibleUserInfo(y),y}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=de([oe(1,w.IConfigurationService)],E),t.TelemetryService=E;function l(){const h=(0,T.localize)(0,null,g.default.nameLong),v=g.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=I.isWeb?"":(0,T.localize)(3,null),y=(0,T.localize)(4,null),u=(0,T.localize)(5,null),s=(0,T.localize)(6,null),a=(0,T.localize)(7,null),e=`
|       | ${y} | ${u} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,T.localize)(8,null);return`
${h} ${v} ${m}

&nbsp;

${a}
${e}

&nbsp;

${r}
`}p.Registry.as(c.Extensions.Configuration).registerConfiguration({id:D.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[D.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:l(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(c.Extensions.Configuration).registerConfiguration({id:D.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[D.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,T.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,T.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${D.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[123],Y([0,1,7,18,36]),function(z,t,L,P,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function C(w,c){const g=await new Promise((D,f)=>{z(["applicationinsights"],D,f)});let p;return g.defaultClient?(p=new g.TelemetryClient(w),p.channel.setUseDiskRetryCaching(!0)):(g.setup(w).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),p=g.defaultClient),w.indexOf("AIF-")===0&&(p.config.endpointUrl=c?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),p}class T{constructor(c,g,p,D,f){this._eventPrefix=c,this._defaultData=g,this.testCollector=D,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof p=="function"?this._aiClient=p():this._aiClient=p,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=C(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(g=>{c(g)},g=>{(0,L.onUnexpectedError)(g),console.error(g)})}}log(c,g){!this._aiClient||(g=(0,P.mixin)(g,this._defaultData),g=(0,I.validateTelemetryData)(g),this.testCollector&&(g.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(p=>p.trackEvent({name:this._eventPrefix+"/"+c,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=T}),define(J[124],Y([0,1,6,13]),function(z,t,L,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function I(C,T){const w=Object.create(null),c=(p,D)=>{const f=JSON.parse(p);w[D]=f};if(T){const p=[],D=await P.Promises.readdir(T);for(const E of D)try{(await P.Promises.stat((0,L.join)(T,E))).isDirectory()&&p.push(E)}catch{}const f=[];for(const E of p)(await P.Promises.readdir((0,L.join)(T,E))).filter(h=>h==="telemetry.json").length===1&&f.push(E);for(const E of f){const l=(await P.Promises.readFile((0,L.join)(T,E,"telemetry.json"))).toString();c(l,E)}}let g=(await P.Promises.readFile((0,L.join)(C,"telemetry-core.json"))).toString();return c(g,"vscode-core"),g=(await P.Promises.readFile((0,L.join)(C,"telemetry-extensions.json"))).toString(),c(g,"vscode-extensions"),JSON.stringify(w,null,4)}t.buildTelemetryMessage=I}),define(J[37],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(J[125],Y([0,1,10,2,8,21,23,16,15,37]),function(z,t,L,P,I,C,T,w,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let p=class extends P.Disposable{constructor(f,E,l,h,v){super();this.extensionsManagementService=f,this.logService=h,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(y=>{this.installedExtensions=y.map(u=>u.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(y=>this.onInstallExtension(y))),this._register(f.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(f.onDidUninstallExtension(y=>this.onDidUninstallExtension(y)));const m=I.URI.file(l.extensionsPath);this._register(E.watch(m)),this._register(L.Event.filter(E.onDidChangeFilesRaw,y=>y.changes.some(u=>this.doesChangeAffects(u,m)))(()=>this.onDidChange()))}doesChangeAffects(f,E){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),E)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(E,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const E of f)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(E=>!(0,T.areSameExtensions)(E,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,T.areSameExtensions)(E,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),E=f.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,T.areSameExtensions)(v,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),l=this.installedExtensions.filter(h=>this.installingExtensions.some(v=>(0,T.areSameExtensions)(v,h))?!1:f.every(v=>!(0,T.areSameExtensions)(v.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=f.map(h=>h.identifier),(E.length||l.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:l})}}};p=de([oe(1,w.IFileService),oe(2,C.INativeEnvironmentService),oe(3,c.ILogService),oe(4,g.IUriIdentityService)],p),t.ExtensionsWatcher=p}),define(J[126],Y([0,1,37,91,16,19,59,10,2]),function(z,t,L,P,I,C,T,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class g{constructor(f){this.uri=f,this.time=g._clock++}touch(){return this.time=g._clock++,this}}g._clock=0;let p=class{constructor(f){this._fileService=f,this._dispooables=new c.DisposableStore,this._limit=2**16;const E=new Map,l=h=>{let v=E.get(h.scheme);return v===void 0&&(v=f.hasProvider(h)&&!this._fileService.hasCapability(h,1024),E.set(h.scheme,v)),v};this._dispooables.add(w.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(h=>{E.delete(h.scheme)})),this.extUri=new C.ExtUri(l),this._canonicalUris=new T.SkipList((h,v)=>this.extUri.compare(h,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,C.normalizePath)(f));let E=this._canonicalUris.get(f);return E?E.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new g(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((l,h)=>l[1].touch<h[1].touch?1:l[1].touch>h[1].touch?-1:0);g._clock=0,this._canonicalUris.clear();const E=this._limit*.5;for(let l=0;l<E;l++)this._canonicalUris.set(f[l][0],f[l][1].touch())}};p=de([oe(0,I.IFileService)],p),t.UriIdentityService=p,(0,P.registerSingleton)(L.IUriIdentityService,p,!0)}),define(J[45],Y([0,1,48,3,6,11,13,72,138,139]),function(z,t,L,P,I,C,T,w,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class p extends Error{constructor(e,r){let i=r.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=e,this.cause=r}}t.ExtractError=p;function D(a){const e=a.externalFileAttributes>>16||33188;return[448,56,7].map(r=>e&r).reduce((r,i)=>r+i,e&61440)}function f(a){if(a instanceof p)return a;let e;return/end of central directory record signature not found/.test(a.message)&&(e="CorruptZip"),new p(e,a)}function E(a,e,r,i,n,o){const d=I.dirname(e),S=I.join(i,d);if(!S.startsWith(i))return Promise.reject(new Error(w.localize(0,null,e)));const R=I.join(i,e);let b;return o.onCancellationRequested(()=>{b&&b.destroy()}),Promise.resolve(T.Promises.mkdir(S,{recursive:!0})).then(()=>new Promise((O,M)=>{if(!o.isCancellationRequested)try{b=(0,L.createWriteStream)(R,{mode:r}),b.once("close",()=>O()),b.once("error",M),a.once("error",M),a.pipe(b)}catch(G){M(G)}}))}function l(a,e,r,i){let n=(0,P.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{n.cancel(),a.close()}),new Promise((d,S)=>{const R=new P.Sequencer,b=O=>{O.isCancellationRequested||(o++,a.readEntry())};a.once("error",S),a.once("close",()=>n.then(()=>{i.isCancellationRequested||a.entryCount===o?d():S(new p("Incomplete",new Error(w.localize(1,null,o,a.entryCount))))},S)),a.readEntry(),a.on("entry",O=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(O.fileName)){b(i);return}const M=O.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(M)){const ce=I.join(e,M);n=(0,P.createCancelablePromise)(le=>T.Promises.mkdir(ce,{recursive:!0}).then(()=>b(le)).then(void 0,S));return}const G=v(a,O),ee=D(O);n=(0,P.createCancelablePromise)(ce=>R.queue(()=>G.then(le=>E(le,M,ee,e,r,ce).then(()=>b(ce)))).then(null,S))})})}function h(a,e=!1){return new Promise((r,i)=>{(0,c.open)(a,e?{lazyEntries:!0}:void 0,(n,o)=>{n?i(f(n)):r((0,C.assertIsDefined)(o))})})}function v(a,e){return new Promise((r,i)=>{a.openReadStream(e,(n,o)=>{n?i(f(n)):r((0,C.assertIsDefined)(o))})})}function m(a,e){return new Promise((r,i)=>{const n=new g.ZipFile;e.forEach(d=>{d.contents?n.addBuffer(typeof d.contents=="string"?Buffer.from(d.contents,"utf8"):d.contents,d.path):d.localPath&&n.addFile(d.localPath,d.path)}),n.end();const o=(0,L.createWriteStream)(a);n.outputStream.pipe(o),n.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>r(a))})}t.zip=m;function y(a,e,r={},i){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=h(a,!0);return r.overwrite&&(o=o.then(d=>T.Promises.rm(e).then(()=>d))),o.then(d=>l(d,e,{sourcePathRegex:n},i))}t.extract=y;function u(a,e){return h(a).then(r=>new Promise((i,n)=>{r.on("entry",o=>{o.fileName===e&&v(r,o).then(d=>i(d),d=>n(d))}),r.once("close",()=>n(new Error(w.localize(2,null,e))))}))}function s(a,e){return u(a,e).then(r=>new Promise((i,n)=>{const o=[];r.once("error",n),r.on("data",d=>o.push(d)),r.on("end",()=>i(Buffer.concat(o)))}))}t.buffer=s}),define(J[127],Y([0,1,45,79]),function(z,t,L,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function I(C){return(0,L.buffer)(C,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(w){throw new Error((0,P.localize)(0,null))}})}t.getManifest=I}),define(J[128],Y([0,1,20,3,7,2,9,6,12,19,43,8,31,13,45,80,21,22,23,90,16,15,32]),function(z,t,L,P,I,C,T,w,c,g,p,D,f,E,l,h,v,m,y,u,s,a,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;let r=class extends C.Disposable{constructor(n,o,d,S,R){super();this.beforeRemovingExtension=n,this.fileService=o,this.logService=d,this.environmentService=S,this.productService=R,this._devSystemExtensionsPath=null,this.systemExtensionsPath=S.builtinExtensionsPath,this.extensionsPath=S.extensionsPath,this.uninstalledPath=w.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new P.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(n){const o=[];(n===null||n===0)&&o.push(this.scanSystemExtensions().then(null,d=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(d).message,m.ExtensionManagementErrorCode.Internal)))),(n===null||n===1)&&o.push(this.scanUserExtensions(!0).then(null,d=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(d).message,m.ExtensionManagementErrorCode.Internal))));try{const d=await Promise.all(o);return(0,L.flatten)(d)}catch(d){throw this.joinErrors(d)}}async scanUserExtensions(n){this.logService.trace("Started scanning user extensions");let[o,d]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return d=d.filter(S=>!o[new y.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()]),n&&(d=(0,y.groupByExtension)(d,R=>R.identifier).map(R=>R.sort((b,O)=>p.rcompare(b.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",d.length),d}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(n,o,d,S){const R=n.key(),b=w.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),O=w.join(this.extensionsPath,R);try{await E.Promises.rm(O)}catch(G){try{await E.Promises.rm(O)}catch(ee){}throw new m.ExtensionManagementError((0,h.localize)(0,null,O,n.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(n,o,b,S);let M=await this.scanExtension(D.URI.file(b),1);if(!M)throw new Error((0,h.localize)(1,null,b));await this.storeMetadata(M,{...d,installedTimestamp:Date.now()});try{await this.rename(n,b,O,Date.now()+2*60*1e3),this.logService.info("Renamed to",O)}catch(G){try{await E.Promises.rm(b)}catch(ee){}if(G.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",n.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(G)}. Deleted from extracted location`,b),G}try{M=await this.scanExtension(D.URI.file(O),1)}catch(G){}if(M)return M;throw new Error((0,h.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(n,o){return this.setMetadata(n,o),await this.storeMetadata(n,{...o,installedTimestamp:n.installedTimestamp}),n}async storeMetadata(n,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const d=w.join(n.location.fsPath,"package.json"),S=await E.Promises.readFile(d,"utf8"),{manifest:R}=await this.parseManifest(S);return R.__metadata=o,await E.Promises.writeFile(d,JSON.stringify(R,null,"	")),n}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...n){const o=n.map(d=>new y.ExtensionIdentifierWithVersion(d.identifier,d.manifest.version));await this.withUninstalledExtensions(d=>{o.forEach(S=>d[S.key()]=!0)})}async setInstalled(n){await this.withUninstalledExtensions(S=>delete S[n.key()]);const d=(await this.scanExtensions(1)).find(S=>new y.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).equals(n))||null;return d?(await this.storeMetadata(d,{installedTimestamp:Date.now()}),this.scanExtension(d.location,1)):null}async withUninstalledExtensions(n){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(S){if(S.code!=="ENOENT")throw S}let d={};if(o)try{d=JSON.parse(o)}catch(S){}return n&&(n(d),Object.keys(d).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(d)):await E.Promises.rm(this.uninstalledPath)),d})}async removeExtension(n,o){this.logService.trace(`Deleting ${o} extension from disk`,n.identifier.id,n.location.fsPath),await E.Promises.rm(n.location.fsPath),this.logService.info("Deleted from disk",n.identifier.id,n.location.fsPath)}async removeUninstalledExtension(n){await this.removeExtension(n,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new y.ExtensionIdentifierWithVersion(n.identifier,n.manifest.version).key()])}async extractAtLocation(n,o,d,S){this.logService.trace(`Started extracting the extension from ${o} to ${d}`);try{await E.Promises.rm(d)}catch(R){throw new m.ExtensionManagementError(this.joinErrors(R).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,l.extract)(o,d,{sourcePath:"extension",overwrite:!0},S),this.logService.info(`Extracted extension to ${d}:`,n.id)}catch(R){try{await E.Promises.rm(d)}catch(O){}let b=m.ExtensionManagementErrorCode.Extract;throw R instanceof l.ExtractError&&(R.type==="CorruptZip"?b=m.ExtensionManagementErrorCode.CorruptZip:R.type==="Incomplete"&&(b=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(R.message,b)}}async rename(n,o,d,S){try{await E.Promises.rename(o,d)}catch(R){if(c.isWindows&&R&&R.code==="EPERM"&&Date.now()<S)return this.logService.info(`Failed renaming ${o} to ${d} with 'EPERM' error. Trying again...`,n.id),this.rename(n,o,d,S);throw new m.ExtensionManagementError(R.message||(0,h.localize)(3,null,o,d),R.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const n=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return n;const o=this.scanDevSystemExtensions(),[d,S]=await Promise.all([n,o]);return[...d,...S]}async scanExtensionsInDir(n,o){const d=new P.Limiter(10),S=await this.fileService.resolve(D.URI.file(n));return S.children?(await Promise.all(S.children.filter(b=>b.isDirectory).map(b=>d.queue(async()=>o===1&&(0,g.basename)(b.resource).indexOf(".")===0?null:this.scanExtension(b.resource,o))))).filter(b=>b&&b.identifier):[]}async scanExtension(n,o){try{const d=await this.fileService.resolve(n);if(d.children){const{manifest:S,metadata:R}=await this.readManifest(n.fsPath),b=d.children.find(({name:ee})=>/^readme(\.txt|\.md|)$/i.test(ee))?.resource,O=d.children.find(({name:ee})=>/^changelog(\.txt|\.md|)$/i.test(ee))?.resource,M={id:(0,y.getGalleryExtensionId)(S.publisher,S.name)},G={type:o,identifier:M,manifest:S,location:n,readmeUrl:b,changelogUrl:O,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return R&&(this.setMetadata(G,R),G.installedTimestamp=R.installedTimestamp),G}}catch(d){o!==0&&this.logService.trace(d)}return null}async scanDefaultSystemExtensions(){const n=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",n.length),n}async scanDevSystemExtensions(){const n=this.getDevSystemExtensionsList();if(n.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(d=>n.some(S=>(0,y.areSameExtensions)(d.identifier,{id:S})))}else return[]}setMetadata(n,o){n.publisherDisplayName=o.publisherDisplayName||null,n.publisherId=o.publisherId||null,n.identifier.uuid=o.id,n.isMachineScoped=!!o.isMachineScoped,n.isBuiltin=n.type===0||!!o.isBuiltin}async removeUninstalledExtensions(){const n=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),d=new Set;for(const b of o)n[new y.ExtensionIdentifierWithVersion(b.identifier,b.manifest.version).key()]||d.add(b.identifier.id.toLowerCase());const S=(0,y.groupByExtension)(o,b=>b.identifier);await P.Promises.settled(S.map(async b=>{const O=b.sort((M,G)=>p.rcompare(M.manifest.version,G.manifest.version))[0];d.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const R=o.filter(b=>n[new y.ExtensionIdentifierWithVersion(b.identifier,b.manifest.version).key()]);await P.Promises.settled(R.map(b=>this.removeUninstalledExtension(b)))}async removeOutdatedExtensions(){const n=await this.scanAllUserExtensions(),o=[],d=(0,y.groupByExtension)(n,S=>S.identifier);o.push(...(0,L.flatten)(d.map(S=>S.sort((R,b)=>p.rcompare(R.manifest.version,b.manifest.version)).slice(1)))),await P.Promises.settled(o.map(S=>this.removeExtension(S,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(n=>n.name)}joinErrors(n){const o=Array.isArray(n)?n:[n];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((d,S)=>new Error(`${d.message}${d.message?",":""}${S instanceof Error?S.message:S}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=w.normalize(w.join(T.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(n){const o=[E.Promises.readFile(w.join(n,"package.json"),"utf8").then(b=>this.parseManifest(b)),E.Promises.readFile(w.join(n,"package.nls.json"),"utf8").then(void 0,b=>b.code!=="ENOENT"?Promise.reject(b):"{}").then(b=>JSON.parse(b))],[{manifest:d,metadata:S},R]=await Promise.all(o);return{manifest:(0,u.localizeManifest)(d,R),metadata:S}}parseManifest(n){return new Promise((o,d)=>{try{const S=JSON.parse(n),R=S.__metadata||null;o({manifest:S,metadata:R})}catch(S){d(new Error((0,h.localize)(4,null)))}})}};r=de([oe(1,s.IFileService),oe(2,a.ILogService),oe(3,v.INativeEnvironmentService),oe(4,e.IProductService)],r),t.ExtensionsScanner=r}),define(J[129],Y([0,1,28,7,9,6,12,29,19,43,8,31,13,45,78,52,21,119,22,23,110,98,127,111,128,125,51,16,14,15,32,30,37]),function(z,t,L,P,I,C,T,w,c,g,p,D,f,E,l,h,v,m,y,u,s,a,e,r,i,n,o,d,S,R,b,O,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;let G=class extends m.AbstractExtensionManagementService{constructor(B,q,ne,U,k,j,H,te,X){super(B,q,ne,te);this.environmentService=U,this.downloadService=k,this.fileService=H;const Z=this._register(j.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(j.createInstance(i.ExtensionsScanner,N=>Z.postUninstall(N))),this.manifestCache=this._register(new r.ExtensionsManifestCache(U,this)),this.extensionsDownloader=this._register(j.createInstance(s.ExtensionsDownloader));const _=this._register(new n.ExtensionsWatcher(this,H,U,ne,X));this._register(_.onDidChangeExtensionsByAnotherSource(({added:N,removed:A})=>{N.length&&this._onDidInstallExtensions.fire(N.map(W=>({identifier:W.identifier,operation:0,local:W}))),A.forEach(W=>this._onDidUninstallExtension.fire({identifier:W}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const B=await this.isAlpineLinux(),q=(0,y.getTargetPlatform)(B?"alpine":T.platform,w.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",q),q})()),this._targetPlatformPromise}async isAlpineLinux(){if(!T.isLinux)return!1;let B;try{B=(await this.fileService.readFile(p.URI.file("/etc/os-release"))).value.toString()}catch(q){try{B=(await this.fileService.readFile(p.URI.file("/usr/lib/os-release"))).value.toString()}catch(ne){this.logService.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(ne))}}return!!B&&(B.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(B){this.logService.trace("ExtensionManagementService#zip",B.identifier.id);const q=await this.collectFiles(B),ne=await(0,E.zip)((0,c.joinPath)(this.environmentService.tmpDir,(0,D.generateUuid)()).fsPath,q);return p.URI.file(ne)}async unzip(B){return this.logService.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const q=await this.downloadVsix(B),ne=C.resolve(q.fsPath);return(0,e.getManifest)(ne)}getInstalled(B=null){return this.extensionsScanner.scanExtensions(B)}async install(B,q={}){this.logService.trace("ExtensionManagementService#install",B.toString());const ne=await this.downloadVsix(B),U=await(0,e.getManifest)(C.resolve(ne.fsPath));if(U.engines&&U.engines.vscode&&!(0,o.isEngineValid)(U.engines.vscode,this.productService.version,this.productService.date))throw new Error(l.localize(0,null,(0,u.getGalleryExtensionId)(U.publisher,U.name),this.productService.version));return this.installExtension(U,ne,q)}async updateMetadata(B,q){return this.logService.trace("ExtensionManagementService#updateMetadata",B.identifier.id),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,{...B.manifest.__metadata||{},...q}),this.manifestCache.invalidate(),B}async updateExtensionScope(B,q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",B.identifier.id),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,{...B.manifest.__metadata||{},isMachineScoped:q}),this.manifestCache.invalidate(),B}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(B){if(B.scheme===I.Schemas.file)return B;const q=(0,c.joinPath)(this.environmentService.tmpDir,(0,D.generateUuid)());return await this.downloadService.download(B,q),q}createInstallExtensionTask(B,q,ne){return p.URI.isUri(q)?new le(B,q,ne,this.galleryService,this.extensionsScanner,this.logService):new ce(q,ne,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(B,q){return new re(B,q,this.extensionsScanner)}async collectFiles(B){const q=async U=>{let k=await f.Promises.readdir(U);k=k.map(te=>C.join(U,te));const j=await Promise.all(k.map(te=>f.Promises.stat(te)));let H=Promise.resolve([]);return j.forEach((te,X)=>{const Z=k[X];te.isFile()&&(H=H.then(_=>[..._,Z])),te.isDirectory()&&(H=H.then(_=>q(Z).then(N=>[..._,...N])))}),H};return(await q(B.location.fsPath)).map(U=>({path:`extension/${C.relative(B.location.fsPath,U)}`,localPath:U}))}};G=de([oe(0,y.IExtensionGalleryService),oe(1,O.ITelemetryService),oe(2,R.ILogService),oe(3,v.INativeEnvironmentService),oe(4,h.IDownloadService),oe(5,S.IInstantiationService),oe(6,d.IFileService),oe(7,b.IProductService),oe(8,M.IUriIdentityService)],G),t.ExtensionManagementService=G;class ee extends m.AbstractExtensionTask{constructor(B,q,ne,U){super();this.identifier=B,this.source=q,this.extensionsScanner=ne,this.logService=U,this._operation=1}get operation(){return this._operation}async installExtension(B,q){try{const ne=await this.unsetUninstalledAndGetLocal(B.identifierWithVersion);if(ne)return B.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ne,B.metadata):ne}catch(ne){throw T.isMacintosh?new y.ExtensionManagementError(l.localize(1,null),y.ExtensionManagementErrorCode.Internal):new y.ExtensionManagementError(l.localize(2,null),y.ExtensionManagementErrorCode.Internal)}return this.extract(B,q)}async unsetUninstalledAndGetLocal(B){if(!await this.isUninstalled(B))return null;this.logService.trace("Removing the extension from uninstalled list:",B.id);const ne=await this.extensionsScanner.setInstalled(B);return this.logService.info("Removed the extension from uninstalled list:",B.id),ne}async isUninstalled(B){return!!(await this.extensionsScanner.getUninstalledExtensions())[B.key()]}async extract({zipPath:B,identifierWithVersion:q,metadata:ne},U){let k=await this.extensionsScanner.extractUserExtension(q,B,ne,U);return this.logService.info("Extracting completed.",q.id),k}}class ce extends ee{constructor(B,q,ne,U,k){super(B.identifier,B,U,k);this.gallery=B,this.options=q,this.extensionsDownloader=ne}async doRun(B){const ne=(await this.extensionsScanner.scanExtensions(null)).find(k=>(0,u.areSameExtensions)(k.identifier,this.gallery.identifier));ne&&(this._operation=2);const U=await this.downloadInstallableExtension(this.gallery,this._operation);U.metadata.isMachineScoped=this.options.isMachineScoped||ne?.isMachineScoped,U.metadata.isBuiltin=this.options.isBuiltin||ne?.isBuiltin;try{const k=await this.installExtension(U,B);return ne&&g.neq(ne.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ne),k}catch(k){throw await this.deleteDownloadedVSIX(U.zipPath),k}}async deleteDownloadedVSIX(B){try{await this.extensionsDownloader.delete(p.URI.file(B))}catch(q){this.logService.warn("Error while deleting the downloaded vsix",B.toString(),(0,P.getErrorMessage)(q))}}async downloadInstallableExtension(B,q){const ne={id:B.identifier.uuid,publisherId:B.publisherId,publisherDisplayName:B.publisherDisplayName};let U;try{this.logService.trace("Started downloading extension:",B.identifier.id),U=(await this.extensionsDownloader.downloadExtension(B,q)).fsPath,this.logService.info("Downloaded extension:",B.identifier.id,U)}catch(k){throw new y.ExtensionManagementError((0,m.joinErrors)(k).message,y.ExtensionManagementErrorCode.Download)}try{const k=await(0,e.getManifest)(U);return{zipPath:U,identifierWithVersion:new u.ExtensionIdentifierWithVersion(B.identifier,k.version),metadata:ne}}catch(k){throw await this.deleteDownloadedVSIX(U),new y.ExtensionManagementError((0,m.joinErrors)(k).message,y.ExtensionManagementErrorCode.Invalid)}}}class le extends ee{constructor(B,q,ne,U,k,j){super({id:(0,u.getGalleryExtensionId)(B.publisher,B.name)},q,k,j);this.manifest=B,this.location=q,this.options=ne,this.galleryService=U}async doRun(B){const q=new u.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),U=(await this.extensionsScanner.scanExtensions(1)).find(j=>(0,u.areSameExtensions)(this.identifier,j.identifier)),k=await this.getMetadata(this.identifier.id,B);if(k.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,k.isBuiltin=this.options.isBuiltin||U?.isBuiltin,U)if(this._operation=2,q.equals(new u.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version)))try{await this.extensionsScanner.removeExtension(U,"existing")}catch(j){throw new Error(l.localize(3,null,this.manifest.displayName||this.manifest.name))}else g.gt(U.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(U);else{const j=await this.unsetUninstalledAndGetLocal(q);if(j)try{await this.extensionsScanner.removeExtension(j,"existing")}catch(H){throw new Error(l.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:C.resolve(this.location.fsPath),identifierWithVersion:q,metadata:k},B)}async getMetadata(B,q){try{const ne=(await this.galleryService.query({names:[B],pageSize:1},q)).firstPage[0];if(ne)return{id:ne.identifier.uuid,publisherDisplayName:ne.publisherDisplayName,publisherId:ne.publisherId}}catch(ne){}return{}}}class re extends m.AbstractExtensionTask{constructor(B,q,ne){super();this.extension=B,this.options=q,this.extensionsScanner=ne}async doRun(B){const q=[],ne=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const U=new u.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);q.push(...ne.filter(k=>U.equals(new u.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version))))}else q.push(...ne.filter(U=>(0,u.areSameExtensions)(U.identifier,this.extension.identifier)));if(!q.length)throw new Error(l.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...q),this.options.remove)for(const U of q)try{B.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(U)}catch(k){throw new Error(l.localize(6,null,(0,L.toErrorMessage)(k)))}}}}),define(J[130],Y([0,1,115,3,17,7,2,11,26,21,93,15,114,140]),function(z,t,L,P,I,C,T,w,c,g,p,D,f,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let l=class extends T.Disposable{constructor(v,m,y){super();this.environmentService=m,this.logService=y,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,m){this.logService.trace("RequestService#request",v.url);const{proxyUrl:y,strictSSL:u}=this;let s;try{s=await(0,p.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.logService.error("RequestService#request resolving shell environment failed",r)}const a={...process.env,...s},e=v.agent?v.agent:await(0,f.getProxyAgent)(v.url||"",a,{proxyUrl:y,strictSSL:u});return v.agent=e,v.strictSSL=u,this.authorization&&(v.headers={...v.headers||{},"Proxy-Authorization":this.authorization}),this._request(v,m)}async getNodeRequest(v){return((0,L.parse)(v.url).protocol==="https:"?await new Promise((u,s)=>{z(["https"],u,s)}):await new Promise((u,s)=>{z(["http"],u,s)})).request}_request(v,m){return P.Promises.withAsyncBody(async(y,u)=>{let s;const a=(0,L.parse)(v.url),e=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),r={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:(0,w.isBoolean)(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(r.auth=v.user+":"+v.password),s=e(r,i=>{const n=(0,w.isNumber)(v.followRedirects)?v.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...v,url:i.headers.location,followRedirects:n-1},m).then(y,u);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,E.createGunzip)())),y({res:i,stream:(0,I.streamToBufferReadableStream)(o)})}}),s.on("error",u),v.timeout&&s.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&s.write(v.data),s.end(),m.onCancellationRequested(()=>{s.abort(),u((0,C.canceled)())})})}async resolveProxy(v){}};l=de([oe(0,c.IConfigurationService),oe(1,g.INativeEnvironmentService),oe(2,D.ILogService)],l),t.RequestService=l}),define(J[141],Y([0,1,34,3,17,28,7,2,9,6,29,8,13,26,107,52,113,21,89,120,22,109,129,16,100,103,41,97,54,55,112,15,104,122,32,44,130,118,30,121,36,123,124,37,126]),function(z,t,L,P,I,C,T,w,c,g,p,D,f,E,l,h,v,m,y,u,s,a,e,r,i,n,o,d,S,R,b,O,M,G,ee,ce,le,re,fe,B,q,ne,U,k,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class H extends w.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,_]=await this.initServices();return Z.invokeFunction(async N=>{const A=N.get(O.ILogService),W=N.get(r.IFileService),x=N.get(m.INativeEnvironmentService),K=N.get(s.IExtensionManagementCLIService);A.info("CLI main",this.argv),this.registerErrorHandler(A),await this.doRun(x,K,W),await Promise.all(_.map(Q=>{(0,P.raceTimeout)(Q.flush(),1e3)}))})}async initServices(){const Z=new S.ServiceCollection,_={_serviceBrand:void 0,...G.default};Z.set(ee.IProductService,_);const N=new y.NativeEnvironmentService(this.argv,_);Z.set(m.INativeEnvironmentService,N),await Promise.all([N.appSettingsHome.fsPath,N.extensionsPath].map(me=>me?f.Promises.mkdir(me,{recursive:!0}):void 0));const A=(0,O.getLogLevel)(N),W=[];W.push(new M.SpdLogLogger("cli",(0,g.join)(N.logsPath,"cli.log"),!0,!1,A)),A===O.LogLevel.Trace&&W.push(new O.ConsoleLogger(A));const x=this._register(new O.MultiplexLogService(W));Z.set(O.ILogService,x);const K=this._register(new i.FileService(x));Z.set(r.IFileService,K);const Q=this._register(new n.DiskFileSystemProvider(x));K.registerProvider(c.Schemas.file,Q);const se=this._register(new l.ConfigurationService(N.settingsResource,K));Z.set(E.IConfigurationService,se),await se.initialize(),Z.set(k.IUriIdentityService,new j.UriIdentityService(K)),Z.set(ce.IRequestService,new o.SyncDescriptor(le.RequestService)),Z.set(h.IDownloadService,new o.SyncDescriptor(v.DownloadService)),Z.set(s.IExtensionManagementService,new o.SyncDescriptor(e.ExtensionManagementService)),Z.set(s.IExtensionGalleryService,new o.SyncDescriptor(u.ExtensionGalleryServiceWithNoStorageService)),Z.set(s.IExtensionManagementCLIService,new o.SyncDescriptor(a.ExtensionManagementCLIService)),Z.set(R.ILocalizationsService,new o.SyncDescriptor(b.LocalizationsService));const ie=[];if((0,q.supportsTelemetry)(_,N)){_.aiConfig&&_.aiConfig.asimovKey&&ie.push(new ne.AppInsightsAppender("monacoworkbench",null,_.aiConfig.asimovKey));const{appRoot:me,extensionsPath:ye,installSourcePath:ue}=N,Ie={appenders:ie,sendErrorTelemetry:!1,commonProperties:(async()=>{let ve;try{const Ee=await f.Promises.readFile((0,g.join)(N.userDataPath,"storage.json"));ve=JSON.parse(Ee.toString())[fe.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&x.error(Ee)}return(0,re.resolveCommonProperties)(K,(0,L.release)(),(0,L.hostname)(),process.arch,_.commit,_.version,ve,_.msftInternalDomains,ue)})(),piiPaths:[me,ye]};Z.set(fe.ITelemetryService,new o.SyncDescriptor(B.TelemetryService,[Ie]))}else Z.set(fe.ITelemetryService,q.NullTelemetryService);return[new d.InstantiationService(Z),ie]}registerErrorHandler(Z){(0,T.setUnexpectedErrorHandler)(_=>{const N=(0,C.toErrorMessage)(_,!0);!N||Z.error(`[uncaught exception in CLI]: ${N}`)}),process.on("uncaughtException",_=>(0,T.onUnexpectedError)(_)),process.on("unhandledRejection",_=>(0,T.onUnexpectedError)(_))}async doRun(Z,_,N){if(this.argv["install-source"])return this.setInstallSource(Z,N,this.argv["install-source"]);if(this.argv["list-extensions"])return _.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return _.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return _.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return _.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}asExtensionIdOrVSIX(Z){return Z.map(_=>/\.vsix$/i.test(_)?D.URI.file((0,g.isAbsolute)(_)?_:(0,g.join)((0,p.cwd)(),_)):_)}async setInstallSource(Z,_,N){await _.writeFile(D.URI.file(Z.installSourcePath),I.VSBuffer.fromString(N.slice(0,30)))}}async function te(X){const Z=new H(X);try{await Z.run()}finally{Z.dispose()}}t.main=te})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c1096372119bcf83b9bd8ccee96dcf266f35de76/core/vs/code/node/cliProcessMain.js.map
